<%@page import="java.util.List"%>
<%@page import="com.rigabyte.http.user.node.dashboard.DashboardUtil"%>
<%@page import="com.rigabyte.http.user.node.dashboard.client.DashboardManagerClient"%>
<%@page import="com.rigabyte.http.user.node.json.OrganizationJson"%>
<%@page import="com.rigabyte.data.user.client.UserManagerClient"%>
<%@page import="com.rigabyte.http.user.node.dashboard.json.AlertInfoHolder"%>
<%@page import="com.rigabyte.http.user.node.dashboard.json.DashboardChartDataJson"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib uri="http://jawr.net/tags" prefix="jwr" %>
<%@ taglib prefix="data" uri="dataTags"%>
<%

OrganizationJson currentOrganization=UserManagerClient.getCurrentOrganization(request,true);
String dashboardChartDataItemId=request.getParameter("itemId");
DashboardChartDataJson dashChartDataJson=DashboardManagerClient.getDashboardChartDataJson(dashboardChartDataItemId,currentOrganization.getId());
List<AlertInfoHolder> alertInfoHolders=DashboardUtil.getDashboardChartAlertInfo(dashChartDataJson);
String emails=DashboardUtil.getEmails(dashChartDataJson);
pageContext.setAttribute("emails",emails);
pageContext.setAttribute("postURL",DashboardUtil.getPostURL(dashChartDataJson));
pageContext.setAttribute("alertInfoHolders",alertInfoHolders);
pageContext.setAttribute("itemId",dashboardChartDataItemId);
pageContext.setAttribute("alertInfo",dashChartDataJson.getAlertInfo());



%>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<jsp:include page="../common/staticIncludes_css.jsp" />
<jwr:style src="/jawr/alerts.css"/>

<jsp:include page="../common/staticIncludes_js.jsp" />
<title>Dashboard Alerts</title>
<jsp:include page="/common/smoothPageLoad.jsp"/>

</head>
<body>
	<jsp:include page="/common/globalNavigation.jsp"/>
	
	<div id="container">
	<div class="seperation"><span id="alertImg"></span><span class="sepTitle">Dashboard Alerts</span></div>
	</div>


	<div id="alertsContactContainer">
		<div id="emailAlerts">
			<label class="alertFormLabel">Email alerts to:</label><input type="text" maxlength="240" id="emails" placeholder="Comma seperated list of emails." value="${emails}"/>
			<label class="alertFormLabel">Alert URL:</label><input type="text" maxlength="240" id="postUrl" placeholder="URL to which data will be sent ex:- http://host:8080/alert" value="${postURL}"/>
			<div id="alertInfo">
				<label class="alertFormLabel">Enabled:</label>
				<c:if test="${alertInfo.enabled==true}">
					<input type="checkbox" value="true" checked="checked" id="enabledBox"/>
				</c:if>
				<c:if test="${alertInfo.enabled==false}">
					<input type="checkbox" value="true" id="enabledBox"/>
				</c:if>
			</div>
		
			<button id="saveAlertContacts" >Save</button>
		</div>
		
	</div>

	<div id="chartDataDiv">
				<div id="chartDataDash" chart_error="true">
				<input type="hidden" name="type" value="CHART"/>
			</div>
	</div>	

	<c:forEach items="${alertInfoHolders}" var="infoHolder">
	<div class="chartInfoAlert" id="${infoHolder.chartDataJson.id}">
	<div class="chartInfo" style="background-color: ${infoHolder.chartDataJson.metaDataMap['resultDataColor']}">
	<div class="chartInfoVal selDebugChartInfoName">
		<c:if test="${empty infoHolder.chartDataJson.metaDataMap['chartInfoLabel']}">
			All Data
		</c:if>
		<c:if test="${not empty infoHolder.chartDataJson.metaDataMap['chartInfoLabel']}">
			${infoHolder.chartDataJson.metaDataMap['chartInfoLabel']}
		</c:if>

		
	</div>
	<%--
	<div class="chartInfoVal">
		Results:${chartInfoAlert.chartDataJson.metaDataMap['resultCount']}
	</div>
	 --%>
	<div class="chartInfoVal">
		Data:${infoHolder.chartDataJson.metaDataMap['indexName']}
	</div>
	<div class="chartInfoVal">
		Source:${infoHolder.chartDataJson.metaDataMap['dataSourceInfoName']}
	</div>
	<div class="chartInfoVal">
		Field:${infoHolder.chartDataJson.fieldDisplayName}
	</div>
	</div>
	<div class="alertInfo">
		<c:if test="${empty infoHolder.alert}">
			<button class="addAlert" style="color: ${infoHolder.chartDataJson.metaDataMap['resultDataColor']}">Add Alert</button>
		</c:if>
		<c:if test="${not empty infoHolder.alert}">
	
			<c:set var="seconds">
			<fmt:formatNumber type="number" maxFractionDigits="0" value="${infoHolder.alert.intervalInMillliseconds/1000}" />
			</c:set>
			<span class="alertMessage">
			<c:if test="${infoHolder.alert.comparsionType=='GREATER_THAN'}">
				${infoHolder.alert.alertName} - Alert if value greater than <span class="alertVal">${infoHolder.alert.comparisonValue}</span> for an interval of <span class="alertVal">${seconds}</span> seconds
			</c:if>
			<c:if test="${infoHolder.alert.comparsionType=='LESS_THAN'}">
				Alert if value less than <span class="alertVal">${infoHolder.alert.comparisonValue}</span> for an interval of <span class="alertVal">${seconds}</span> seconds
			</c:if>
			<div class="alertControls">
				<button class="editAlert" style="color: ${infoHolder.chartDataJson.metaDataMap['resultDataColor']}">Modify</button>
				<button class="deleteAlert"style="color: ${infoHolder.chartDataJson.metaDataMap['resultDataColor']}" >Delete</button>
			</div>
			</span>
		</c:if>
	</div>
	</div>
	
	
	</c:forEach>

	<div id="addEditDialog">
	</div>
<jwr:script src="/jawr/alerts.js"/>
</body>
</html>
