<%@page import="com.rigabyte.data.util.Configuration"%>
<%@page import="com.rigabyte.data.util.Constants"%>
<%@page import="com.rigabyte.data.util.IndexUtil"%>
<%@page import="com.rigabyte.http.user.node.json.UserJson"%>
<%@page import="com.rigabyte.http.user.node.dashboard.DashboardUtil"%>
<%@page import="com.rigabyte.http.SearchUserState"%>
<%@page import="com.rigabyte.data.user.client.UserManagerClient"%>
<%@page import="com.rigabyte.http.user.node.json.OrganizationJson"%>
<%@page import="com.rigabyte.http.user.node.dashboard.client.DashboardManagerClient"%>
<%@page import="java.util.List"%>
<%@page import="com.rigabyte.http.user.node.dashboard.json.DashboardJson"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%
String dashboardId=request.getParameter("id");
String hideDescription=request.getParameter("hideDescription");
if(hideDescription==null)
{
	hideDescription="false";
}
request.setAttribute("hideDescription",hideDescription);

Configuration configuration=Configuration.getInstance();

String authDashboardId=DashboardUtil.getdashboardIdFromAuth(request);

if(authDashboardId!=null)
{
	dashboardId=authDashboardId;
}

//If not dashboardId parameter is passed and no auth parameter is passed.
if(dashboardId==null)
{
	Boolean report=(Boolean)request.getAttribute("report");
	List<DashboardJson> dashboards=null;
	if(report!=null && report.equals(Boolean.TRUE))
	{
		String reportIdSession=(String)session.getAttribute(Constants.REPORT_ID_SESSION);
		
		
		SearchUserState searchUserState=IndexUtil.getSearchUserState(request);
		UserJson user=UserManagerClient.getCurrentUser(request,true);
		List<String> reportIds=user.getReportIdList();
		if(user!=null && !reportIds.isEmpty())
		{
			if(reportIdSession!=null && reportIds.contains(reportIdSession))
			{
				dashboardId=reportIdSession;
			}
			else
			{
				dashboardId=reportIds.get(0);	
			}
			
		}
	}
	else
	{
		String dashboardIdSession=(String)session.getAttribute(Constants.DASHBOARD_ID_SESSION);
		UserJson user=UserManagerClient.getCurrentUser(request,true);
		 List<String> dashboardIds=user.getDashboardIdList();
		if(!dashboardIds.isEmpty())
		{
			if(dashboardIdSession!=null && dashboardIds.contains(dashboardIdSession))
			{
				dashboardId=dashboardIdSession;
			}
			else
			{
				dashboardId=dashboardIds.get(0);	
			}
			
		}
	}
}



if(dashboardId!=null)
{

	Boolean report=(Boolean)request.getAttribute("report");
	if(report!=null && report.equals(Boolean.TRUE))
	{
		DashboardUtil.setDefaultReportIdInSession(dashboardId, request);
	}
	else
	{
		DashboardUtil.setDefaultDashboardIdInSession(dashboardId, request);	
	}
	
	
	DashboardJson dashboardJson=null;
	dashboardJson=DashboardManagerClient.getDashboardWithAuthCheck(dashboardId,request);
	
	if(dashboardJson!=null)
	{
		int numColumns=dashboardJson.getNumColumns();
		pageContext.setAttribute("displayLegend",new Boolean(dashboardJson.isDisplayLegend()));
		pageContext.setAttribute("numColumnsDashboard",new Integer(numColumns));
		int dashboardWidthPercent=DashboardManagerClient.getDashboardChartDataWidthPercentage(numColumns);
		pageContext.setAttribute("dashboardDataWidthPercent",new Integer(dashboardWidthPercent));
	}
	else
	{
		pageContext.setAttribute("numColumnsDashboard",new Integer(3));
		pageContext.setAttribute("displayLegend",new Boolean(true));
	}
	pageContext.setAttribute("dashboard",dashboardJson);
	if(dashboardJson!=null)
	{
		List chartDataList=DashboardManagerClient.getDashboardChartDataJson(dashboardJson,request);
		pageContext.setAttribute("chartDatas",chartDataList);
	}
}
%>


<script>
	var dashboardRefreshInterval=<%=configuration.getDashboardRefreshInterval()%>;
	var numColumnsDashboard=${numColumnsDashboard};
	var displayLegend=${displayLegend};
</script> 

<div id="dashboardBody">

<c:if test="${(empty dashboard || empty chartDatas)}">
						<c:if test="${report==true}"><div class="helpImage"><img src="/images/help/reports/reportsHelp.png"/></div></c:if>
					<c:if test="${report==false}"><div class="helpImage"><img src="/images/help/dashboard/dashboardHelp.png"/></div></c:if>
</c:if>
<c:if test="${not empty dashboard && not empty chartDatas}">

<c:forEach items="${chartDatas}" var="dashboardChartData">
	<c:if test="${dashboardChartData.type=='CHART'}">
		<div id="chartDataDiv_${dashboardChartData.id}" style="width:${dashboardDataWidthPercent-.3}%;">
	
			
			<div id="chartDataDash_${dashboardChartData.id}" chart_error="true">
				<input type="hidden" name="type" value="${dashboardChartData.type}"/>
			</div>
			
			<c:if test="${empty param.auth}">
				<div class="settingsIcon" id="settings_${dashboardChartData.id}"></div>
			</c:if>
			<div id="searches_${dashboardChartData.id}"></div>
			<c:if test="${not empty dashboardChartData.description}">
				<div class="dashChartDataDesc"><p><c:out value="${dashboardChartData.description}"/></p></div>
			</c:if>
		</div>
	</c:if>
	<c:if test="${dashboardChartData.type=='LOG_ENTRY'}">
		<div id="chartDataDiv_${dashboardChartData.id}" style="width:100%;clear:both;background-color:${dashboardChartData.resultDataUnitForPage.logEntryState.colorCode};" title="Log Entry">
	
	
				<div id="logDataDash_${dashboardChartData.id}">
					<input type="hidden" name="type" value="${dashboardChartData.type}"/>
					<span class="logDataMarker"></span>
					<div class="logDataData">
					
					<%--Setting escapeXML to true here seem to cause problems with highlighted search terms, <span> will show up on the page as text. --%>
					<c:if test="${dashboardChartData.resultDataUnitForPage.truncatedContent==true}">
						<c:out value="${dashboardChartData.resultDataUnitForPage.resultContent}" escapeXml="false"/>
					</c:if>
					<c:if test="${dashboardChartData.resultDataUnitForPage.truncatedContent==false}">
						<c:if test="${not empty  dashboardChartData.resultDataUnitForPage.resultContentFull}">
							<c:out value="${dashboardChartData.resultDataUnitForPage.resultContentFull}" escapeXml="false"/>
						</c:if>
						<c:if test="${not empty  dashboardChartData.resultDataUnitForPage.resultContentFull}">
							<c:out value="${dashboardChartData.resultDataUnitForPage.resultContentFull}" escapeXml="false"/>
						</c:if>
						<c:if test="${empty  dashboardChartData.resultDataUnitForPage.resultContentFull}">
							<c:out value="${dashboardChartData.resultDataUnitForPage.resultContent}" escapeXml="false"/>
						</c:if>
						
					</c:if>
					</div>
				</div>
			
			<c:if test="${empty param.auth}">
				<div class="settingsIcon" id="settings_${dashboardChartData.id}"></div>
			</c:if>
		</div>
	</c:if>

	<c:if test="${dashboardChartData.type=='DESCRIPTION' && hideDescription!='true'}">
		<div id="chartDataDiv_${dashboardChartData.id}" style="width:100%;clear:both;" title="Description">
				<div id="logDataDash_${dashboardChartData.id}">
					<input type="hidden" name="type" value="${dashboardChartData.type}"/>
					<div class="logDataDescription">
					<c:out value="${dashboardChartData.description}" escapeXml="false"/>
					</div>
				</div>
			
			<c:if test="${empty param.auth}">
				<div class="settingsIcon" id="settings_${dashboardChartData.id}"></div>
			</c:if>
		</div>
	</c:if>
</c:forEach>

</c:if>
<jsp:include page="/dashboard/dashboardChartDataMenu.jsp"></jsp:include>
</div>
