<%@page import="com.rigabyte.data.util.Configuration"%>
<%@page import="com.rigabyte.data.util.Constants"%>
<%@page import="com.rigabyte.http.user.node.json.SearchIndexJson"%>
<%@page import="com.rigabyte.http.user.node.json.OrganizationJson"%>
<%@page import="com.rigabyte.data.shard.client.SearchIndexInfo"%>
<%@page import="com.rigabyte.http.user.node.json.UserJson"%>
<%@page import="com.rigabyte.data.user.client.UserManagerClient"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Iterator"%>
<%@page import="com.rigabyte.data.shard.client.SearchEngineClientManager"%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib prefix="data" uri="dataTags"%>

<%
UserJson user=UserManagerClient.getCurrentUser(request,true);
pageContext.setAttribute("user", user);
Configuration configuration=Configuration.getInstance();
OrganizationJson organization=UserManagerClient.getCurrentOrganization(request,false);
List<SearchIndexJson> searchIndexList = organization.getSearchIndexList();
SearchIndexJson indexJson=null;
String indexId=request.getParameter("indexId");
for (Iterator iterator = searchIndexList.iterator(); iterator.hasNext();) {
	SearchIndexJson searchIndexJson2 = (SearchIndexJson) iterator.next();

	if(searchIndexJson2.getId().equals(indexId))
	{
	 indexJson=searchIndexJson2;
	 break;
	}
}
SearchIndexInfo indexInfo=SearchEngineClientManager.getInstance().getSearchIndexInfo(indexJson, organization);

pageContext.setAttribute("indexInfo",indexInfo);
pageContext.setAttribute("indexJson",indexJson);
String stateStr="Paused";
if(indexJson.getState()==Constants.DATA_COLLECTION_CONTINUE)
{
	stateStr="Active";
}
pageContext.setAttribute("indexState",stateStr);
%>


	<script type="text/javascript">
		var dataCollectionStateRefreshInterval =
	<%=configuration.getDataCollectionStateRefreshInterval()%>
	</script>
	
	<div id="dataCollectionDetails">
		
	<c:if test="${indexJson.defaultIndex==false && user.permissions.admin==true}">
		<button type="button" id="delete_data_collection" value="${indexInfo.id}">Delete</button>	
	</c:if>
	
		<table id="indexInfoTable">
			<tr class="indexInfo">
				<td class="dataCollectionProp">Name</td>
				<td>${indexJson.name}</td>
			</tr>
			<tr class="indexInfo">
				<td class="dataCollectionProp">Entries</td>
				<td>${indexInfo.numEntries}</td>
			</tr>
			<tr class="indexInfo">
				<td class="dataCollectionProp">Id</td>
				<td>${indexInfo.id}</td>
			</tr>
			<tr class="indexInfo">
				<td class="dataCollectionProp">DefaultIndex</td>
				<td>${indexJson.defaultIndex}</td>
			</tr>
			<tr class="indexInfo">
				<td class="dataCollectionProp">Namespace</td>
				<td>${indexInfo.indexNameSpace}/${indexInfo.name}</td>
			</tr>
			<tr class="indexInfo">
				<td class="dataCollectionProp">Status</td>
				<td>${indexState}</td>
			</tr>
	
		</table>
		
			<div id="fieldExtractions">Field Extractions <c:if test="${user.permissions.admin==true && indexJson.defaultIndex==false}"><button type="button"  id="add_field_extractions">Add New</button></c:if></div>
			<c:if test="${not empty indexJson.fieldInfos}">
				<table id="fieldInfoTable">
					<thead>
						<tr>
							<td>Field Name</td>
							<td>RegEx</td>
							<td></td>
							<c:if test="${indexJson.defaultIndex==false}"><td><span style="float: right">Delete<span></td></c:if>
						</tr>
					</thead>
					<c:forEach var="fieldItem" items="${indexJson.fieldInfos}">
						<tr class="shardInfo">
							<td>${fieldItem.fieldName}</td>
							<td>${fieldItem.fieldRegex}</td>
							<c:if test="${indexJson.defaultIndex==false}"><td><button type="button" class="editFieldInfo" id="${fieldItem.id}">Edit</button></td></c:if>
							<c:if test="${indexJson.defaultIndex==false}"><td><span class="deleteFieldInfo" id="${fieldItem.id}"/></td></c:if>
						</tr>
					</c:forEach>
				</table>		
			</c:if>
			
		<c:if test="${not empty indexJson.dataSourceInfoList}">
		<div id="dataSourceHeading">Data Sources</div>
		<table id="dataSourceTable">
			<thead>
			</thead>
			<c:forEach var="dataSourceItem" items="${indexJson.dataSourceInfoList}">
				<tr>
					<c:if test="${fn:length(dataSourceItem.name)>40}">
						<td class="dataSourceName">...${fn:substring(dataSourceItem.name,20,fn:length(dataSourceItem.name))}</td>
					</c:if>
					<c:if test="${fn:length(dataSourceItem.name)<40}">
						<td class="dataSourceName">${dataSourceItem.name}</td>
					</c:if>
				</tr>
			</c:forEach>
		</table>
		</c:if>
	
	
		<c:if test="${not empty indexInfo.shardInfos}">
		<div id="shardsHeading">Shards</div>
		<table id="shardsTable">
			<thead>
				<tr>
					<td>Shard Id</td>
					<td>Num Entries</td>
					<td>Start</td>
					<td>End</td>
					
					<c:if test="${param.override=='true'}">
						<td><span style="float: right"><c:if test="${user.permissions.admin==true}">Delete</c:if><span></td>
					</c:if>
				</tr>
			</thead>
			<c:forEach var="shardItem" items="${indexInfo.shardInfos}">
				<tr class="shardInfo">
					<td>${shardItem.id}</td>
					<td>${shardItem.entries}</td>
					<td>${shardItem.startNum}</td>
					<td>${shardItem.endNum}</td>
					<c:if test="${param.override=='true'}">
						<td><c:if test="${user.permissions.admin==true}"><span class="deleteShard" id="${shardItem.id}"/></c:if></td>
					</c:if>
				</tr>
			</c:forEach>
		</table>
		</c:if>
		
	</div>

