<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ taglib uri="http://jawr.net/tags" prefix="jwr"%>
<%@ taglib prefix="data" uri="dataTags"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<jsp:include page="/common/staticIncludes_css.jsp" />
<jsp:include page="/common/staticIncludes_js.jsp" />
<jwr:style src="/jawr/gettingStarted.css" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Getting Started Help Documents</title>


<jsp:include page="/common/smoothPageLoad.jsp" />
</head>
<body>
	<jsp:include page="/common/globalNavigation.jsp" />


	<div class="seperation">
		<span class="sepTitle">Getting Started</span>
	</div>
<span id="infoLogo"></span>

<a href="#riga2Min" class="helpMenu">Rigabyte in 2 Minutes</a>
<a href="https://www.youtube.com/channel/UC9aqoF9CQzSTCyQU3SbDWmw" class="helpMenu">All RigaByte Videos</a>
<a href="#installRigabyte" class="helpMenu">Installing Rigabyte</a>
<a href="#rigaAgent" class="helpMenu">Rigabyte Agent</a>
<a href="#searchMenu" class="helpMenu">Search Menu</a>
<a href="#queryRef" class="helpMenu">Search Examples</a>
<a href="#alertRef" class="helpMenu">Setting up alerts.</a>
<a href="#monitor" class="helpMenu">Monitoring files using Rsyslog and the RigaByte Agent.</a>
<a href="#appender" class="helpMenu">Using the RigaByte log4j Appender.</a>
<a href="#sendFiles" class="helpMenu">Easy way to send log files to RigaByte.</a>
<a href="#javaGCLogs" class="helpMenu">Analyzing Java Garbage Collection Logs</a>
<a href="#startPatternHelp" class="helpMenu">Help with Start Pattern</a>

<jsp:include page="/common/rigabyteEnterprise.jsp"></jsp:include>
	</div>
	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">RigaByte in 2 minutes.</span>
	</div>
	<a name="riga2Min"></a>
	<div class="helpContents">
	<iframe width="560" height="315" src="https://www.youtube.com/embed/8xu3wn8AL54" frameborder="0" allowfullscreen></iframe>
	</div>
	

	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Installing Rigabyte</span>
	</div>
	<a name="installRigabyte"></a>
	<img src="/images/help/rigabyteInstall1.png"/>			

	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">RigaByte Agent</span>
	</div>
	<a name="rigaAgent" />
	<div class="helpContents">
		<img src="/images/help/agent/rigabyteAgent.jpg" alt="" width="900px" />
		<p style="font-size: large;">The RigaByte agent provides a secure and efficient way to send data to RigaByte.The RigaByte agent must be used to send data to RigaByte cloud, the agent is optional for use with standalone RigaByte. 
			The agent buffers, encrypts and compresses data before sending it to RigaByte. Data can be fed to the rigabyte agent using a syslog client like rsyslog, using the Rigabyte Agent API, using the rigabyte log4j appender. The agent parses the
			data it recieves and sends it to rigabyte.com.</p>
		<ul>
			<li>
				startRelayAgent.sh is used to start the RigaByte agent.
			</li>
			<li>
				Configuration.datarelayAgent.properties, DataListenerConfiguration.datarelayAgent.properties are used to configure the Rigabyte Agent.
			</li>
		</ul>
	</div>
	
	
	
	
	<jsp:include page="/help/searchMenuHelp.jsp" />
	<jsp:include page="/help/searchQueryRef.jsp" />
<jsp:include page="/help/alertRef.jsp" />

	<a name="monitor"></a>
	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Monitoring files using Rsyslog and the RigaByte Agent.</span>
	</div>
	<div class="helpContents">
		<iframe width="560" height="315" src="https://www.youtube.com/embed/XXTF4ZIXvHY?vq=hd1080" frameborder="0"> </iframe>

		<p>Below are files referenced in the above video.</p>
		<h4>Rsyslog Configuration - /etc/rsyslog.d/00-riga.conf</h4>
		<div class="sampleCode">
			<pre>
		<code>
$ModLoad imfile
$InputFilePollInterval 3
$PrivDropToGroup adm
$WorkDirectory /var/spool/rsyslog

# Input for FILE1
$InputFileName /home/riga/logs/apache.log
$InputFileTag ProdApache1LogTag
$InputFileStateFile ProdApacheLogState001
$InputFileSeverity info
$InputFilePersistStateInterval 20000
$InputRunFileMonitor

# Add a tag for file events
#$template RigabyteTemplate,"%TIMESTAMP:::date-rfc3339% %msg%\n"
$template RigabyteTemplate,"%msg%\n"
#Send to Rigabyte Agent.
if $programname == 'ProdApache1LogTag' then @@192.168.0.11:10518;RigabyteTemplate
if $programname == 'ProdApache1LogTag' then ~


# Input for FILE1
$InputFileName /home/riga/logs/tomcat.log
$InputFileTag ProdTomcat1LogTag
$InputFileStateFile ProdTomcatLogState001
$InputFileSeverity info
$InputFilePersistStateInterval 20000
$InputRunFileMonitor

# Add a tag for file events
#$template RigabyteTomcatTemplate,"%TIMESTAMP:::date-rfc3339% %msg%\n"
$template RigabyteTomcatTemplate,"%msg%\n"
#Send to Rigabyte Agent.
if $programname == 'ProdTomcat1LogTag' then @@192.168.0.11:10520;RigabyteTomcatTemplate
if $programname == 'ProdTomcat1LogTag' then ~
		
		
		</code>
	</pre>
		</div>


		<h4>bin/DataListenerConfiguration.datarelay.properties</h4>
		<div class="sampleCode">
			<pre>
		<code>
dataListeners=tcpSampleLogApache,tcpSampleLogTomcat
#dataListeners=tcpSampleLogApache,udpSampleLog2,tcpSampleLog3

dataListener.tcpSampleLogApache.port=10515
dataListener.tcpSampleLogApache.dataCollectionName=Production Logs Apache
dataListener.tcpSampleLogApache.dataProcessorTask=com.rigabyte.data.hub.datalistener.DataReaderTaskTCP
dataListener.tcpSampleLogApache.parser=com.rigabyte.data.parser.StartDatePatternDataParser
dataListener.tcpSampleLogApache.startPattern=dd/MMM/yyyy:HH:mm:ss
dataListener.tcpSampleLogApache.batchSizeNumEntries=120
#Maximum characters accepted by the DataHub 6MB
dataListener.tcpSampleLogApache.batchSizeChars=6291456


dataListener.tcpSampleLogTomcat.port=10520
dataListener.tcpSampleLogTomcat.dataCollectionName=Production Logs Tomcat
dataListener.tcpSampleLogTomcat.dataProcessorTask=com.rigabyte.data.hub.datalistener.DataReaderTaskTCP
dataListener.tcpSampleLogTomcat.parser=com.rigabyte.data.parser.StartDatePatternDataParser
dataListener.tcpSampleLogTomcat.startPattern=yyyy-MM-dd'T'HH:mm:ss.SSS
dataListener.tcpSampleLogTomcat.batchSizeNumEntries=120
#Maximum characters accepted by the DataHub 6MB
dataListener.tcpSampleLogTomcat.batchSizeChars=6291456
		
		
		</code>
	</pre>
		</div>
	</div>

	<a name="appender"></a>

	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Using the RigaByte log4j Appender.</span>
	</div>
	<div class="helpContents">
		<iframe width="560" height="315" src="https://www.youtube.com/embed/zMvTn8Opj4g?vq=hd1080" frameborder="0"> </iframe>
		<p>
			<b>It is recommended that the RigaByte appender point to the RigaByte agent host and HTTP port instead of directly sending data to rigabyte.com</b>
		</p>
		<h4>Sample log4j.properties file used in the video.</h4>
		<div class="sampleCode">
			<pre>
		<code>
# Print messages up to level INFO
log4j.logger.net.jawr=INFO

# Set root logger level to DEBUG and its only appender to Appender1.
log4j.rootLogger=INFO,console,rigabyteAppender


# Appender1 is set to be a ConsoleAppender.
log4j.appender.rigabyteAppender=com.rigabyte.agent.log4j.RigabyteAppender

# Appender2 uses PatternLayout.
#Flag indicating if the data is to be gzipped or not.
log4j.appender.rigabyteAppender.gzip=false
#Data source name.
log4j.appender.rigabyteAppender.dataSourceName=TestHostInstance1
#Data collecton name.
log4j.appender.rigabyteAppender.dataCollectionName=Rigabyte Appender Test
#Hostname for the data hub.
log4j.appender.rigabyteAppender.host=datahub101.rigabyte.com
log4j.appender.rigabyteAppender.authToken=iIk15id4HCVnK9hdqeKzgXdppcv6xm1V4T4vnntPAp8=___1422946239856
#Port used by the data hub.
log4j.appender.rigabyteAppender.port=28080
#The batch size of the log batch that is sent to the hub, logs are grouped in batches.
log4j.appender.rigabyteAppender.batchSize=240
#Time in milliseconds after which what ever data is present in the batch is send as the next batch,
#even if less than the batchSize configured. 
log4j.appender.rigabyteAppender.batchIdleTime=4000

#Maximum number of lines in the stack trace.
log4j.appender.rigabyteAppender.maxStackTraceLines=20
log4j.appender.rigabyteAppender.test=false
log4j.appender.rigabyteAppender.layout=org.apache.log4j.PatternLayout
log4j.appender.rigabyteAppender.layout.ConversionPattern=%d{yyyy-MM-dd HH:mm:ss SSS} [%t] %-5p %c %x - %m%n

# Appender1 is set to be a ConsoleAppender.
log4j.appender.console=org.apache.log4j.ConsoleAppender

# Appender2 uses PatternLayout.
log4j.appender.console.layout=org.apache.log4j.PatternLayout
log4j.appender.console.layout.ConversionPattern=%d{yyyy-MM-dd HH:mm:ss SSS} [%t] %-5p %c %x - %m%n
		</code>
	</pre>
		</div>
	</div>

	<a name="sendFiles"></a>
	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Easy way to send log files to RigaByte.</span>
	</div>
	<div class="helpContents">
		<iframe width="560" height="315" src="https://www.youtube.com/embed/Qpe1_op-ctU?vq=hd1080" frameborder="0"> </iframe>

	</div>

	<a name="javaGCLogs"></a>
	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Analyzing Java Garbage Collection Logs</span>
	</div>
	<div class="helpContents">
		<iframe width="560" height="315" src="https://www.youtube.com/embed/lgwOIoiZaUs?vq=hd1080" frameborder="0"> </iframe>
		<p style="font-size: large;; width: 80%; color: gray;">Use the following search to extract details from Java Garbage Collection logs, the below search returns extracted
			fields.</p>
		<div class="sampleCode">
			<pre>
		<code>
field:oldGenSize|field:oldGenUsed|field:newGenSize|field:newGenUsed|field:pauseTime||
		</code>
	</pre>
		</div>
	</div>

	<a name="startPatternHelp"></a>
	<div class="seperation helpSep">
		<span class="sepTitle helpTitle">Help with the Start Pattern</span>
	</div>
	<div class="helpContents">
		<jsp:include page="/help/patternHelp.jsp"></jsp:include>
	</div>
	</div>
<data:cloud>
	<jsp:include page="/common/chatApplication.jsp"></jsp:include>
</data:cloud>

</body>
</html>
