<p style="font-size:large; ;width: 80%; color: gray;">The start pattern is used to identify the start of each entry.
	Most of the data has a date pattern as a start. If the pattern is not
	auto detected, you have to provide the pattern to use to identify the
	start of each entry.
</p>
<p style="color:green">
If you need assistance with the pattern to use, contact Rigabyte support with a some sample lines of data and we can help. 
</p>
<table class="patternHelpTable" style="margin-top:30px;width:600px;">
	<caption><b>Examples</b></caption>
	<tr  bgcolor="#ccccff">
		<th>date</th>
		<th>pattern</th>
	</tr>
	<tr>
		<td>2007-04-05T14:30Z</td>
		<td>yyyy-MM-dd'T'HH:mm</td>
	</tr>
	<tr>
		<td>2010-03-26T10:05:38.707</td>
		<td>yyyy-MM-dd'T'HH:mm:ss.SSS</td>
	</tr>
	<tr>
		<td>22/Jul/2012:04:09:22</td>
		<td>dd/MMM/yyyy:HH:mm:ss</td>
	</tr>
	<tr>
		<td>Tue Jan 28 00:00:02 MST 2014</td>
		<td>EEE MMM dd HH:mm:ss 'MST' yyyy</td>
	</tr>
	<tr>
		<td>Java GC logs with time as: 4.145:</td>
		<td>JAVA_GC_LOG_SECONDS.MILLISECONDS:</td>
	</tr>
</table>


<table style="margin-top:30px;">
<caption><b>Pattern Letter Reference</b></caption>
<tbody><tr bgcolor="#ccccff">
         <th align="left">Letter
         </th><th align="left">Date or Time Component
         </th><th align="left">Presentation
         </th><th align="left">Examples
     </th></tr><tr>
         <td><code>G</code>
         </td><td>Era designator
         </td><td><a href="#text">Text</a>
         </td><td><code>AD</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>y</code>
         </td><td>Year
         </td><td><a href="#year">Year</a>
         </td><td><code>1996</code>; <code>96</code>
     </td></tr><tr>
         <td><code>Y</code>
         </td><td>Week year
         </td><td><a href="#year">Year</a>
         </td><td><code>2009</code>; <code>09</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>M</code>
         </td><td>Month in year
         </td><td><a href="#month">Month</a>
         </td><td><code>July</code>; <code>Jul</code>; <code>07</code>
     </td></tr><tr>
         <td><code>w</code>
         </td><td>Week in year
         </td><td><a href="#number">Number</a>
         </td><td><code>27</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>W</code>
         </td><td>Week in month
         </td><td><a href="#number">Number</a>
         </td><td><code>2</code>
     </td></tr><tr>
         <td><code>D</code>
         </td><td>Day in year
         </td><td><a href="#number">Number</a>
         </td><td><code>189</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>d</code>
         </td><td>Day in month
         </td><td><a href="#number">Number</a>
         </td><td><code>10</code>
     </td></tr><tr>
         <td><code>F</code>
         </td><td>Day of week in month
         </td><td><a href="#number">Number</a>
         </td><td><code>2</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>E</code>
         </td><td>Day name in week
         </td><td><a href="#text">Text</a>
         </td><td><code>Tuesday</code>; <code>Tue</code>
     </td></tr><tr>
         <td><code>u</code>
         </td><td>Day number of week (1 = Monday, ..., 7 = Sunday)
         </td><td><a href="#number">Number</a>
         </td><td><code>1</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>a</code>
         </td><td>Am/pm marker
         </td><td><a href="#text">Text</a>
         </td><td><code>PM</code>
     </td></tr><tr>
         <td><code>H</code>
         </td><td>Hour in day (0-23)
         </td><td><a href="#number">Number</a>
         </td><td><code>0</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>k</code>
         </td><td>Hour in day (1-24)
         </td><td><a href="#number">Number</a>
         </td><td><code>24</code>
     </td></tr><tr>
         <td><code>K</code>
         </td><td>Hour in am/pm (0-11)
         </td><td><a href="#number">Number</a>
         </td><td><code>0</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>h</code>
         </td><td>Hour in am/pm (1-12)
         </td><td><a href="#number">Number</a>
         </td><td><code>12</code>
     </td></tr><tr>
         <td><code>m</code>
         </td><td>Minute in hour
         </td><td><a href="#number">Number</a>
         </td><td><code>30</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>s</code>
         </td><td>Second in minute
         </td><td><a href="#number">Number</a>
         </td><td><code>55</code>
     </td></tr><tr>
         <td><code>S</code>
         </td><td>Millisecond
         </td><td><a href="#number">Number</a>
         </td><td><code>978</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>z</code>
         </td><td>Time zone
         </td><td><a href="#timezone">General time zone</a>
         </td><td><code>Pacific Standard Time</code>; <code>PST</code>; <code>GMT-08:00</code>
     </td></tr><tr>
         <td><code>Z</code>
         </td><td>Time zone
         </td><td><a href="#rfc822timezone">RFC 822 time zone</a>
         </td><td><code>-0800</code>
     </td></tr><tr bgcolor="#eeeeff">
         <td><code>X</code>
         </td><td>Time zone
         </td><td><a href="#iso8601timezone">ISO 8601 time zone</a>
         </td><td><code>-08</code>; <code>-0800</code>;  <code>-08:00</code>
 </td></tr></tbody>
 </table>
	<button class="helpCloseButton" style="width:120px;height:40px;margin:auto;">Close</button>
