function BrowseDataManager()
{
 this.jsonEditorManager=new JsonEditorManager(this);
 this.currentEditorNode=null;
}


BrowseDataManager.prototype.initialize=function ()
{
	var browseDataManager=this;
	
	  // create the editor
	this.jsonEditorManager.initialize();
	
	
	$('#fileTree')
	  // listen for event
	  .on('select_node.jstree', function (e, data) {

		  var current=data.instance.get_node(data.selected[data.selected.length-1]);
		  browseDataManager.handleNodeSelection(current);

	  });
	
	
	$('#fileTree').jstree({
		'core' : {
			"check_callback" : true, // enable all modifications
			"data" : {
				"url" :'/adminreq/?action=browseConfig',
				"data" : function (node) {
					return { "id" : node.id };
				}
			},
			'themes' : {
				'responsive' : true,
				'stripes' : true
			}
		},
		"plugins" : []
	});
	
	
};


BrowseDataManager.prototype.handleNodeSelection=function (currentNode)
{
	
	if (['HOST', 'HOSTFOLDER', 'LINK', 'LINKSFOLDER','BEANFOLDER','BEAN','BACKUP','DATAHUBFOLDER','DATAHUBTAPE'].indexOf(currentNode.original.dataType) >= 0) {
		this.jsonEditorManager.hideBackup();
	}
	else
	{
		this.jsonEditorManager.showBackup();
	}
	

	
	
	
	  $.cookie('lastPathId',currentNode.original.id,{ expires: 7,path: '/' });
			  
	  if(currentNode.original.dataType=='STORABLEITEMFOLDER' || currentNode.original.dataType=='STORABLEITEM')
	  {
		  this.jsonEditorManager.showDelete();
	  }	
	  else
	  {
		  this.jsonEditorManager.hideDelete();		  
	  }
	  
	
	  if(currentNode.original.dataType=='STORABLEITEM')
	  {
		  this.handleLoad(currentNode.original.id);
		  this.currentEditorNode=currentNode;
		  this.jsonEditorManager.displayId(currentNode.original.id);
	  }
	  else if(currentNode.original.dataType=='BEAN')
	  {
		  this.jsonEditorManager.setViewOnly();
		  this.handleLoadBean(currentNode.original.id);
		  this.currentEditorNode=currentNode;
		  this.jsonEditorManager.displayId(currentNode.original.id);
	  }
	  else if(currentNode.original.dataType=='DATAHUBTAPE')
	  {
		  this.jsonEditorManager.setViewOnly();
		  this.handleLoadBean(currentNode.original.id);
		  this.currentEditorNode=currentNode;
		  this.jsonEditorManager.displayId(currentNode.original.id);
	  }
	  else
	  {
		  this.jsonEditorManager.setViewOnly();
		  this.jsonEditorManager.hideSave();
		  this.jsonEditorManager.displayEditableJson(currentNode.original, currentNode.original);
		  this.jsonEditorManager.displayId(currentNode.original.id);
		  this.currentEditorNode=null;
	  }
	  
	  if(currentNode.original.dataType=='BACKUP')
	  {
		  this.jsonEditorManager.showRestore();
		  this.jsonEditorManager.hideBackup();
	  }
	  else
	  {
		  this.jsonEditorManager.hideRestore();
	  }
	  
	  
	  
};

BrowseDataManager.prototype.handleGetStorableItemJsonResponse=function()
{
	var browseDataManager=this;
	
	return function(jsonResponse)
	{
		browseDataManager.jsonEditorManager.setEdit();
		browseDataManager.jsonEditorManager.showSave();
		browseDataManager.jsonEditorManager.displayEditableJson(jsonResponse, jsonResponse.item);
		
	};
	
};

BrowseDataManager.prototype.handleGetBeanJsonResponse=function()
{
	var browseDataManager=this;
	
	return function(jsonResponse)
	{
		browseDataManager.jsonEditorManager.displayReadOnlyJson(jsonResponse, jsonResponse.beanInfo.bean);
		
	};
	
};



BrowseDataManager.prototype.handleSaveStorableItemJsonResponse=function()
{
	var browseDataManager=this;
	return function(jsonResponse)
	{
		if(!jsonResponse.error)
		{
			notifyUser('Message','Saved',2000,false);
			browseDataManager.handleLoad(jsonResponse.id);
		}
		else
		{
			notifyUser('Error',jsonResponse.error,4000,true);
		}
	};
	
};

BrowseDataManager.prototype.deleteNode=function(id)
{
//	console.log(id);
	$('#fileTree').jstree('delete_node',id);
	//Temporary hack as jstree is not working, deleting leaf is working, deleting folders is not.
	//location.reload();
	$("#fileTree").jstree('refresh');
};

BrowseDataManager.prototype.handleDeleteResponse=function(id)
{
	var browseDataManager=this;
	return function(jsonResponse)
	{
		if(!jsonResponse.error)
		{
			notifyUser('Message','Deleted',2000,false);
			browseDataManager.deleteNode(id);
		}
		else
		{
			notifyUser('Error',jsonResponse.error,4000,true);
		}
	};
	
};

BrowseDataManager.prototype.handleBackupResponse=function(id)
{
	var browseDataManager=this;
	return function(jsonResponse)
	{
		if(!jsonResponse.error)
		{
			notifyUser('Message','Copied to Backup directory:'+jsonResponse.dest,4000,false);
			$("#fileTree").jstree('refresh');
		}
		else
		{
			notifyUser('Error',jsonResponse.error,4000,true);
		}
	};
	
};

BrowseDataManager.prototype.handleRestoreResponse=function(id)
{
	var browseDataManager=this;
	return function(jsonResponse)
	{
		if(!jsonResponse.error)
		{
			notifyUser('Message','Restored from Backup directory',4000,false);
		}
		else
		{
			notifyUser('Error',jsonResponse.error,4000,true);
		}
	};
	
};

BrowseDataManager.prototype.handleSaveJson=function(json,jsonResponse)
{
	$.post('/adminreq?action=updateStorableItem',{json:JSON.stringify(json),id:jsonResponse.id},this.handleSaveStorableItemJsonResponse());
};

BrowseDataManager.prototype.handleDelete=function(id,backup)
{
	$.post('/adminreq?action=deletePath',{id:id,backup:backup},this.handleDeleteResponse(id));
};

BrowseDataManager.prototype.handleBackup=function(id)
{
	$.post('/adminreq?action=backupPath',{id:id},this.handleBackupResponse(id));
};

BrowseDataManager.prototype.handleRestore=function(id)
{
	$.post('/adminreq?action=restorePath',{id:id},this.handleRestoreResponse(id));
};


BrowseDataManager.prototype.handleLoad=function(id)
{
	  var param=new Object();
	  param.id=id;
	$.post('/adminreq?action=getStorableItemJson',param,this.handleGetStorableItemJsonResponse());
};


BrowseDataManager.prototype.handleLoadBean=function(id)
{
	  var param=new Object();
	  param.id=id;
	$.post('/adminreq?action=getBean',param,this.handleGetBeanJsonResponse());
};


$(document).ready(function() {
	var browseDataManager=new BrowseDataManager();
	browseDataManager.initialize();
});



