//Manager class that has responsibility of coordinating actions.
function JsonEditorManager(listener)
{
	this.listener=listener;
	this.currentId=null;
}


JsonEditorManager.prototype.initialize=function ()
{
	var jsonEditorManager=this;
	
	  // create the editor
	  var container = document.getElementById('jsonEditor');
	  this.editor = new JSONEditor(container);
	  
		$('#saveJson').click(function(event){
		    var json = jsonEditorManager.editor.get();
			jsonEditorManager.listener.handleSaveJson(json,jsonEditorManager.jsonResponse);
		});


		$('#deleteNode').click(function(event){
			jsonEditorManager.listener.handleDelete(jsonEditorManager.currentId,true);
		});

		$('#backupNode').click(function(event){
			jsonEditorManager.listener.handleBackup(jsonEditorManager.currentId,true);
		});

		$('#restoreNode').click(function(event){
			jsonEditorManager.listener.handleRestore(jsonEditorManager.currentId,true);
		});
};


JsonEditorManager.prototype.displayEditableJson=function(jsonResponse,json)
{
	this.jsonResponse=jsonResponse;
	this.editor.set(json);
	this.currentId=jsonResponse.id;
	$('#editorDataId').text(jsonResponse.id);
	$('#editorDataId').show();
};


JsonEditorManager.prototype.displayReadOnlyJson=function(jsonResponse,json)
{
	this.jsonResponse=jsonResponse;
	this.editor.set(json);
	this.currentId=jsonResponse.id;
	$('#editorDataId').text(jsonResponse.id);
	$('#editorDataId').show();
};


JsonEditorManager.prototype.displayId=function(id)
{
	this.currentId=id;
	$('#editorDataId').text(id);
	$('#editorDataId').show();
};


JsonEditorManager.prototype.clearJson=function()
{
	this.jsonResponse=null;
	this.editor.set('');
};

JsonEditorManager.prototype.setViewOnly=function()
{
	$('#jsonEditor').css('background-color','#eeeeee');
	this.editor.setMode('view');
};

JsonEditorManager.prototype.setEdit=function()
{
	$('#jsonEditor').css('background-color','transparent');
	this.editor.setMode('tree');
};

JsonEditorManager.prototype.showSave=function()
{
	$('#saveJson').show();
}

JsonEditorManager.prototype.hideSave=function()
{
	$('#saveJson').hide();
}
JsonEditorManager.prototype.showDelete=function()
{
	$('#deleteNode').show();
}

JsonEditorManager.prototype.hideDelete=function()
{
	$('#deleteNode').hide();
}

JsonEditorManager.prototype.showBackup=function()
{
	$('#backupNode').show();
}

JsonEditorManager.prototype.hideBackup=function()
{
	$('#backupNode').hide();
}
JsonEditorManager.prototype.showRestore=function()
{
	$('#restoreNode').show();
}

JsonEditorManager.prototype.hideRestore=function()
{
	$('#restoreNode').hide();
}