	//Class that handles display of chart information.
	function ChartInfoManager(chartManager,communicationsManager,chartInfoEventHandler,searchesDiv,readOnly)
	{
		this.communicationsManager=communicationsManager;
		this.chartManager=chartManager;
		this.chartInfoEventHandler=chartInfoEventHandler;
		this.searchesDiv=searchesDiv;
		this.readOnly=readOnly;
		this.miniInfo=false;
	}

	ChartInfoManager.prototype.setUseMiniInfo=function()
	{
		this.miniInfo=true;
	};
	
	
	ChartInfoManager.prototype.initialize=function()
	{

		//Associate function 
		if(this.readOnly!=true)
			{
				$('#searches').on('click','.closeImage',this.handleCloseChartInfoClick(this.chartManager,this,this.communicationsManager,this.chartInfoEventHandler));
				$('#searches').on('click','.showChartSeries',this.handleHideSearchInfoClick(this.chartManager,this,this.chartInfoEventHandler));
				$('#searches').on('click','.hideChartSeries',this.handleHideSearchInfoClick(this.chartManager,this,this.chartInfoEventHandler));
				$('#searches').on('click','.searchInfoContainer',this.selectSearchInfoClick(this.chartManager,this,this.chartInfoEventHandler));
			}
		
		$("#searches").on('mouseenter','.dstooltip',function(event)
				{
					var dstooltip=this;
					$(this).tooltip({
						content: function() {
							var ds= $(this).attr('title');
							ds=replaceAll(',','<br/>',ds);
							return ds;
						}
					});
					
					$(this).tooltip('open');
					
				});
		
		$("#searches").on('mouseleave','.dstooltip',function(event)
				{
					$(this).tooltip('destroy');
				});
	
	};
	
	//Method used to set the chart info state saved in the session on the chart infos.
	ChartInfoManager.prototype.setChartDataState=function(chartDataArray)
	{
		var chartInfoManager=this;
		$.each(chartDataArray,function(i,flotChartData){
			//check chartInfoHidden is not undefined and is true
			if(flotChartData.metaData.chartInfoHidden && flotChartData.metaData.chartInfoHidden=='true')
				{
					var chartInfoId=flotChartData.metaData.chartInfoId;
					var hideElement=$('#'+chartInfoId).find('.hideChartSeries');
					chartInfoManager.hideChartInfo(chartInfoId, hideElement);
				}
		});
	};


	//Updates the resultCount,busyIndicator,debugInformation
	ChartInfoManager.prototype.updateChartInfo=function()
	{
		$.each(this.chartManager.chartDataArray,function(i,flotChartDataItem){
			
			var chartInfoId=flotChartDataItem.metaData.chartInfoId;
			var sii=flotChartDataItem.searchInstanceState;
			
			$("#"+chartInfoId+".searchInfo").find(".resCountInfo").text(flotChartDataItem.metaData.resultCount);
			
			if(flotChartDataItem.allResultsPopulated==true)
			{
				$("#"+chartInfoId+".searchInfo").find(".busyIndicator").remove();
				$("#"+chartInfoId+".searchInfo").find(".searchingMsg").remove();
			}
			else
			{
				$("#"+chartInfoId+".searchInfo").find(".searchingMsg").html(sii.completedSearches+' of '+sii.numberOfShardsToSearch);
			}
			
			var searchStatsHTML='';
			
			if(debugInfoOnPage==true)
			{
				var title=JSON.stringify(sii);
				if(typeof title != 'undefined')
				{
					title=title.replace(/["']/g, "");
					title=title.replace(/[,]/g, " ");
					$("#"+chartInfoId+".searchInfo").find(".senInfo").attr('title',title);
				}

			}
			
		});
		
	}
	
	ChartInfoManager.prototype.displayChartInfo=function()
	{
		var chartInfoManager=this;
		$(chartInfoManager.searchesDiv).html('');
		$.each(chartInfoManager.chartManager.chartDataArray,function(i,flotChartDataItem){
			var color=flotChartDataItem.color;
			var chartInfoId=flotChartDataItem.metaData.chartInfoId;
			
			var label=flotChartDataItem.metaData.chartInfoLabel;
			if(label==null || label.length==0)
				{
					label="All Data";
				}
			
			var allDataLoaded=flotChartDataItem.allResultsPopulated;
			var busyIndicatorHTML='';
			var sii=flotChartDataItem.searchInstanceState;
			var searchStatsHTML='';

			if(debugInfoOnPage==true)
			{
				var title=JSON.stringify(sii);
				if(typeof title != 'undefined')
				{
					title=title.replace(/["']/g, "");
					title=title.replace(/[,]/g, " ");
					searchStatsHTML='<span class="senInfo" title="'+title+'"/>';					
				}

			}
			
			if(allDataLoaded==false)
			{
				busyIndicatorHTML='<img class="busyIndicator" src="/images/busyAni.gif"/><span class="searchingMsg"> '+sii.completedSearches+' of '+sii.numberOfShardsToSearch+'</span>';
			}
			busyIndicatorHTML=busyIndicatorHTML+searchStatsHTML;
			
			var closeButtonHtml='<div class="closeDiv"><a href="" class="closeImage"></a></div>';
			var hideButtonHtml='<div class="hideDiv"><a class="hideChartSeries"></a></div>';
			var hiddenHTML='';
			if(flotChartDataItem.metaData.chartInfoHidden=='true')//This is to ensure that the hidden chart infos are properly rendered.
			{
				hideButtonHtml='<div class="hideDiv"><a class="showChartSeries"></a></div>';
				hiddenHTML=' hidden';
			}
			
			//The readonly is true for reports
			if(chartInfoManager.readOnly==true)
				{
					closeButtonHtml='';
					hideButtonHtml='';
				}

			
			var valueDisplaymaxLength=24;
			
			var chartInfoOuterClass='searchInfoOuter'+hiddenHTML;
			var searchInfoTitle='searchInfoTitle';
			var searchInfoLabel='searchInfoLabel';
			var searchInfoContainer='searchInfoContainer';
			var chainClass='chartInfoChain';
			
			if(chartInfoManager.miniInfo==true)
			{
					chartInfoOuterClass='searchInfoOuterMini';
					searchInfoTitle='searchInfoTitleMini';
					searchInfoLabel='searchInfoLabelMini';
					searchInfoContainer='searchInfoContainerMini';
					chainClass='chartInfoChainMini';
					valueDisplaymaxLength=15;
			}

			
			var indexName=flotChartDataItem.metaData.indexName;
			//Get name of data source.
			var nameHolder=chartInfoManager.getDataSourceInfoName(flotChartDataItem, valueDisplaymaxLength);

			//Can be used to get a lighter version of the color.
			color=shadeRGBColor(color,.6);
			var chainHTML='';
			if(flotChartDataItem.fieldNumber && parseInt(flotChartDataItem.fieldNumber)>1)
			{
				chainHTML='<span class="'+chainClass+'"></span>';
			}			
			var chartInfoHTML='<div class="'+chartInfoOuterClass+'"><div class="searchInfo" id="'+chartInfoId+'"style="background-color:'+color+'">'+
			chainHTML+
			'<div class="'+searchInfoContainer+'">'+
			'<div class="'+searchInfoTitle+'">'+
				'<a class="'+searchInfoLabel+'" href="" title="'+label+'">'+label.substring(0,valueDisplaymaxLength)+'</a>'+
			'</div>';
			

			
			
			if(chartInfoManager.miniInfo==false)
			{
				chartInfoHTML=chartInfoHTML+			'<div class="searchInfoResultCount">'+
				'<a class="searchInfoLabel" href=""><span class="cInfoLabel">Results:</span><span class="resCountInfo">'+flotChartDataItem.metaData.resultCount+'</span></a>'+busyIndicatorHTML+
				'</div>'+
				'<div class="searchInfoResultCount">'+
				'<a class="searchInfoLabel" href="" title="'+indexName+'" ><span class="cInfoLabel">Data:</span>'+indexName.substring(0,valueDisplaymaxLength)+'</a>'+
				'</div>'+
				'<div class="searchInfoResultCount">'+
				'<a class="searchInfoLabel dstooltip" href="" title="'+nameHolder.longName+'"><span class="cInfoLabel">Source:</span>'+nameHolder.shortName+'</a>'+
				'</div>';
			}
			chartInfoHTML=chartInfoHTML+ '</div>'+
			closeButtonHtml+
			hideButtonHtml+
		'</div></div>';
			
			$(chartInfoManager.searchesDiv).append(chartInfoHTML);
			
		});
	


	};
	
	
	ChartInfoManager.prototype.getDataSourceInfoName=function(flotChartDataItem,maxLength)
	{
		var nameHolder=new Object();
		if(flotChartDataItem.dataSourceInfoJsons.length==0)
		{
			nameHolder.shortName='All';
			nameHolder.longName='All';
		}
		else
		{
			nameHolder.shortName=flotChartDataItem.dataSourceInfoJsons.length+' sources.';
			if(flotChartDataItem.metaData.addDataSourcesSelected=="true")
			{
				nameHolder.shortName="All";
			}
			
			nameHolder.longName='';
			for (var int = 0; int < flotChartDataItem.dataSourceInfoJsons.length; int++) {
				var name=flotChartDataItem.dataSourceInfoJsons[int].name;
				if(name.length>maxLength)
				{
					name='..'+name.substring(name.length-(maxLength-2));	
				}
				
				nameHolder.longName=nameHolder.longName+name+',';
			}
		}
		return nameHolder;
	}
	
	
	ChartInfoManager.prototype.selectCurrentChartInfo=function(generateEvent)
	{
		var chartInfoId=this.chartManager.getChartInfoIdForCurrentSeries();
		if(chartInfoId!=null)
		{
			this.selectChartData(chartInfoId,generateEvent);			
		}		
	}
	
	ChartInfoManager.prototype.selectChartData=function(chartInfoId,generateEvent)
	{
		
			if(chartInfoId!=null)
			{
				$('.closeImage').removeClass('selected');
					$('#'+chartInfoId).find('.closeImage').addClass('selected');				
			
					if(generateEvent!=false)
					{
						//Event handler method called on event listener.
						this.chartInfoEventHandler.handleChartInfoEventSelectChartData(this.chartManager.chartIdToChartDataMap[chartInfoId],chartInfoId);
					}
					
					this.currentChartInfoId=chartInfoId;
			}

	};
	
	
	//Function called with the searchInfo hide button is called.
	ChartInfoManager.prototype.handleHideSearchInfoClick=function(chartManager,chartInfoManager,chartInfoEventHandler)
	{
    	return function(event)
    	{
    		
    		var chartInfoId=$(this).closest(".searchInfo").attr('id');
			var className=$(this).attr('class');
			 if(className=='showChartSeries')//If the user has clicked 'show' that would be the new selection.
				 {
					 chartInfoManager.showChartInfo(chartInfoId, $(this),chartManager);
					 chartInfoManager.selectChartData(chartInfoId,true);
					 chartManager.setCurrentChartDataIdSelected(chartInfoId);
					  
					 chartInfoEventHandler.handleChartInfoEvent("chartInfoShown",chartInfoId);
					 chartInfoEventHandler.handleChartInfoEvent("selectSearchInfo",chartInfoId);
				 }
			 else//if user has clicked hide
				 {
					 chartInfoManager.hideChartInfo(chartInfoId,$(this));
					 chartManager.hideSeries(chartInfoId);
					 chartInfoEventHandler.handleChartInfoEvent("chartInfoHidden",chartInfoId);
					 
					 //If the hidden chart info is same as the current chart info then select next possible chartinfo.
					 if(chartInfoManager.currentChartInfoId==chartInfoId)
					 {
						 var index=chartManager.getIndexForVisibleChartData();//When the user hides a series find the chart info to select next.
						 if(index>=0)
						 {
							 var chartInfoId=chartManager.getChartInfoId(index);
							 if(chartInfoId!=null)
								 {
								    chartManager.setCurrentChartDataIdSelected(chartInfoId);
								 	chartInfoManager.selectChartData(chartInfoId,true);
								 	chartInfoEventHandler.handleChartInfoEvent("selectSearchInfo",chartInfoId);							 
								 }
						 }
						 chartInfoManager.generateChartInfoHiddenEvent(chartInfoEventHandler);						 
					 }
				 }			
			 
			
			chartManager.plotChart();

			event.preventDefault();
			return false;
    	};
	};

	
	ChartInfoManager.prototype.hideChartInfo=function(chartInfoId,element)
	{
		var searchInfo=$('#'+chartInfoId).parent();
		element.attr('class','showChartSeries');
		searchInfo.attr('class','searchInfoOuter hidden');
	};
	

	ChartInfoManager.prototype.showChartInfo=function(chartInfoId,element,chartManager)
	{
		var searchInfo=$('#'+chartInfoId).parent();
		chartManager.showSeries(chartInfoId);
		element.attr('class','hideChartSeries');
		searchInfo.attr('class','searchInfoOuter');
	};

	
	//Function called when the searchInfo close button is called.
	ChartInfoManager.prototype.handleCloseChartInfoClick=function (chartManager,chartInfoManager,communicationsManager,chartInfoEventHandler)
	{
		return function(event){
	
			var chartInfoId=$(this).closest(".searchInfo").attr('id');

			communicationsManager.sendRemoveResultDataRequest(chartInfoId,false,function(response){
				
				relatedChartInfos=response;

				if(relatedChartInfos.length>0)
				{
					var currentChartInfoId=chartManager.getChartInfoIdForCurrentSeries();
					for ( var i = 0; i < relatedChartInfos.length; i++) {
						var chartInfoId=relatedChartInfos[i];
						chartManager.removeSeriesWithChartInfoId(chartInfoId);
						$('#'+chartInfoId).parent().remove();
						//if current chartInfoId is closed, set currentChartDataIdSelected to null.
						if(currentChartInfoId==chartInfoId)
						{
							chartManager.setCurrentChartDataIdSelected(null)	
						}
						
						chartInfoEventHandler.handleChartInfoEvent("closeSearchInfo",chartInfoId);
					}
				
					currentChartInfoId=chartManager.getChartInfoIdForCurrentSeries();

					if(currentChartInfoId==null)//If currently selected chart info has been closed.
					{
							var nextChartDataIndex=chartManager.getIndexForVisibleChartData();
							 if(nextChartDataIndex>=0)
							 {
								currentChartInfoId=chartManager.getChartInfoId(nextChartDataIndex);
								chartManager.setCurrentChartDataIdSelected(currentChartInfoId);
								chartInfoManager.selectChartData(currentChartInfoId,true);	 
							 	chartInfoEventHandler.handleChartInfoEvent("selectSearchInfo",currentChartInfoId);
							 }
					}
				}
				
				chartManager.plotChart();
				if(chartManager.isChartEmpty())
				{
					chartInfoEventHandler.handleChartInfoEvent("chartEmpty",null);
				}				
				
				//If all chart data is hidden,then generate a chartHidden event.
				chartInfoManager.generateChartInfoHiddenEvent(chartInfoEventHandler);
				
			});
			
			event.preventDefault();
			return false;
		};
	};

	
	ChartInfoManager.prototype.handleCloseAllChartInfo=function()
	{
		var chartInfoManager=this;
		var chartInfoId=this.currentChartInfoId;
		chartInfoManager.communicationsManager.sendRemoveResultDataRequest(chartInfoId,true,function(){

			var requestCount=getURLParameter("requestCount");
			
			//If the request count is 0 or if there is no request count, the reload the URL without any parameters.
			//This is needed as when request count is 0, the search request handler is hit, if not the drilldown handler is hit.
			//Hitting the search handler will repeat the search.

			if(typeof requestCount != 'undefined' && requestCount!='0' && requestCount.length>0) //If there is a request count and is not 0.
			{
				location.reload();	
				
			}
			else //If no request count or request count is 0.
			{
				window.location.href = "/";
			}	

			
		});
		
		
	};

	
	ChartInfoManager.prototype.handleHideAllChartInfo=function()
	{
		this.communicationsManager.hideAllButCurrentChartInfo(this.currentChartInfoId,this);
	};

	ChartInfoManager.prototype.handleShowAllChartInfo=function()
	{
		this.communicationsManager.showAllChartInfo(this);
	};
	
	
	ChartInfoManager.prototype.handleShowHideResponse=function()
	{
		var requestCount=getURLParameter("requestCount");
		
		//If the request count is 0 or if there is no request count, the reload the URL without any parameters.
		//This is needed as when request count is 0, the search request handler is hit, if not the drilldown handler is hit.
		//Hitting the search handler will repeat the search.

		if(typeof requestCount != 'undefined' && requestCount!='0' && requestCount.length>0) //If there is a request count and is not 0.
		{
			location.reload();	
			
		}
		else //If no request count or request count is 0.
		{
			window.location.href = "/";
		}	
		
	}

	
	
	ChartInfoManager.prototype.generateChartInfoHiddenEvent=function(chartInfoEventHandler)
	{
		if(this.chartManager.isAllDataInChartHidden())
		{
			chartInfoEventHandler.handleChartInfoEvent("chartHidden",null);
		}

	};
	
	//Function called when link on search info is clicked.
	ChartInfoManager.prototype.selectSearchInfoClick=function (chartManager,chartInfoManager,chartInfoEventHandler)
	{
		
		return function (event)
		{
			var chartInfoId=$(this).closest(".searchInfo").attr('id');
			var element=$(this).parent().find('.showChartSeries');
			if(element.length>0)//The series hidden, so show it.
			{
				chartInfoManager.showChartInfo(chartInfoId, element,chartManager);
				chartManager.setCurrentChartDataIdSelected(chartInfoId);
				chartInfoManager.selectChartData(chartInfoId,true);
				chartManager.plotChart();//plot the chart again.
				chartInfoEventHandler.handleChartInfoEvent("chartInfoShown",chartInfoId);
				chartInfoEventHandler.handleChartInfoEvent("selectSearchInfo",chartInfoId);
			}
			else//Series is already displayed.
			{
						chartManager.setCurrentChartDataIdSelected(chartInfoId);
						chartInfoManager.selectChartData(chartInfoId,true);
						chartManager.plotChart();//plot the chart again.
						//The date selected for a chart info will be the last date used for the data collection, so the last date used for a data collection 
						//is saved. This behavior is by design. So when selecting chart infos from the same data collection, the date will not change.
						chartInfoEventHandler.handleChartInfoEvent("selectSearchInfo",chartInfoId);
			}
			
			event.preventDefault();
			return false;
		};
	};
	//This is the index of the chart info 0,1,2,3 etc
	ChartInfoManager.prototype.getCurrentChartInfoId=function()
	{
		return this.currentChartInfoId;
	};
	
	ChartInfoManager.prototype.saveLogPageNumberState=function(pageNumber,chartInfoId)
	{
		var chartSeriesNumber=this.chartManager.getIndexForCartInfoId(chartInfoId)
		this.chartManager.chartDataArray[chartSeriesNumber].metaData.currentLogPageNumber=pageNumber;
	};

	ChartInfoManager.prototype.getLogPageNumberState=function(chartInfoId)
	{
		var chartSeriesNumber=this.chartManager.getIndexForCartInfoId(chartInfoId)
		
		var currentPageNumber= this.chartManager.chartDataArray[chartSeriesNumber].metaData.currentLogPageNumber;
		if(!currentPageNumber)
			{
				currentPageNumber=1;
			}
		return currentPageNumber;
	};
	
