var allChartDataLoadedSeleniumTest=false;
var getChartDataCountSeleniumTest=0;
var dataDisplayManagerGlobal=null;
//Manager class that has responsibility of coordinating actions.
	function DataDisplayManager()
	{
		this.communicationsManager=new CommunicationsManager();
		this.chartManager=new ChartManager(this.communicationsManager,"#chart","line");
		this.addToDashboard=new AddToDashboardDialog(this.communicationsManager,this);
		this.searchOptionsManager=new SearchOptionsManager(this.communicationsManager,this.addToDashboard);
		this.chartInfoManager=new ChartInfoManager(this.chartManager,this.communicationsManager,this,"#searches",false);
		this.logDataManager=new LogDataManager(this.communicationsManager,this);
		this.paginationManager=new PaginationManager();
		this.infoPopupDialog=new InfoPopupDialog();
		this.tailDataManager=new TailDataManager(this.communicationsManager,this);
		this.flaggedDataManager=new FlaggedDataManager(this.communicationsManager,this);
		this.searchHistoryManager=new SearchHistoryManager(this.communicationsManager,this);
		
		this.overloadNotification=false;
		this.chartManager.markCurrentChartDataSel=true;
		//Used to check if any partial available log data has been loaded.
		this.searchableLogDataLoadedFlags=new Object();
		//Used to keep track of if response is for a refresh reqeust.
		this.isRefreshRequest=false;
		//========== For Contact support dialog.
		var contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_minDialog');
		
		var initialText='Subject:Help me with XYZ.\n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		contactSupportDialog.setInitialText(initialText);
		
//		$('#contactSupport3').click(function(){
//			contactSupportDialog.setMessageAddendum('Any Addendum');
//			contactSupportDialog.showDialog();
//		});

		//Handlers used for notification from contactSupportForm
		this.handleValidationFailure=function(message)
		{
			notifyUser("Error", message, 3000,true);
		};

		//Handlers used for notification from contactSupportForm	
		this.handleSendingMessageNotification=function(message)
		{
			notifyUser("Message", message, 2000,false);
		};

		//Handlers used for notification from contactSupportForm
		this.handleMessageSentNotificationSuccess=function(message)
		{
			notifyUser("Message", message, 3000,false);
			contactSupportDialog.hideDialog();
		};
		
		//Remove the background-image on focus.
//		$('#search_input').on('click focusin', function() {
//			$('#search_input').css('background-image', 'none');
//		});

		if(typeof displayAxisLabelsForChart != 'undefined')
		{
				this.chartManager.displayAxisLabels=displayAxisLabelsForChart;
		}
		//========== For Contact support dialog end

		
}

	
	DataDisplayManager.prototype.initialize=function()
	{
		var dataDisplayManager=this;
		$("#search_submit").button();
		$("body").on('click touchend','#search_submit',this.handleSearchRequest(this));
		
		$("body").on('click touchend','.drilldown1',function(){
			var requestCount=$(this).attr('dat');
			window.location='/?requestCount='+requestCount;
		});
		
		$('body').on('click touchend','#moreLogInfo',function(event){
			
			var displayExtraInfo=dataDisplayManager.logDataManager.isDisplayExtraInfo();
			if(displayExtraInfo==false)
				{
				$("#moreLogInfo").addClass('buttonSelected');
				}
			else
				{
				$("#moreLogInfo").removeClass('buttonSelected');
				}
			
			
			dataDisplayManager.logDataManager.toggleExtraInfo();
			event.preventDefault();
	});
		
		
		
		$('body').on('click touchend','#closeAllBut',function(event){
			event.preventDefault();					
			dataDisplayManager.chartInfoManager.handleCloseAllChartInfo();
			});

		$('body').on('click touchend','#hideAllBut',function(event){
			dataDisplayManager.chartInfoManager.handleHideAllChartInfo();
			event.preventDefault();
			});

		$('body').on('click touchend','#showAll',function(event){
			dataDisplayManager.chartInfoManager.handleShowAllChartInfo();
			event.preventDefault();
			});
		
		


		

		
		this.searchOptionsManager.initialize();
		//Load chart data, chart Manager has the handler method that is called.
//		var startDate=getURLParameter("startDate");
//		var endDate=getURLParameter("endDate");
		
		var startDate=this.searchOptionsManager.getStartDateInMillis();
		var endDate=this.searchOptionsManager.getEndDateInMillis();
		
		//Get the selected index.
		var index=this.searchOptionsManager.getDataCollectionId();
		this.searchOptionsManager.loadDataSourceInfos(index, this.searchOptionsManager,null);
		this.communicationsManager.loadChartData(this,startDate,endDate,index);
		this.chartInfoManager.initialize();
		this.addToDashboard.initialize();
		this.infoPopupDialog.initialize();
		this.logDataManager.initialize();
		this.searchHistoryManager.initialize();
		
		//Use this to always display the dialog.
		//this.infoPopupDialog.displayDialog();
		//this.infoPopupDialog.displayDialogOncePerSession(); -Commented out as dialog display is handled on the backend.
		
		//Variable set in search2.jsp
		if(typeof userMessage !=='undefined')
		{
				notifyUserSmall(userMessage,560);
		}
		
		
	};

	//When data is refreshed, this is used to filter out chart data that was closed.
	DataDisplayManager.prototype.filterOutNonExistingChartData=function(newChartDataArray)
	{
		var chartIdToChartDataMap=this.chartManager.chartIdToChartDataMap;
		var filteredArray=new Array();
		for (var int = 0; int < newChartDataArray.length; int++) {
			var chartDataId=newChartDataArray[int].metaData.chartInfoId;
			
			if(chartDataId in chartIdToChartDataMap)
			{
					filteredArray.push(newChartDataArray[int]);
			}
			else
			{
				
			}
			
		}
		return filteredArray;
	}
	
	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.handleGetChartDataResponse=function(chartDataArray,jsonResponse)
	{
		
			this.chartManager.setChartData(chartDataArray, jsonResponse);	
			if(chartDataArray.length>0)
			{
				this.chartManager.setChartDataState();				
			}
		
			this.chartManager.plotChart();
			
			this.displayChartLogoIfNeeded();
		
			//Display chart information.
			this.chartInfoManager.displayChartInfo();

			this.chartInfoManager.selectCurrentChartInfo(true);	
			//Method used to set the chart info state saved in the session on the chart infos.
			this.chartInfoManager.setChartDataState(chartDataArray);
		
			//Load data for search options.
			this.searchOptionsManager.loadSearchOptionsData(true);
		
		var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();
		var chartDataCompletelyLoaded=this.isChartDataComplete(chartDataArray);
		//Variable is used in selenium tests.
		allChartDataLoadedSeleniumTest=chartDataCompletelyLoaded;
		
		//If log data is ready to be loaded, load data, if already loaded update the page count.
		this.loadLogDataIfReady(chartInfoId,chartDataCompletelyLoaded);
		
		
		if(chartDataCompletelyLoaded==false)
		{
			var dataDisplayManager=this;
			setTimeout(function(){dataDisplayManager.communicationsManager.redoExistingSearch(dataDisplayManager);},2000);
		}
		
	};

	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.handleRefreshChartDataResponse=function(chartDataArray,jsonResponse)
	{
		//Variable used in selenium tests.
		getChartDataCountSeleniumTest+=1;
		var overload=false;
		var overloadedMessage;
		if(this.overloadNotification==false)
		{
			for (var int = 0; int < chartDataArray.length; int++) {
				
				if(typeof chartDataArray[int].searchInstanceState != 'undefined')
				{
					
					if(chartDataArray[int].searchInstanceState.overloaded==true)
					{
						overloadedMessage=chartDataArray[int].searchInstanceState.overloadedMessage;
						overload=true;
					}
				}
			}
			if(overload==true && typeof overloadedMessage !='undefined')
			{
				 notifyUser('Message',overloadedMessage,6000,true);
			}
			this.overloadNotification=true;
		}
		
		
			//When data is refreshed, this is used to filter out chart data that was closed.
			chartDataArray=this.filterOutNonExistingChartData(chartDataArray);
		
			this.chartManager.updateChartData (chartDataArray, jsonResponse);
		
			this.chartManager.plotChart();
		
			//Display chart information.
			this.chartInfoManager.updateChartInfo();
			
			this.isRefreshRequest=true;
		
			//Load data for search options, if false argument is passed, data is not reloaded from the server.
			//With false , the existing form values are stored in the in memory objects.
			this.searchOptionsManager.loadSearchOptionsData(true);
		
		var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();
		var chartDataCompletelyLoaded=this.isChartDataComplete(chartDataArray);
		//Variable is used in selenium tests.
		allChartDataLoadedSeleniumTest=chartDataCompletelyLoaded;
		
		//If log data is ready to be loaded, load data, if already loaded update the page count.
		this.loadLogDataIfReady(chartInfoId,chartDataCompletelyLoaded);
		
		if(chartDataCompletelyLoaded==false)
		{
			var dataDisplayManager=this;
			setTimeout(function(){dataDisplayManager.communicationsManager.redoExistingSearch(dataDisplayManager);},2000);
		}

	};


	DataDisplayManager.prototype.loadLogDataIfReady=function(chartInfoId,chartDataCompletelyLoaded)
	{
		//If data available, load log data. If data already loaded update the pagination count.
		if(chartInfoId!=null)
		{
					var chartInfoHidden=this.chartManager.isChartDataHidden(chartInfoId);
					
					//If chartInfo not hidden and if searchable log data available and not loaded.
					if(chartInfoHidden==false && this.searchableLogDataLoadedFlags.chartInfoId!=true)
					{
						var pageNumber=this.chartInfoManager.getLogPageNumberState(chartInfoId);
							pageNumber=parseInt(pageNumber);
							//Note that this executes only if logData for the chartInfoId is not already loaded.
							if(this.isLogDataAvailableForLoading(chartInfoId) || chartDataCompletelyLoaded)
								{
									this.logDataManager.showLogDataSpinner();
									this.communicationsManager.loadLogData(this,pageNumber,chartInfoId);
									this.searchableLogDataLoadedFlags.chartInfoId=true;
								}
					}//If searchable log data has already been loaded, we only need to update the page count. 		
					else if(this.searchableLogDataLoadedFlags.chartInfoId && this.searchableLogDataLoadedFlags.chartInfoId==true)
					{
						var searchablePageCount=this.chartManager.getSearchablePageCount(chartInfoId);
						this.paginationManager.setMaxPageCount(searchablePageCount);
					}				

		}
	}
	
	
	DataDisplayManager.prototype.isLogDataAvailableForLoading=function(chartInfoId)
	{
		var searchableResultCount=parseInt(this.chartManager.chartIdToChartDataMap[chartInfoId].metaData.searchableResultCount);
		var searchablePageCount=parseInt(this.chartManager.chartIdToChartDataMap[chartInfoId].metaData.searchablePageCount);
		
		if(searchablePageCount>0 && searchableResultCount>0)
		{
			return true;
		}
						
		return false;
	};
	
	
	//Method to display tail results.
	DataDisplayManager.prototype.displayTailResults=function(response,color)
	{
		//If there is atleast one non hidden chart info present.
		if($('.hideChartSeries').length>0)
		{
			this.logDataManager.displayTailResults(response,color);	
		}
		
	};

	DataDisplayManager.prototype.displayFlaggedResults=function(response)
	{
		this.logDataManager.displayFlaggedLogData(response);
	};
	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.displayChartInfoOptionButtons=function(pageCount)
	{
		if(this.chartManager.chartDataArray.length>0)
		{
			$('#chartInfoButtonList').show();
		}
		
		if(pageCount>0)
		{
			$('#logDataButtonList').show();
		}

		
	};

	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.hideChartInfoOptionButtons=function(pageCount)
	{
		
			$('#logDataButtonList').hide();
			$('#chartInfoButtonList').hide();
	};

	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.handleRepeatExistingSearchResponse=function(dataDisplayManager)
	{
		return function()
		{
			dataDisplayManager.reloadChartData(dataDisplayManager);
		};
		
		
	};

	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.reloadChartData=function(dataDisplayManager)
	{
			var startDate=dataDisplayManager.searchOptionsManager.getStartDateInMillis();
			var endDate=dataDisplayManager.searchOptionsManager.getEndDateInMillis();
			
			//Get the selected index.
			var index=dataDisplayManager.searchOptionsManager.getDataCollectionId();
			dataDisplayManager.communicationsManager.loadChartData(dataDisplayManager,startDate,endDate,index,true);
		
	};
	
	//Method called after the chart data has been loaded.
	DataDisplayManager.prototype.isChartDataComplete=function(chartDataArray)
	{
		var result=true;
		for ( var int = 0; int < chartDataArray.length; int++) {
			if(chartDataArray[int].allResultsPopulated==false)
			{
				result=false;
				return result;
			};
		}
		return result;
	};
	
	
	DataDisplayManager.prototype.handleGetLogDataResponseError=function()
	{
		this.logDataManager.hideLogDataSpinner();
		notifyUser('Error','Error getting log data.',4000,true);
	}
	//Method called after the log data has loaded.
	DataDisplayManager.prototype.handleGetLogDataResponse=function(jsonResponse,chartInfoIdResponse)
	{
			
		var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();
		if(chartInfoId!=chartInfoIdResponse)//Current chartInfoId has changed while log data was being fetched, do no do any thing
		{
			return;
		}

		//If user has closed existing chartInfos, do not display any log data.
		if($('.searchInfoOuter').length==0)
		{
			return;
		}
		
		var currentSelectedSeriesNumber=this.chartManager.getIndexForCartInfoId(chartInfoId);
	
		
				this.logDataManager.hideLogDataSpinner();
				var pageCount=parseInt(jsonResponse.metaData.pageCount);
				var currentPage=parseInt(jsonResponse.metaData.currentPage);
				
				var textColor=this.chartManager.getSeriesColor(currentSelectedSeriesNumber);
				if(pageCount > 0)
					{
						
						this.paginationManager.showPagination();
						this.paginationManager.paginateLogData(pageCount, textColor, this,currentSelectedSeriesNumber,currentPage);	
						this.displayChartInfoOptionButtons(pageCount);
						//Display log data.
						this.logDataManager.displayLogData(jsonResponse,this.logDataManager);
						
					}
				else
					{
						this.paginationManager.clearPagination();
						this.logDataManager.clearLogs();
						if(tailRequested!='true')
						{
							this.hideChartInfoOptionButtons(pageCount);	
						}
						else
						{
							this.displayChartInfoOptionButtons(pageCount);
						}
						
						
					}

				//Used to get a lighter shade of the color.
				var lighterColor=shadeRGBColor(textColor,.5);
				//Used to highlight the search result matches.
				$(".st").css('background-color',lighterColor);

				if(tailRequested!='true')//If not tail is requested.
				{

				}else //If tail is requested.	
				{

					this.displayChartInfoOptionButtons(1);
					$('#tail21').click();
					tailRequested=false;
				}
				//Used for selenium tests.
				logDataFullyLoadedSelTest=true;
	};
	
	
	DataDisplayManager.prototype.displayChartLogoIfNeeded=function()
	{
		if(this.chartManager.isAllDataInChartHidden() || this.chartManager.isChartEmpty())
		{
			$('#chartLogo').css('visibility','visible');
			
		}
		else
		{
			$('#chartLogo').css('visibility','hidden');
		}
		
	}
	//Method called when a new chart info event occurs.
	DataDisplayManager.prototype.handleChartInfoEvent=function(eventType,chartInfoId)
	{
		
		//Index id is used to identify the chartInfo state on the server.
			this.displayChartLogoIfNeeded();
			if(eventType=="selectSearchInfo")
			{
				
				var pageNumber=this.chartInfoManager.getLogPageNumberState(chartInfoId);
				pageNumber=parseInt(pageNumber);
				var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();
				
				this.tailDataManager.setCurrentChartInfoId(chartInfoId);
				var indexCurrentSelected=this.chartManager.getIndexForCartInfoId(this.chartInfoManager.getCurrentChartInfoId());
				var color=this.chartManager.getSeriesColor(indexCurrentSelected);
				
				this.tailDataManager.setColor(color);

				this.paginationManager.clearPagination();
				this.logDataManager.clearLogs();
				if(this.tailDataManager.isTailActive()==false || this.tailDataManager.isTailPaused()==true)
				{
					this.hideChartInfoOptionButtons();
				}

				if(this.isLogDataAvailableForLoading(chartInfoId))
				{
					if(this.tailDataManager.isTailActive()==false || this.tailDataManager.isTailPaused()==true)
					{
						this.logDataManager.showLogDataSpinner();	
					}

					this.communicationsManager.loadLogData(this,pageNumber,chartInfoId);	
				}
				
				if(this.flaggedDataManager.isFlaggedActive())
				{
					this.flaggedDataManager.flaggedDataHidden();
				}
				
				//Load the search options data.
				this.searchOptionsManager.loadSearchOptionsData(false);
				
			}
			else if(eventType=="chartEmpty" || eventType=="chartHidden")//This is generated when all chart data is hidden.
			{
				if(eventType=="chartEmpty")
				{
					$("#search_input").val('');
				}
				
				this.paginationManager.clearPagination();
				this.logDataManager.clearLogs();
				this.hideChartInfoOptionButtons();
				this.logDataManager.hideLogDataSpinner();
				
				
			}
			else if(eventType=="chartInfoShown")
			{
				//Save the chartInfoState to not hidden.
				this.communicationsManager.saveChartInfoState(chartInfoId, false);

			}
			else if(eventType =="chartInfoHidden")
			{
				//Save the chartInfoState to hidden.
				this.communicationsManager.saveChartInfoState(chartInfoId, true);
			}
			if(eventType =="closeSearchInfo")
			{
				//Generated when a chart info is closed.
			}
				
		
	};

	//Method called when a new chart data is selected, can be caused by multiple events.
	DataDisplayManager.prototype.handleChartInfoEventSelectChartData=function(flotChartDataItem,chartInfoId)
	{
		//Code to set the search keyword for chart info to search input.
		$("#search_input").val(flotChartDataItem.metaData.label);
		var selectedIndex=this.chartManager.getIndexForCartInfoId(chartInfoId);
		var color=this.chartManager.getSeriesColor(selectedIndex);
		
		$("#search_input_label").css('color',color);
		$(".search_options_label").css('color',color);
		$("#search_submit").css('color',color);
		//var lighterColor=shadeRGBColor(color,.3);
		//$("#search_input").css('background-color',lighterColor);
		//$("#search_input").css('border-color',lighterColor);
		//Display the left border for log data in the selected color.
		//$("#logData").css('border-left-color',color);

		//$("#search_options_form").effect("highlight", {color:color}, 4000);
		
		//Set the correct index selected.
		this.searchOptionsManager.setSelectedIndex(flotChartDataItem.metaData.searchIndexId);				
		
		this.searchOptionsManager.setSelectedDataSource(flotChartDataItem.dataSourceInfoJsons,flotChartDataItem.metaData.searchIndexId,this.searchOptionsManager);
		 
		this.searchOptionsManager.updateSearchOptionsState2(flotChartDataItem.metaData.startDateSearchOpt,flotChartDataItem.metaData.endDateSearchOpt,flotChartDataItem.metaData.xAxisDataType,flotChartDataItem.metaData.dateLabel);
	
	};
	
	
	DataDisplayManager.prototype.reloadCurrentLogData=function()
	{
		
		var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();
		var pageNumber=this.chartInfoManager.getLogPageNumberState(chartInfoId);
		pageNumber=parseInt(pageNumber);
		this.handlePagenationChange(pageNumber);
	}
	
	//Method called when pagination on change event occurs.
	DataDisplayManager.prototype.handlePagenationChange=function(pageNumber)
	{
		
		if(this.tailDataManager.isTailActive())
		{
			$("#tail21").removeClass('buttonSelectedTail');
			$("#tailpause21").removeClass('buttonSelected');
			$('#tailButtonList').hide();
			this.tailDataManager.stopTail();	
		}
		
		if(this.flaggedDataManager.isFlaggedActive())
		{
			this.flaggedDataManager.flaggedDataHidden();
		}
		
		var index=parseInt(pageNumber);
		var chartInfoId=this.chartInfoManager.getCurrentChartInfoId();

		//Save the PageNumber state for chartInfo logData
		this.chartInfoManager.saveLogPageNumberState(pageNumber, chartInfoId);
		//Note that the load log data response handler is the paginationManager.
		this.logDataManager.showLogDataSpinner();
		this.communicationsManager.loadLogData(this,index,chartInfoId);
	};

	
	
$(document).ready(function() {
	dataDisplayManager=new DataDisplayManager();
	dataDisplayManager.initialize();
	dataDisplayManagerGlobal=dataDisplayManager;
});

	
function getURLParameter(name)
{
 return decodeURI((RegExp(name+'='+'(.+?)(&|$)').exec(location.search)||[,null])[1]);
}

//Method that handles clicks on the search(Go) button.
DataDisplayManager.prototype.handleSearchRequest=function (dataDisplayManager)
{
	return function (event)
	{
		//Get values from search options.
		var startDate=dataDisplayManager.searchOptionsManager.getStartDate();
		var endDate=dataDisplayManager.searchOptionsManager.getEndDate();
		var dataCollectionId=dataDisplayManager.searchOptionsManager.getDataCollectionId();
		var dataSourceInfoId=dataDisplayManager.searchOptionsManager.getDataSourceInfoId();
		var xAxisDataType=dataDisplayManager.searchOptionsManager.xAxisDataType();
		//Set values on the search form.
		$('#srch_action').val('search');
		
		if(startDate!=null)
		{
			$('#srch_startDate').val(startDate);	
		}
		if(endDate!=null)
			{
				$('#srch_endDate').val(endDate);
			}
		
		if(xAxisDataType!=null)
		{
			$('#xAxisDataType').val(xAxisDataType);
		}
		
		//Set the search index id.
		if(dataCollectionId!=null)
		{
				$('#srch_index').val(dataCollectionId);
		}
		
		if(dataSourceInfoId!=null)
		{
			$('#dataSourceInfoId').val(dataSourceInfoId);
		}
		
		var requestCount=getURLParameterRequestCount();
		
		$('#requestCount').val(requestCount);
	
		dataDisplayManager.communicationsManager.search();

		
		
		
		event.preventDefault();
		return false;
	};
};




