	//Class that handles display of the log data menu.
	function LogDataEntryMenuManager(logDataManager)
	{
		this.logDataManager=logDataManager;
		this.menuVisible=false;
		this.cursorOnMenu=false;
		this.currentMenuTrigger=null;
		
		logDataEntryMenuManager=this;
		
		 $(document).one("click", function() {
			 logDataEntryMenuManager.hideMenu(false, logDataEntryMenuManager);
			});
		 this.initializeHandlers();
		 this.initializeLogDataEntryMenuHandlers();
				 
	};

//Called after the logDataEntryMenu.jsp is loaded. Happens after add log entry to report.	
	LogDataEntryMenuManager.prototype.initializeLogDataEntryMenuHandlers=function()
	{
		$('#selectedReportClose').button({
			icons : {
				primary : "ui-icon-circle-close",
				label: "Cancel current report selection"
			},
			text : false
		});

		$('#selectedReportClose').click(function(event){
			
			$('#selectedReport').remove();
			$.removeCookie('addToReportId',{path: '/' });
			
//			logDataEntryMenuManager.menuVisible=false;
//			logDataEntryMenuManager.cursorOnMenu=false;
//			$("#logDataEntryMenu").hide();
			
		});
	}
	
	LogDataEntryMenuManager.prototype.initializeHandlers=function()
	{

		$('#help21').tooltip({
			tooltipClass:'tooltipHelp',
			content: function() {
		          return "<img src='/images/help/searchMenuHelp.png'/>";
		      }
		    });
		
		
		logDataEntryMenuManager=this;
		
		$('body').on('mouseenter','#logDataEntryMenu',function(event){ logDataEntryMenuManager.cursorOnMenu=true;});
		
		$('body').on('mouseleave','#logDataEntryMenu',function(event){ 
			logDataEntryMenuManager.cursorOnMenu=false;
			logDataEntryMenuManager.hideMenu(false,logDataEntryMenuManager);
		});
		
		$('body').on('click touchend',"span[id^='swatch']",function(event){
			 logDataEntryMenuManager.pauseTail(logDataEntryMenuManager.logDataManager);
			 logDataEntryMenuManager.handleSwatchClick(event,this,logDataEntryMenuManager);
			 logDataEntryMenuManager.cursorOnMenu=false;
			 logDataEntryMenuManager.hideMenu(false,logDataEntryMenuManager);
		});

		$('body').on('click touchend',"span[id^='near']",function(event){
			 logDataEntryMenuManager.pauseTail(logDataEntryMenuManager.logDataManager);
			 logDataEntryMenuManager.handleNearByLogClick(event,this,logDataEntryMenuManager);
			 logDataEntryMenuManager.cursorOnMenu=false;
			 logDataEntryMenuManager.hideMenu(false,logDataEntryMenuManager);
		 });
		
		$('body').on('click touchend',"span[id^='save2']",function(event){
			logDataEntryMenuManager.pauseTail(logDataEntryMenuManager.logDataManager);
			logDataEntryMenuManager.handleSaveClick(event,logDataEntryMenuManager);
			 logDataEntryMenuManager.cursorOnMenu=false;
			 logDataEntryMenuManager.hideMenu(false,logDataEntryMenuManager);
		 });
		
		$('body').on('click touchend',"span[id^='close2']",function(event){
			 logDataEntryMenuManager.pauseTail(logDataEntryMenuManager.logDataManager);
			 logDataEntryMenuManager.handleCloseNearByLogClick(event,logDataEntryMenuManager);
			 logDataEntryMenuManager.cursorOnMenu=false;
			 logDataEntryMenuManager.hideMenu(false,logDataEntryMenuManager);
		 });
		
		$('body').on('click touchend',"#tail21",this.handleTailStartClick(this.logDataManager));
		$('body').on('click touchend',"#tailpause21",this.handleTailPauseClick(this.logDataManager));
		$('body').on('click touchend',"#tailplay21",this.handleTailPlayClick(this.logDataManager));
		$('body').on('click touchend',"#tailclear21",this.handleTailClearClick(this.logDataManager));
		$('body').on('click touchend',"#flagged21",this.handleFlaggedEntryClick(this.logDataManager));
		$('body').on('click touchend',"#flaggedClear21",this.handleFlaggedEntryClearClick(this.logDataManager));
		$('body').on('click touchend',"#download21",this.handleDownloadClick(this.logDataManager));
		
	};


	LogDataEntryMenuManager.prototype.handleDownloadClick=function(logDataManager)
	{
		return function(event)
		{
			var logEntryStates=logDataManager.getCurrentLogEntryStates();
			$('#download_json').val(JSON.stringify(logEntryStates));
			$('#download_form').submit();
		}
	}
	
	LogDataEntryMenuManager.prototype.handleFlaggedEntryClearClick=function(logDataManager)
	{
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;	
			dataDisplayManager.flaggedDataManager.clearFlaggedData();
		}
		
	}

	LogDataEntryMenuManager.prototype.handleFlaggedEntryClick=function(logDataManager)
	{
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;
			var flaggedActive=dataDisplayManager.flaggedDataManager.isFlaggedActive();
			if(flaggedActive==false)
			{
				$("#flagged21").addClass('buttonSelected');
				dataDisplayManager.flaggedDataManager.displayFlaggedData();
			}
			else
			{
				dataDisplayManager.reloadCurrentLogData();
				dataDisplayManager.flaggedDataManager.flaggedDataHidden();
			}			
		};

	}
	
	LogDataEntryMenuManager.prototype.handleTailPlayClick=function(logDataManager)
	{
		
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;
			var tailPaused=dataDisplayManager.tailDataManager.isTailPaused();
			if (tailPaused==true)
			{
				$("#tailpause21").removeClass('buttonSelected');
				$("#tail21").addClass('buttonSelectedTail');
				dataDisplayManager.tailDataManager.continueTail();
				dataDisplayManager.logDataManager.setDisplayMenuTrigger(false);
			}
		};
	
	}


	

	LogDataEntryMenuManager.prototype.handleTailPauseClick=function(logDataManager)
	{
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;
			var tailPaused=dataDisplayManager.tailDataManager.isTailPaused();
			
			if(tailPaused==false)
			{
				logDataManager.logDataEntryMenuManager.pauseTail(logDataManager);	
			}
			else if(tailPaused==true)
			{
				$("#tailpause21").removeClass('buttonSelected');
				$("#tail21").addClass('buttonSelectedTail');
				dataDisplayManager.tailDataManager.continueTail();
				dataDisplayManager.logDataManager.setDisplayMenuTrigger(false);
			}
		};
	
	}
	
	
	LogDataEntryMenuManager.prototype.pauseTail=function(logDataManager)
	{
		var dataDisplayManager=logDataManager.dataDisplayManager;
		var tailPaused=dataDisplayManager.tailDataManager.isTailPaused();
		if(tailPaused==false)
		{
			$("#tailpause21").addClass('buttonSelected');
			$("#tail21").removeClass('buttonSelectedTail');
			
			var chartInfoId=dataDisplayManager.chartInfoManager.getCurrentChartInfoId();
			dataDisplayManager.tailDataManager.setCurrentChartInfoId(chartInfoId);
			var color=dataDisplayManager.chartManager.getSeriesColorForChartInfoId(chartInfoId);

			dataDisplayManager.tailDataManager.setColor(color);

			dataDisplayManager.tailDataManager.pauseTail();
			dataDisplayManager.logDataManager.setDisplayMenuTrigger(true);
			notifyUser("Message", 'Tail paused.', 2000,false);
		}
	}
	
	LogDataEntryMenuManager.prototype.handleTailClearClick=function(logDataManager)
	{
		
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;
			dataDisplayManager.logDataManager.clearLogs();
			notifyUser("Message", 'Cleared tail data.', 2000,false);
		};
	
	}

	
	
	LogDataEntryMenuManager.prototype.handleTailStartClick=function(logDataManager)
	{
		
		return function(event)
		{
			var dataDisplayManager=logDataManager.dataDisplayManager;	
			var displayTailInfo=dataDisplayManager.tailDataManager.isTailActive();
			dataDisplayManager.flaggedDataManager.flaggedDataHidden();
			if(displayTailInfo==false)
			{
				$("#tail21").addClass('buttonSelectedTail');
				$("#tailpause21").removeClass('buttonSelected');
				dataDisplayManager.logDataManager.clearLogs();
				var chartInfoId=dataDisplayManager.chartInfoManager.getCurrentChartInfoId();
				dataDisplayManager.tailDataManager.setCurrentChartInfoId(chartInfoId);
				var color=dataDisplayManager.chartManager.getSeriesColorForChartInfoId(chartInfoId);
				dataDisplayManager.tailDataManager.setColor(color);
				dataDisplayManager.tailDataManager.startTail();
				dataDisplayManager.logDataManager.setDisplayMenuTrigger(false);
				$('#tailButtonList').show();
			}
			else
			{
				$("#tail21").removeClass('buttonSelectedTail');
				$("#tailpause21").removeClass('buttonSelected');
				dataDisplayManager.tailDataManager.stopTail();
				dataDisplayManager.logDataManager.setDisplayMenuTrigger(true);
				$('#tailButtonList').hide();
			}
			
			
		};
	
	};
	
	
	LogDataEntryMenuManager.prototype.handleSaveClick=function(event,logDataEntryMenuManager)
	{
		var logDataEntryElement=$(logDataEntryMenuManager.currentMenuTrigger).closest("div[class='logDataEntry']");
		logDataEntryMenuManager.logDataManager.saveClickNotification(logDataEntryElement,'save2');
	};

	LogDataEntryMenuManager.prototype.handleCloseNearByLogClick=function(event,logDataEntryMenuManager)
	{
		var logDataEntryElement=$(logDataEntryMenuManager.currentMenuTrigger).closest("div[class='logDataEntry']");
		logDataEntryMenuManager.logDataManager.closeNearByLogNotification(logDataEntryElement);
	};
	
	LogDataEntryMenuManager.prototype.handleSwatchClick=function(event,swatch,logDataEntryMenuManager)
	{
		var swatchColor=$(swatch).children("input").attr("value");
		var swatchId=$(swatch).attr("id");
		var logDataEntryElement=$(logDataEntryMenuManager.currentMenuTrigger).closest("div[class='logDataEntry']");
		logDataEntryMenuManager.logDataManager.swatchSelectionNotification(swatchColor,logDataEntryElement,swatchId);
	};

	LogDataEntryMenuManager.prototype.handleNearByLogClick=function(event,swatch,logDataEntryMenuManager)
	{
		var id=$(swatch).attr("id");
		var logDataEntryElement=$(logDataEntryMenuManager.currentMenuTrigger).closest("div[class='logDataEntry']");
		
		logDataEntryMenuManager.logDataManager.nearByLogRequestNotification(id,logDataEntryElement);
		
		
	};

	
	LogDataEntryMenuManager.prototype.initialize=function()
	{
		var logDataEntryMenuManager=this;
		
		$('#logData').on("mouseenter",".menuTrigger,.entrySavedTrigger",function(event){ logDataEntryMenuManager.displayMenu(this,logDataEntryMenuManager);});
		$('#logData').on("mouseleave",".menuTrigger,.entrySavedTrigger",function(event){ 
			
			var mouseExitThroughSide=false;
			var bottom=$(this).offset().top + $(this).outerHeight();
			var top=$(this).offset().top;
			var right=$(this).offset().left + $(this).outerWidth();
			
			if(event.pageY >=(top) && event.pageY<=(bottom+4) && event.pageX>=(right-4))
			{
				mouseExitThroughSide=true;
			}
			logDataEntryMenuManager.hideMenu(mouseExitThroughSide,logDataEntryMenuManager);
		});

	};
	
	LogDataEntryMenuManager.prototype.displayMenu=function(menuTrigger,logDataEntryMenuManager)
	{

		if(logDataEntryMenuManager.menuVisible==false && logDataEntryMenuManager.cursorOnMenu==false)
		{
				logDataEntryMenuManager.currentMenuTrigger=menuTrigger;
				var offset=$(menuTrigger).offset();
				
//			    var left  =offset.left  + "px";
//			    var top   =(offset.top+$(menuTrigger).outerHeight()-1)  + "px";

			    var left  =(offset.left+$(menuTrigger).outerWidth()-1)  + "px";
			    var top   =offset.top+ "px";

			    
			    var div = document.getElementById("logDataEntryMenu");
	
			    div.style.left = left;
			    div.style.top = top;
			    
				logDataEntryMenuManager.menuVisible=true;
				var logDataEntryElement=$(logDataEntryMenuManager.currentMenuTrigger).closest("div[class='logDataEntry']");
				var resultDataUnit=$(logDataEntryElement).data('resultDataUnit');
				
				var dataSourceName=resultDataUnit.dataSourceName;
				if(dataSourceName.length>60)
				{
					dataSourceName='...'+dataSourceName.substring(50);
				}
				
				$('#nearbefore').attr('title',$('#nearbefore').attr('titleText')+dataSourceName);
				$('#nearafter').attr('title',$('#nearafter').attr('titleText')+dataSourceName);
				$('#nearbeforeall').attr('title',$('#nearbeforeall').attr('titleText'));
				$('#nearafterall').attr('title',$('#nearafterall').attr('titleText'));
				$("#logDataEntryMenu").show();
		}
	};

	LogDataEntryMenuManager.prototype.hideMenu=function(mouseExitThroughtRightSide,logDataEntryMenuManager)
	{
		if(logDataEntryMenuManager.menuVisible==true && logDataEntryMenuManager.cursorOnMenu==false && mouseExitThroughtRightSide==false)
		{
			logDataEntryMenuManager.menuVisible=false;
			$("#logDataEntryMenu").hide();
		}
	};

	
	LogDataEntryMenuManager.prototype.isMenuVisible=function()
	{
		return this.menuVisible;
	};
	
	