var  logDataFullyLoadedSelTest=false;

//Class that handles display of  data
	function LogDataManager(communicationsManager,dataDisplayManager)
	{
		this.displayExtraInfo=false;
		this.menuTriggerVisible=false;
		this.logDataEntryMenuManager=new LogDataEntryMenuManager(this);
		this.addLogEntryToReportDialog=new AddLogEntryToReportDialog(communicationsManager,this);
		this.advancedNearBySearchDialog=new AdvancedNearbySearchDialog(communicationsManager,this);
		this.communicationsManager=communicationsManager;
		this.dataDisplayManager=dataDisplayManager;
		this.jsonResponse=null;
		this.activeMultiSelectName=null;
		this.multiSelectObjects=new Array();
		this.splitChars='[](){}*<>;:,"? |&=/.-';
		this.spanStart='<span class="ele">';
		this.tailNoDataCount=0;
		this.dispMenuTrigger=true;
		this.spanEnd='</span>';
		this.currentNearByLogType='UNKNOWN';
		String.prototype.splice = function( idx, rem, s ) {
		    return (this.slice(0,idx) + s + this.slice(idx + Math.abs(rem)));
		};


		this.lastLogDataEntryMenuTriggerSelected=null;

	}

	
	
	LogDataManager.prototype.initialize=function()
	{
		
		var logDataManager=this;

		
		$("body").on('click','.moreButton',this.handleMoreClick(this));
		$("body").on('click','.lessButton',this.handleLessClick(this));

		$("body").on('click','.ele',this.handleLogDataClick(this));
		
		$("body").on('mouseenter','.ele',function(event){
			if(!logDataManager.isMultiSelectActive())
			{
				$(this).css("background-color","#D8DD83");	
			}
		});

		$("body").on('mouseleave','.ele',function(event){

			if(!logDataManager.isMultiSelectActive())
			{
				$(this).css("background-color","transparent");	
			}
		});

		
		$('body').on("mouseenter",".logDataEntry",function(event){ 
			logDataManager.displayMenuTrigger(this); 
		});
		
		$('body').on("mouseleave",".logDataEntry",function(event){ logDataManager.hideMenuTrigger(this);});
		
		$('body').on("mouseenter",".multiSel",function(event){
			var logDataEntry=$(this).closest("div[class='logDataEntry']");
			logDataManager.handleMultiSelect(logDataEntry,$(this));
		});

		//Complete multiselect.
		$("body").on('click','#logData',function(event)
		{
			if(logDataManager.isMultiSelectActive())
			{
				logDataManager.handleMultiSelectComplete();
				event.preventDefault();
				
				$.each($('.multiSel'), function(i, multiSel) {
					$(multiSel).removeClass("logDataEntrySelectMode");
					$(multiSel).removeClass("logDataEntrySelected");
				});
			}
		});


		//Complete multiselect
		$("body").on('mouseleave','#logData',function(event)
		{
			if(logDataManager.isMultiSelectActive())
			{
				logDataManager.handleMultiSelectComplete();
				event.preventDefault();
				
				$.each($('.multiSel'), function(i, multiSel) {
					$(multiSel).removeClass("logDataEntrySelectMode");
					$(multiSel).removeClass("logDataEntrySelected");
				});

			}
		});
		
		$("body").on('mouseenter','.dsIcon',function(event)
		{
			var dsIcon=this;
			$(this).tooltip({
				tooltipClass:'dsIconHelp',
				content: function() {
						var html='<div class="dsIconHelpInner">'+$(dsIcon).parent().find('.extraLogInfo').html()+'</div>';
					
						return html;
			      }
			});
			
			$(this).tooltip('open');
			
		});

		$("body").on('mouseleave','.dsIcon',function(event)
		{
			$(this).tooltip('destroy');
			
		});
		
		$("body").on('click','.dsIcon',function(event)
		{
					var dsIcon=this;
					$(dsIcon).parent().find('.extraLogInfo').show();
		
		});
		
	}
	
	LogDataManager.prototype.setDisplayMenuTrigger=function(display)
	{
		this.dispMenuTrigger=display;
	}
	
	LogDataManager.prototype.isDisplayExtraInfo=function()
	{
		return this.displayExtraInfo;
	};
	
	LogDataManager.prototype.loadLogData=function(pageNumber,chartDataNumber)
	{
		//Used for selenium tests.
		logDataFullyLoadedSelTest=false;
		this.communicationsManager.loadLogData(this,pageNumber,chartDataNumber);
		
	};
	
	

	LogDataManager.prototype.handleLoadLogDataUnitResponse=function(logDataManager,logEntryClicked,moreClick)
	{
		return function (resultDataUnitPage)
		{
			
			var logDataDataElement=$(logEntryClicked).closest(".logDataData");
			
			var backupHTML=logDataDataElement.html();
			logDataDataElement.data("backupHTML",backupHTML);
			logDataDataElement.empty();
			if(moreClick==true)
			{
				var lessButton='<a class="lessButton" href="">less</a>';
				var content=logDataManager.highlight(resultDataUnitPage.resultContentFull, logDataManager.spanStart, logDataManager.spanEnd);
				logDataDataElement.html(content+lessButton);
			}
			else
			{
				var moreButton='.....<a class="moreButton" href="">more</a>';
				var content=logDataManager.highlight(resultDataUnitPage.resultContent, logDataManager.spanStart, logDataManager.spanEnd);
				logDataDataElement.html(content+moreButton);
			}
			
		};
	};

	
	LogDataManager.prototype.handleMultiSelectStart=function(swatchColor,logDataEntryElement,swatchId)
	{
		this.multiSelectObjects.length=0;
		this.activeMultiSelectName=swatchId;
		this.currentSwatchColor=swatchColor;
		$.each($('.multiSel'), function(i, multiSel) {
			$(multiSel).addClass("logDataEntrySelectMode");
		});
		
		
		
	}
	
	LogDataManager.prototype.handleMultiSelectStartSave=function(logDataEntryElement,id)
	{
		this.multiSelectObjects.length=0;
		this.activeMultiSelectName=id;

		$.each($('.multiSel'), function(i, multiSel) {
			$(multiSel).addClass("logDataEntrySelectMode");
		});
		
		
		
	}

	
	//Method called to notify of a swatch selection.
	LogDataManager.prototype.swatchSelectionNotification=function(swatchColor,logDataEntryElement,swatchId)
	{
		this.handleMultiSelectStart(swatchColor, logDataEntryElement, swatchId);
		notifyUser("Message",'Mouse over to select, click to complete.', 4000,false);
//		var logEntryState=logDataEntryElement.data('logEntryState');
//		logEntryState.colorCode=swatchColor;
//		if(swatchColor=='#FFFFFF')
//		{
//			logEntryState.flagged=false;
//		}
//		else
//		{
//			logEntryState.flagged=true;
//		}
//		var logEntryStates=[logEntryState];
//		this.saveLogEntryState(logEntryStates);
	};

	LogDataManager.prototype.isMultiSelectActive=function()
	{
		if(this.activeMultiSelectName!=null)
		{
				return true;
		}
		return false;
	};

	
	//Method called when there is a advanced search request for near by elements from advancedNearBySearchDialog.js
	LogDataManager.prototype.nearByLogRequestAdvancedNotification=function(params)
	{
		$("body").toggleClass("wait");
		this.communicationsManager.getNearByLogData(params.logEntryId,params.chartInfoId,params.beforeOrAfter,params.nearByLogType,params.numResults,params.intervalInSeconds,this,params.resultDataUnit,params.selectedDSIds);
	}

	//Method called when request for near by element is made.
	LogDataManager.prototype.nearByLogRequestNotification=function(id,logDataEntryElement)
	{
		var logEntryState=logDataEntryElement.data('logEntryState');
		var resultDataUnit=logDataEntryElement.data('resultDataUnit');
		var order=logDataEntryElement.data('order');
		
		if(logEntryState)//Log entry state can be undefined if the menu is for a entry that has been deleted.
		{
			var logEntryId=logEntryState.encryptedLogDataIdentifier;
			var beforeOrAfter="after";
			var nearByLogType='FROMDS';
			var numResults=20;
			var intervalInSeconds=30;
			var chartInfoId=null;
			
			if(id.indexOf('before') > -1)
			{
				beforeOrAfter="before";
			}

			//If the order is descending, swap the before/after.
			if(order=='descending' || logDataDescendingOrder==true)
			{
				if(beforeOrAfter=='before')
				{
					beforeOrAfter='after';
				}
				else
				{
					beforeOrAfter="before";	
				}
			}

			
			var chartInfoId=this.dataDisplayManager.chartInfoManager.getCurrentChartInfoId();
			
			if(id.indexOf('all') > -1)
			{
				nearByLogType="FROMDC";
				var params=new Object();
				params.logEntryId=logEntryId;
				params.chartInfoId=chartInfoId;
				params.nearByLogType=nearByLogType;
				params.beforeOrAfter=beforeOrAfter;
				params.numResults=numResults;
				params.intervalInSeconds=intervalInSeconds;
				params.resultDataUnit=resultDataUnit;
				
				this.advancedNearBySearchDialog.showDialog(params);
			
			
			}
			else
			{
				$("body").toggleClass("wait");
				this.communicationsManager.getNearByLogData(logEntryId,chartInfoId,beforeOrAfter,nearByLogType,numResults,intervalInSeconds,this,resultDataUnit);
			}
			
		}
		
	
	};
	
	LogDataManager.prototype.findDivToPrependNearByData=function(allDivStartIndex,allLogDataEntryDivs,nearByDataLineNumber,nearByDateInMillis,order)
	{
		
		var result=new Object();
		result.matchFound=false;
		$.each(allLogDataEntryDivs, function(i, logEntryDiv) {
			
			if(order=='ascending')
			{
				if(i>=allDivStartIndex)
				{
					var resultDataUnitExisting=$(logEntryDiv).data('resultDataUnit');
					if(resultDataUnitExisting.dateInMillis>=nearByDateInMillis)
					{
						
						if(resultDataUnitExisting.dateInMillis==nearByDateInMillis)
						{
							if(resultDataUnitExisting.dataLineNumber<nearByDataLineNumber) //If the dates are equal and line number of existing entry is less than nearByEntry
							{																//then we have not found the div to prepend. 
								return true;//Same as continue.
							}
						}
						
						
						result.existingDivDataLineNumber=resultDataUnitExisting.dataLineNumber;
						result.existingDivDateInMillis=resultDataUnitExisting.dateInMillis;
						result.existingLogEntryDiv=logEntryDiv;
						result.matchFound=true;
						result.matchedIndex=i;
						return false;
					}
				}
				
			}
			else if(order=='descending')
			{
				if(i>=allDivStartIndex)
				{
					var resultDataUnitExisting=$(logEntryDiv).data('resultDataUnit');
					if(resultDataUnitExisting.dateInMillis<=nearByDateInMillis)
					{
						
						if(resultDataUnitExisting.dateInMillis==nearByDateInMillis)
						{
							if(resultDataUnitExisting.dataLineNumber>nearByDataLineNumber) //If the dates are equal and line number of existing entry is less than nearByEntry
							{																//then we have not found the div to prepend. 
								return true;//Same as continue.
							}
						}
						
						
						result.existingDivDataLineNumber=resultDataUnitExisting.dataLineNumber;
						result.existingDivDateInMillis=resultDataUnitExisting.dateInMillis;
						result.existingLogEntryDiv=logEntryDiv;
						result.matchFound=true;
						result.matchedIndex=i;
						return false;
					}
				}
				
			}
			
			
		});
		
		return result;
	};
	
	
	LogDataManager.prototype.displayTailResults=function(response,color)
	{
		var logDataManager=this;
		var tailResults=response.resultDataUnits;
		var allLogDataEntryDivs=$('.logDataEntry');
		var firstLogDataEntry=null;
		var numEntriesToDisplay=600;
		if(allLogDataEntryDivs.length>0)
		{
			firstLogDataEntry=allLogDataEntryDivs.first();
		}
		
		var firstLogEntryResultDataUnit=null;
		if(firstLogDataEntry!=null)
		{
			firstLogEntryResultDataUnit=firstLogDataEntry.data('resultDataUnit');
		}

		var numNewEntries=0;
		var resultsUnitsToDisplay=new Array();
		//Find the results to display. The highest date is first, lowest date is last.
		$.each(tailResults, function(i, tailResultDataUnit) {
			
			if(firstLogEntryResultDataUnit !=null && tailResultDataUnit.resultData.logDataIdentifier==firstLogEntryResultDataUnit.logDataIdentifier)
			{
				//Stop the loop.
				return false;
			}//new entries should not be before previous entries.
			else
			{
				resultsUnitsToDisplay.push(tailResultDataUnit);	
			}
			
			
		});
		
		resultsUnitsToDisplay=resultsUnitsToDisplay.reverse();
		
		$.each(resultsUnitsToDisplay, function(i, tailResultDataUnit) {
		
			var logEntryElement=logDataManager.getLogEntryElement(tailResultDataUnit);
			numNewEntries+=1;
			//$('#logData').prepend(logEntryElement);
			var  $newLogEntry=$(logEntryElement).prependTo('#logData');
			//$newLogEntry.css('color',color);
			$newLogEntry.data('order','descending');
			
		});

		if(debugInfoOnPage==true)
		{
			$('#logData').prepend('<div class="debugInfoTail">--debugInfoOnPage:true numNewEntries:'+numNewEntries+'--totalEntriesReturned:'+tailResults.length+'--</div>');	
		}

		//If there are more than a 1000 elements remove excess elements.
		if(allLogDataEntryDivs.length>numEntriesToDisplay)
		{
			//Remove all siblings.
			$(allLogDataEntryDivs[numEntriesToDisplay-200]).nextAll().remove();
		}

		
		if(numNewEntries==0)
		{
			logDataManager.tailNoDataCount+=1;
			//notifyUser("Message", 'No new data in tail.', 1500,false);
			if(logDataManager.tailNoDataCount%1==0)
			{
				//Remove if entries get over 1000.
				var allNoTailData=$('.noTailData');
				if(allNoTailData.length>numEntriesToDisplay)
				{
					$(allNoTailData[numEntriesToDisplay]).nextAll().remove();
				}
				
				//Code to make sure that the No new matching data message does not keep repeating multiple times - START
				$('#logData').children('div').each(function(){
					var className=$(this).attr('class');
					if(className!='noTailData' && className!='debugInfoTail')
					{
							return false;//Same as break.
					}
					else //If element is noTailData
					{
						$(this).remove();
					}
					
				});
				//Code to make sure that the No new matching data message does not keep repeating multiple times - END
				
				$('#logData').prepend('<div class="noTailData">No new matching data ('+response.currentDisplayTime+')</div>');	
			}
			return;
		}

		if(response.entriesSkipped==true)
		{
			logDataManager.entriesSkippedCount+=1;
			if(logDataManager.entriesSkippedCount%1==0)
			{
				//Remove if entries get over 1000.
				var alldataSkipped=$('.dataSkipped');
				if(alldataSkipped.length>numEntriesToDisplay)
				{
					$(allLogDataEntryDivs[numEntriesToDisplay]).nextAll().remove();
				}

				
				$('#logData').prepend('<div class="dataSkipped">Some entries possibly skipped, too much data to tail.</div>');	
			}
			
		}
		
		if(logDataManager.displayExtraInfo==true)
		{
			$('.extraLogInfo').show();	
		}else
		{
			$('.extraLogInfo').hide();
		}
		
		
	}
	
	
	LogDataManager.prototype.handleGetNearByLogDataResponse=function(params,resultDataUnit)
	{
		var logDataManager=this;
		return function (nearByLogDataResponse)
		{
			$("body").removeClass("wait");
			var numNewEntries=0;
			
			//If the type requested is different from what is already there.
			if(logDataManager.currentNearByLogType && nearByLogDataResponse.type!=logDataManager.currentNearByLogType)
			{
//	Commenting this out as we do not want to clean existing near by results weather the user selects fromDS or fromDC
//				$.each($('.nearByLogEntry'), function(i, nearByLogEntry) {
//					var logDataEntry=$(nearByLogEntry).closest("div[class='logDataEntry']");
//					$(logDataEntry).remove();
//				});
			}
			
			
			logDataManager.currentNearByLogType=nearByLogDataResponse.type;
			
			if(nearByLogDataResponse.error==true)
			{
				notifyUser("Message",nearByLogDataResponse.errorMessage, 3000,true);
				return;
			}
			//Merge results, insert data at appropriate place.
			var allLogDataEntryDivs=$('.logDataEntry');
			var nearByResultDataUnits=nearByLogDataResponse.resultDataUnits;
			
			
			if(!nearByResultDataUnits || nearByResultDataUnits.length==0)
			{
				notifyUser("Message", 'No data found.', 2000,false);
				return;
			}
			var firstLogEntry=null;
			//Set the order based on the order of the first entry on the page.
			var order='ascending';
			if(allLogDataEntryDivs.length>0)
			{
				firstLogEntry=allLogDataEntryDivs[0];
				order=$(firstLogEntry).data('order');
			}

			//logDataDescendingOrder is set in javaScriptConfiguration.jsp
			if(logDataDescendingOrder==true)
			{
				order='descending';
			}
			
			var allDivStartIndex=0;
			if(order!='descending') //Order is ascending.
			{
				if(params.beforeOrAfter=='before')
				{
					nearByResultDataUnits=nearByResultDataUnits.reverse();
				}				
			}
			else //Order is descending.
			{
				if(params.beforeOrAfter=='after')
				{
					nearByResultDataUnits=nearByResultDataUnits.reverse();
				}
			}
			
			$.each(nearByResultDataUnits, function(i, nearByResultDataUnit) {
				var result=logDataManager.findDivToPrependNearByData(allDivStartIndex,allLogDataEntryDivs,nearByResultDataUnit.resultData.dataLineNumber,nearByResultDataUnit.resultData.dateInMillis,order);
				
				if(result.matchFound==true)
				{
					allDivStartIndex=result.matchedIndex;
					
					if(result.existingDivDateInMillis=nearByResultDataUnit.resultData.dateInMillis && result.existingDivDataLineNumber==nearByResultDataUnit.resultData.dataLineNumber)
					{
						return true;//Same as continue.
					}
					else
					{
						numNewEntries+=1;
						var logEntryElement=logDataManager.getLogEntryElement(nearByResultDataUnit);
						var $newLogEntry=$(logEntryElement).insertBefore(result.existingLogEntryDiv);
						$newLogEntry.data('order',order);
					}
				}
				else
				{
					numNewEntries+=1;
					var logEntryElement=logDataManager.getLogEntryElement(nearByResultDataUnit);
					var $newLogEntry=$(logEntryElement).insertAfter($('.logDataEntry').last());
					$newLogEntry.data('order',order);
				}
				
			});
			
			if(numNewEntries > 0)
			{
				if(logDataManager.displayExtraInfo==true)
				{
					$('.extraLogInfo').show();	
				}else
				{
					$('.extraLogInfo').hide();
				}
				
				notifyUserSmall(numNewEntries+" new entries fetched.",1400);	
			}
			else
			{
				notifyUserSmall(numNewEntries+" new entries fetched.",1400);
			}
			
			
		};
	};
	


	LogDataManager.prototype.saveClickNotification=function(logDataEntryElement,id)
	{
		notifyUser("Message",'Mouse over to select, click to complete.', 4000,false);
		this.handleMultiSelectStartSave(logDataEntryElement,id)
			
//		var identifierId=logEntryState.encryptedLogDataIdentifier;
//		
//		var selectedReportInput=$('#selectedReportId');
//		
//		if(selectedReportInput.val()) //A report id has been selected.
//		{
//			//save this, so as to use the response handler.
//			this.currentLogDataEntryElement=logDataEntryElement;
//			this.communicationsManager.addLogEntryToReport(selectedReportInput.val(),[identifierId],this);
//			
//		}
//		else
//		{
//			//Show report dialog.
//			this.addLogEntryToReportDialog.setLogEntry(logDataEntryElement);
//			this.addLogEntryToReportDialog.showDialog();
//		}
		
	};

	LogDataManager.prototype.closeNearByLogNotification=function(logDataEntryElement)
	{
			var chartInfoId=this.dataDisplayManager.chartInfoManager.getCurrentChartInfoId();
			this.communicationsManager.closeNearByLogData(chartInfoId,this);

			$.each($('.nearByLogEntry'), function(i, nearByLogEntry) {
				var logDataEntry=$(nearByLogEntry).closest("div[class='logDataEntry']");
				$(logDataEntry).remove();
			});
	};

	
	LogDataManager.prototype.handleCloseNearByLogResponse=function (params)
	{
		return function(data)
		{
			notifyUser("Message",data.numResults+' related results cleared.',4000,false);
		};
	};
	
	
	
	LogDataManager.prototype.handleAddLogEntryToReportResponse=function (logDataManager,logEntryStates)
	{
		return function(data)
		{
			
			if(data.error==true)
			{
				notifyUser("Error",data.errorMessage,5000,true);
			}
			else
			{
				var reportName=$('#selectedReportName').text();
				var message='Saved to report: '+data.dashboardName+', total entries:'+data.numDashboardEntries;
				notifyUser('Message', message,3000,false);
				
				var ids=new Array();
				for ( var n = 0; n < logEntryStates.length; n++) {
					ids.push(logEntryStates[n].encryptedLogDataIdentifier);
					logEntryStates[n].saved=true;
				}
				
				logDataManager.saveLogEntryState(logEntryStates);
			}

		};
		
	};

	
	
	LogDataManager.prototype.saveLogEntryState=function(logEntryStates)
	{
		this.communicationsManager.saveLogEntryState(logEntryStates,this);
	};

	
	LogDataManager.prototype.handleLogDataClick=function(logDataManager)
	{
		return function(event)
		{

			if(!logDataManager.isMultiSelectActive())
			{
				var searchTerm=$(this).text();
				var currentSearchTerm=$("#search_input").val();
				$("#search_input").val(currentSearchTerm+' '+searchTerm);
				//Simulate the click event.
				$("#search_submit").click();
			}

		};
		
	};
	

	LogDataManager.prototype.handleSaveLogEntryStateResponse=function()
	{
		var logDataManager=this;
		return function(response)
		{
				$("#flaggedText21").text(response.numberOfFlaggedEntries);	
		};
	}
	
	LogDataManager.prototype.handleLessClick=function(logDataManager)
	{
		return function(event){
			event.preventDefault();
			var logDataEntry=$(this).closest("div[class='logDataData']");
			var backupHTML=logDataEntry.data("backupHTML");
			
			var logDataEntryElement=$(this).closest("div[class='logDataEntry']");
			var logEntryState=logDataEntryElement.data("logEntryState");
			var savedDocViewTop=logDataEntryElement.data("moreClickDocViewTop");
			logEntryState.displayMore=false;

			logDataManager.saveLogEntryState([logEntryState]);
			
			if(backupHTML)
			{
				var backup=logDataEntry.html();
				logDataEntry.data("backupHTML",backup);
				logDataEntry.empty();
				logDataEntry.html(backupHTML);
			}
			else
			{
				logDataManager.communicationsManager.loadLogDataUnit(logDataManager,logEntryState.encryptedLogDataIdentifier,this,false);	
			}
			
			
			var docViewTop = $(window).scrollTop();
			var elementTop=logDataEntryElement.offset().top; 
		    if(elementTop<docViewTop)
		    {
				$('html, body').animate({
			        scrollTop: savedDocViewTop
			    }, 10,function(){
			    	//logDataEntryElement.toggle("shake",{times:1,distance:3});
			    	logDataEntryElement.toggle("highlight",{color:'#fefefe'});	
			    });
				
		    }
		    
			//This is to hide the MenuTrigger when less option is clicked. 
			logDataManager.hideMenuTrigger(logDataManager.lastLogDataEntryMenuTriggerSelected);
		};
	};

	LogDataManager.prototype.handleMoreClick=function(logDataManager)
	{
		return function (event)
		{
			event.preventDefault();
			//If data has been saved.
			var logDataEntry=$(this).closest("div[class='logDataData']");
			var backupHTML=logDataEntry.data("backupHTML");
			
			var logDataEntryElement=$(this).closest("div[class='logDataEntry']");
			var logEntryState=logDataEntryElement.data("logEntryState");
			var docViewTop = $(window).scrollTop();
			logDataEntryElement.data("moreClickDocViewTop",docViewTop);
			logEntryState.displayMore=true;
			logEntryState.fullContentLoaded=true;
			
			logDataManager.saveLogEntryState([logEntryState]);
			
			if(backupHTML)
			{
				var backup=logDataEntry.html();
				logDataEntry.data("backupHTML",backup);
				logDataEntry.empty();
				logDataEntry.html(backupHTML);
			}
			else
			{
				var logDataIdentifier=logEntryState.encryptedLogDataIdentifier;
				logDataManager.communicationsManager.loadLogDataUnit(logDataManager,logDataIdentifier,this,true);
			}
			
			
		};
	};

	
	LogDataManager.prototype.toggleExtraInfo=function()
	{
		
		if($('.extraLogInfo').is(':visible')) {
			$('.extraLogInfo').hide();
			this.displayExtraInfo=false;
		}
		else
		{
			$('.extraLogInfo').show();
			this.displayExtraInfo=true;
		}
		
	};
	
	
	LogDataManager.prototype.getLogEntryElement=function(resultDataUnitExtraInfo)
	{
				var resultDataUnit=resultDataUnitExtraInfo.resultData;
				var logDataManager=this;
				var resultContent='';
				var buttonHTML='';
				//If the full content is to be displayed.
				if(resultDataUnit.logEntryState.displayMore==true)
				{
					resultContent=resultDataUnit.resultContentFull;
					if(resultDataUnit.truncatedContent==true)
					{
						buttonHTML='<a class="lessButton" href="">less</a>';
					}
				}					
				else
				{
					resultContent=resultDataUnit.resultContent;
					if(resultDataUnit.truncatedContent==true)
					{
						buttonHTML='.....<a class="moreButton" href="">more</a>';
					}
		
				}
				
			//Insert span so as to detect mouse over events.
			var content=logDataManager.highlight(resultContent, logDataManager.spanStart, logDataManager.spanEnd);
			if(displayLineNumber==true)
			{
				content = resultDataUnit.dataLineNumber+' '+content;	
			}
			
			var savedHTML='';
			var nearByClass='';
			var logEntryStyle='style="background-color:'+resultDataUnit.logEntryState.colorCode+';"';
			if(resultDataUnitExtraInfo.nearByResult==true)
			{
				nearByClass=' nearByLogEntry';
				if(resultDataUnit.logEntryState.colorCode=='#FFFFFF')
				{
					//logEntryStyle='style="background-color:'+'#f5f5f5'+';"'
				}
			}
			//Will produce number 0-19
			var dataSourceIconHTML='<div title="test" class="dsIcon sprite sprite-dc'+parseInt(resultDataUnitExtraInfo.iconNumber)%19+'"/>'
			var menuTrigger='<div class="menuTrigger"/>';
			if(resultDataUnit.logEntryState.saved==true)
			{
					savedHTML='<span class="entrySavedTrigger"></span>';
					menuTrigger=savedHTML;
			}
			
			//var content=resultDataUnit.resultContent;
			
			var extraInfo=logDataManager.getExtraInfoHTML(resultDataUnit);
		
			content='<div class="multiSel"></div><div class="logDataData'+nearByClass+'">'+content+buttonHTML+'</div>';
			
			var logEntryElement=$('<div class="logDataEntry" '+logEntryStyle+'>'+menuTrigger+dataSourceIconHTML+content+extraInfo+'</div>');
	
			logEntryElement.data("logEntryState",resultDataUnit.logEntryState);
			logEntryElement.data("resultDataUnit",resultDataUnit);
			return logEntryElement;
	}
	
	
	//Handler that is called when log data is loaded.
	LogDataManager.prototype.displayLogData=function(jsonResponse,logDataManager)
	{
		this.jsonResponse=jsonResponse;
		this.currentNearByLogType=this.jsonResponse.nearByResultsType;

		$("#logData").empty();
		var logDataManager=this;
		
		if(debugInfoOnPage==true)
		{
			var title=JSON.stringify(jsonResponse.logSearchInstanceState);
			title=title.replace(/["']/g, "");
			title=title.replace(/[,]/g, " ");
			var searchStatsHTML='<span class="senInfo senLogInfo" title="'+title+'"/>';
			$("#logData").prepend(searchStatsHTML);
		}
		
		
		
		$.each(jsonResponse.resultDataUnitForPage, function(i, resultDataUnitExtraInfo) {
			
			var resultDataUnit=null;
			if(resultDataUnitExtraInfo!=null)
			{
				resultDataUnit=resultDataUnitExtraInfo.resultData;	
			}
			
			if(resultDataUnit!=null)
				{
					var logEntryElement=logDataManager.getLogEntryElement(resultDataUnitExtraInfo);
					var  $newLogEntry=$(logEntryElement).appendTo("#logData");
					$newLogEntry.data('order','ascending');
					
				}
		});
		
		if(logDataManager.displayExtraInfo==true)
		{
			$('.extraLogInfo').show();	
		}else
		{
			$('.extraLogInfo').hide();
		}
		
		
		logDataManager.logDataEntryMenuManager.initialize();
		
	};

	
	
	//Handler that is called when log data is loaded.
	LogDataManager.prototype.displayFlaggedLogData=function(jsonResponse)
	{
		$("#logData").empty();
		var logDataManager=this;
		
		
		
		$.each(jsonResponse.resultDataUnits, function(i, resultDataUnitExtraInfo) {
			
			var resultDataUnit=null;
			if(resultDataUnitExtraInfo!=null)
			{
				resultDataUnit=resultDataUnitExtraInfo.resultData;	
			}
			
			if(resultDataUnit!=null)
				{
					var logEntryElement=logDataManager.getLogEntryElement(resultDataUnitExtraInfo);
					var  $newLogEntry=$(logEntryElement).appendTo("#logData");
					$newLogEntry.data('order','ascending');
					
				}
		});
		
		if(logDataManager.displayExtraInfo==true)
		{
			$('.extraLogInfo').show();	
		}else
		{
			$('.extraLogInfo').hide();
		}
		
		
		logDataManager.logDataEntryMenuManager.initialize();
	};
	

	LogDataManager.prototype.getCurrentLogEntryStates=function()
	{
		var logEntryStates=new Array();
		var logEntryElements=$('.logDataEntry');

		for(var n=0;n<logEntryElements.length;n++)
		{
				logEntryStates.push($(logEntryElements[n]).data('logEntryState'));
		}
		return logEntryStates;
	}
	
	LogDataManager.prototype.handleMultiSelectComplete=function()
	{
		if(this.multiSelectObjects.length>0)
		{
			var numEntries=0;
			var selectedElements=new Array();
			var logEntryStates=new Array();
			for(var n=0;n<this.multiSelectObjects.length;n++)
			{
				if(this.multiSelectObjects[n]!=null)
				{
					numEntries+=1;
					selectedElements.push(this.multiSelectObjects[n]);
					logEntryStates.push($(this.multiSelectObjects[n]).data('logEntryState'));
				}
			}
			
			if(numEntries>0)
			{
				if(this.activeMultiSelectName.indexOf('swatch')>-1)
				{
					//notifyUser("Message",'Flagged '+numEntries+' entries and saved flagged state.', 4000,false);
			    	//logDataEntryElement.toggle("shake",{times:1,distance:3});
			    	//logDataEntryElement.toggle("highlight",{color:'#fefefe'});	
			    	
					$(this.multiSelectObjects[this.multiSelectObjects.length-1]).effect( "transfer", {to:$('#flagged21')}, 500 );
//					$('#flagged21').toggle("highlight",{color:'#64dd17'});
//					$('#flagged21').toggle("highlight",{color:'#64dd17'});
					this.saveLogEntryState(logEntryStates);
				}
				else if(this.activeMultiSelectName.indexOf('save2')>-1)
				{
					this.handleSaveMultiSelectComplete(logEntryStates);
				}

			}
		}
		this.multiSelectObjects.length=0;
		this.activeMultiSelectName=null;

		
	};
	
	LogDataManager.prototype.handleSaveMultiSelectComplete=function(logEntryStates)
	{
		
		var ids=new Array();
		for ( var n = 0; n < logEntryStates.length; n++) {
			ids.push(logEntryStates[n].encryptedLogDataIdentifier);
		}
		
		
		var selectedReportInput=$('#selectedReportId');
		
		if(selectedReportInput.val()) //A report id has been selected.
		{
			//save this, so as to use the response handler.
			this.communicationsManager.addLogEntryToReport(selectedReportInput.val(),ids,logEntryStates,this);
			
		}
		else
		{
			//Show report dialog.
			this.addLogEntryToReportDialog.setLogEntryIds(ids,logEntryStates);
			this.addLogEntryToReportDialog.showDialog();
		}

		
	};
	
	
	LogDataManager.prototype.handleMultiSelect=function(logDataEntry,multiSelElement)
	{
		var logDataEntryElement=logDataEntry;
		if(this.isMultiSelectActive()==true)//background image size 157 + 20
		{
			var entryIndex=$.inArray(logDataEntry[0],this.multiSelectObjects);
			if(entryIndex!=-1)//If already exists, reverse action.
			{
				var prevLogEntryState=logDataEntryElement.data('prevLogEntryState');
				logDataEntryElement.data('logEntryState',prevLogEntryState);
				delete this.multiSelectObjects[entryIndex];
				
				if(this.activeMultiSelectName.indexOf('swatch')>-1)
				{
					logDataEntryElement.css('background-color',prevLogEntryState.colorCode);	
				}
				else if(this.activeMultiSelectName.indexOf('save2')>-1)
				{
					logDataEntryElement.children(".menuTrigger,.entrySavedTrigger").removeClass('entrySavedTrigger').addClass('menuTrigger');
					
				}
				
				multiSelElement.removeClass('logDataEntrySelected');
			}
			else
			{
				var logEntryState=logDataEntryElement.data('logEntryState');
				var logEntryStateBackup=jQuery.extend({}, logEntryState);
				logDataEntryElement.data('prevLogEntryState',logEntryStateBackup);

				if(this.activeMultiSelectName.indexOf('swatch')>-1)
				{

					logEntryState.colorCode=this.currentSwatchColor;
					if(this.currentSwatchColor=='#FFFFFF')
					{
						logEntryState.flagged=false;
					}
					else
					{
						logEntryState.flagged=true;
					}
					
					logDataEntryElement.css('background-color',this.currentSwatchColor);

				}
				else if(this.activeMultiSelectName.indexOf('save2')>-1)
				{
					logDataEntryElement.children(".menuTrigger,.entrySavedTrigger").attr('class','entrySavedTrigger');
					
				}
					
				multiSelElement.addClass('logDataEntrySelected');
				this.multiSelectObjects.push(logDataEntry[0]);
			}
		}

	};
	
	LogDataManager.prototype.displayMenuTrigger=function(logDataEntry)
	{
		if(this.dispMenuTrigger==false)
		{

			return;
		}
		//If previously selected menu trigger was different, hide it first.
		if(this.lastLogDataEntryMenuTriggerSelected && logDataEntry!=this.lastLogDataEntryMenuTriggerSelected)
		{
			this.hideMenuTrigger(this.lastLogDataEntryMenuTriggerSelected);
		}

		if(this.menuTriggerVisible==false)
		{
			this.lastLogDataEntryMenuTriggerSelected=logDataEntry;
			this.menuTriggerVisible=true;
			
			$(logDataEntry).children(".menuTrigger,.entrySavedTrigger").css('visibility','visible');
			
		}
		
	};
	
	LogDataManager.prototype.hideMenuTrigger=function(logDataEntry)
	{
		
		if(!logDataEntry)
		{
			logDataEntry=this.lastLogDataEntryMenuTriggerSelected;
		}
		if(this.menuTriggerVisible==true && this.logDataEntryMenuManager.isMenuVisible()==false)
		{
			$(logDataEntry).children(".menuTrigger").css('visibility','hidden');
			this.menuTriggerVisible=false;
			
		}
	};
	
	
	LogDataManager.prototype.getExtraInfoHTML=function(resultDataUnit)
	{
		
		var dataSourceName=resultDataUnit.dataSourceName;
		if(dataSourceName.length>40)
		{
			dataSourceName='...'+dataSourceName.substring(dataSourceName.length-40);
		}
		var info='<span class="dsName">DataSource:</span><span class="extraInfoVal">'+dataSourceName+'</span>';
		info=info+'<span class="dcName">DataCollection:</span><span class="extraInfoVal">'+resultDataUnit.dataCollectionName+'</span>';
		info=info+'<span class="dcName">StartNumber:</span><span class="extraInfoVal">'+resultDataUnit.dateInMillis+'</span>';
		info=info+'<span class="dcName">Data Source LineNumber:</span><span class="extraInfoVal">'+resultDataUnit.dataSourceLineNumber+'</span>';
		info=info+'<span class="dcName">Index LineNumber:</span><span class="extraInfoVal selTestDLN">'+resultDataUnit.dataLineNumber+'</span>';
		var extraInfo='<div class="extraLogInfo">'+info+'</div>';
		return extraInfo;

	};

	LogDataManager.prototype.clearLogs=function()
	{
		$('#logData').html('');
	};

	//Insert span around log data elements to enable mouse over events.
	LogDataManager.prototype.highlight=function(data,spanStart,spanEnd)
	{

		if(data==null)
			{
				return null;
			}
		
		var initialData=data;
		//Find position of existing spans to skip them.
		var spanPosition=this.getSpanPosition(data,0);
		var spanPositions=[];
		var insertPositions=[];
		while(spanPosition!=null)
			{
				spanPositions.push(spanPosition);
				spanPosition=this.getSpanPosition(data,spanPosition.end);
			}
		
		var spanInserted=false;
		for ( var n = 0; n < data.length; n++) {
			
			var checkForBr=data.substring(n,n+5);
			if(checkForBr=='<br/>')
			{
				n+=5;
				continue;
			}
			//For the very first character and also make sure it is not in split chars.
			if(n==0 && this.splitChars.indexOf(data.charAt(n))==-1)
				{
					var insertPosition=new Object();
					insertPosition.index=0;
					insertPosition.str=spanStart;
					insertPositions.push(insertPosition);
					spanInserted=true;
				}
			var doSplit=this.doSplit(spanPositions,n,data,spanInserted);
			
			if(doSplit==true)
			{
				var spanStr;
				if(spanInserted==true)
				{
					spanStr=spanEnd;
					spanInserted=false;
				}
				else
				{
					spanStr=spanStart;
					spanInserted=true;
				}

				var insertPosition=new Object();
				insertPosition.index=n;
				insertPosition.str=spanStr;
				insertPositions.push(insertPosition);
			}
		}
		var offset=0;
		for(var n=0;n<insertPositions.length;n++)
			{
				data=data.splice(insertPositions[n].index+offset,0,insertPositions[n].str);
				offset+=insertPositions[n].str.length;
			}
		
		//Insert a close span at the end if the last character is not in splitChars. //Make sure that last character is not the end of an existing span.
		if(data!=null && this.splitChars.indexOf(data.charAt(data.length-1))==-1 && this.checkWithinExistingSpan(spanPositions,initialData.length-1)==false)
			{
				data=data+spanEnd;
			}
		return data;
		
	};

	//Method returns the start and end of a span.
	LogDataManager.prototype.doSplit=function(spanPositions,index,data,spanInserted)
	{
		var currentChar=data.charAt(index);
		var previousChar=data.charAt(index-1);
		var nextChar=data.charAt(index+1);
		var splitChars=this.splitChars;
		//This is to make sure that soon after a span is closed another span is open. //Also make sure this is not the start of an existing span.
		if(previousChar!=null && splitChars.indexOf(currentChar)==-1 && splitChars.indexOf(previousChar)!=-1 && index!=0)
			{
			var withinSpan=false;
			
				withinSpan=this.checkWithinExistingSpan(spanPositions,index);

				if(withinSpan==false && spanInserted==false)//Span inserted flag is used to make sure that the last tag inserted was an span end </span>
					{
					return true;
					}
			}
		
		//If currentChar is not in splitChar, but is start of an existing span, and previousChar is not in splitChars.
		if(splitChars.indexOf(currentChar)==-1 && splitChars.indexOf(previousChar)==-1)
		{
			for ( var n = 0; n < spanPositions.length; n++)
			{
				//When a new existing span starts.
				if(index == spanPositions[n].start && previousChar!=null && splitChars.indexOf(previousChar==-1) && this.checkWithinExistingSpan(spanPositions,index-1)==false)
				{
						return true;
				}

				//To check if the character after span is not in splitChars.
				
				var spanLength=this.spanEnd.length;
				var afterSpan=data.charAt(spanLength);
				//If the span ends and the next character is not in split chars ,then split.
				if(index==(spanPositions[n].end+spanLength) && splitChars.indexOf(afterSpan)==-1)
				{
						return true;
				}
			}
		}
		
		if(splitChars.indexOf(currentChar)!=-1)//If the character is in splitChars.
			{
				if(previousChar!=null && previousChar.indexOf(currentChar)==-1) //The previous character should not be in splitChars.
					{
						//Check if index is within span positions.
						var withinSpan=false;
						withinSpan=this.checkWithinExistingSpan(spanPositions,index);
						//If not within span position. //Also check that we are not inserting a span at the very last character.
						if(withinSpan==false && splitChars.indexOf(previousChar)==-1 && this.checkWithinExistingSpan(spanPositions,index-1)==false)
							{
								return true;
							}
					
					}
				
			}
		
		
		return false;
	};
	
	//Method returns the start and end of a span.
	LogDataManager.prototype.getSpanPosition=function(data,startIndex)
	{
		
		var spanPosition=new Object();
		
		var index=data.indexOf('<span',startIndex);
		if(index!=-1)
			{
				spanPosition.start=index;
				if(index<data.length)
					{
						var endIndex=data.indexOf('</span>',index+1);
						if(endIndex!=-1)
							{
							spanPosition.end=endIndex;
								return spanPosition;
							}
					}
			
			}
		
		return null;
	};

	
	LogDataManager.prototype.outputResult=function(data,result,expected)
	{
		if(result!=expected)
		{
			document.write('fail: '+data+'</br>');
		}
		
		document.write(data+'</br>');
		
	};
	
	//Method returns if the passed in index is withing existing spanPositions.
	LogDataManager.prototype.checkWithinExistingSpan=function(spanPositions,index)
	{
		for ( var n = 0; n < spanPositions.length; n++)
		{
			if(index >=spanPositions[n].start && index <=spanPositions[n].end+6)
			{
				return true;
			}
		}
		
		return false;
	};
	
	//Show spinner for log data
	LogDataManager.prototype.showLogDataSpinner=function()
	{
		$('#logDataSpinnerContainer').show();
		$('.logDataSpinner').show();
	};
	
	//Hide spinner for log data.
	LogDataManager.prototype.hideLogDataSpinner=function()
	{
		$('#logDataSpinnerContainer').hide();
		$('.logDataSpinner').hide();
	};