//Class that handles display of  data
	function SearchHistoryManager(communicationsManager,dataDisplayManager)
	{
		this.communicationsManager=communicationsManager;
		this.dataDisplayManager=dataDisplayManager;
		this.searchHistoryData=null;
	}

	
	SearchHistoryManager.prototype.initialize=function()
	{
		this.searchHistoryData=searchHistoryJson;
		this.generateSearchHistoryHTML();
		var searchHistoryManager=this;
		
		$("#chartAndSearchHistory").on('mouseleave','#searchHistoryBox',function(event){ 
			searchHistoryManager.hideSearchHistory();
		});

		$('#searchInputBlock').on('focusin','#search_input',function(event){
			searchHistoryManager.showSearchHistory();
		});

		$('#searchInputBlock').on('focusout','#search_input',function(event){
			//If cursor is not on the searchHistoryBox.
			if($('#searchHistoryBox:hover').length==0)
			{
				searchHistoryManager.hideSearchHistory();	
			}
		});

		
		$('#searchInputBlock').on('click','#search_input',function(event){
			searchHistoryManager.showSearchHistory();
		});

		$('#searchHistoryBox').on('mouseenter','.searchHistoryGo',function(event){
			$(this).closest('.searchHistory').find('.historyHover').addClass('historyHoverSH');
		});
		
		$('#searchHistoryBox').on('mouseleave','.searchHistoryGo',function(event){
			
			$(this).closest('.searchHistory').find('.historyHover').removeClass('historyHoverSH');
		});

		$('#searchHistoryBox').on('click','.searchHistoryGo',searchHistoryManager.handleGoButtonClick());
		
		$('#searchHistoryBox').on('click','.searchHistoryKeywordAndDesc',searchHistoryManager.handleSearchKeywordClick());
		
		$('#searchHistoryBox').on('click','.searchHistoryDCDS',searchHistoryManager.handleDataCollectionDataSourceClick());
		
		$('#searchHistoryBox').on('click','.searchHistoryTime',searchHistoryManager.handleTimeClick());
		

		$('#searchHistoryBox').on('click','#searchHistoryClose',function(event){
			searchHistoryManager.hideSearchHistory();
		});
		
	}

	
	SearchHistoryManager.prototype.handleGoButtonClick=function()
	{
		var searchHistoryManager=this;
		return function(event)
		{
			searchHistoryManager.handleSearchKeywordClick()(event,this,false);
			searchHistoryManager.handleDataCollectionDataSourceClick()(event,this,false);
			searchHistoryManager.handleTimeClick()(event,this,false);
			notifyUserSmall('Keyword, data collection and date updated.',1000);	
		}
	}
	
	SearchHistoryManager.prototype.handleTimeClick=function()
	{
		var searchHistoryManager=this;
		return function(event,clickedElement,notifyUser)
		{
			if(!clickedElement)
			{
				clickedElement=this;
			}
			if($(clickedElement).hasClass("historyHover"))
			{
				var searchHistoryData=searchHistoryManager.getSearchHistoryDataForElement(clickedElement);
				var xAxisDataType=$('#xAxisDataTypeOpt').val();
				if(searchHistoryData.xAxisDataType==xAxisDataType)
				{
					var searchOptionsManager=searchHistoryManager.dataDisplayManager.searchOptionsManager;
					searchOptionsManager.updateSearchOptionsState2(searchHistoryData.startNumberDisplay,searchHistoryData.endNumberDisplay,xAxisDataType);
					if(notifyUser!=false)
					{
						notifyUserSmall('Date updated.',1000);	
					}
					
				}
				else
				{
					if(searchHistoryData.xAxisDataType)
					{
						notifyUserSmall('Data types for date do not match.',2000);	
					}
					
				}
			}
			
		};
	}
	
	
	
	SearchHistoryManager.prototype.handleSearchKeywordClick=function()
	{
		var searchHistoryManager=this;
		return function(event,clickedElement,notifyUser)
		{
			if(!clickedElement)
			{
				clickedElement=this;
			}
			var searchHistoryData=searchHistoryManager.getSearchHistoryDataForElement(clickedElement);
			var keyword=searchHistoryData.keyword;
			$('#search_input').val(keyword);
			if(notifyUser!=false)
				{
				notifyUserSmall('Keyword updated.',1000);
				}
			
		};
	}
	
	SearchHistoryManager.prototype.handleDataCollectionDataSourceClick=function()
	{
		var searchHistoryManager=this;
		return function(event,clickedElement,notifyUser)
		{
			if(!clickedElement)
			{
				clickedElement=this;
			}
			
			if($(clickedElement).hasClass("historyHover"))
			{
				var searchHistoryData=searchHistoryManager.getSearchHistoryDataForElement(clickedElement);
				if(searchHistoryData.dataCollectionId)
				{
					var searchOptionsManager=searchHistoryManager.dataDisplayManager.searchOptionsManager;
					searchOptionsManager.setSelectedIndex(searchHistoryData.dataCollectionId);
					searchOptionsManager.setSelectedDataSource(searchHistoryData.dataSourceInfos,searchHistoryData.dataCollectionId,searchOptionsManager);
					if(notifyUser!=false)
					{
						notifyUserSmall('Data Collection and Data Source Selected.',1000);	
					}
					
				}

			}
		};
	}

	SearchHistoryManager.prototype.getSearchHistoryDataForElement=function(clickedElement)
	{
		var index=$(clickedElement).closest('.searchHistory').attr('tag');
		index=parseInt(index);
		var searchHistoryData=this.searchHistoryData[index];
		return searchHistoryData;
	}
	
	SearchHistoryManager.prototype.hideSearchHistory=function()
	{
		$("#searchHistoryBox").hide();	
	}

	SearchHistoryManager.prototype.showSearchHistory=function()
	{
		$("#searchHistoryBox").show();	
	}

	
	SearchHistoryManager.prototype.generateSearchHistoryHTML=function()
	{
		var searchHistoryManager=this;
		searchHistoryManager.hideSearchHistory();
		
		for (var int = 0; int < this.searchHistoryData.length; int++) {
			
		var keyword=this.searchHistoryData[int].keyword;
		if(keyword.length==0)
		{
			keyword='All Data';
		}
		var searchHistoryContentHTML='<div class="searchHistory" tag="'+int+'">';
				searchHistoryContentHTML+='<span class="searchHistoryKeywordAndDesc historyHover">';
				searchHistoryContentHTML+='<span class="searchHistoryKeyword">'+keyword+'</span>';
				if(this.searchHistoryData[int].description)
				{
					searchHistoryContentHTML+='<span class="searchHistoryDesc">'+this.searchHistoryData[int].description+'</span>';	
				}
				
				searchHistoryContentHTML+='</span>';
				
				var hoverClass='historyHover';
				if(!this.searchHistoryData[int].dataCollectionName)
				{
					hoverClass='';
				}
				else
				{
					 hoverClass='historyHover';
				}
				searchHistoryContentHTML+='<span class="searchHistoryDCDS '+hoverClass+'">';
				
				var displayGoButton=false;
				if(this.searchHistoryData[int].dataCollectionName)
				{
					displayGoButton=true;
					searchHistoryContentHTML+='<span class="searchHistoryDC">'+this.searchHistoryData[int].dataCollectionName+'</span>';
					
					searchHistoryContentHTML+='<span class="searchHistoryDS">';
					if(this.searchHistoryData[int].dataSourceInfos.length==0)
					{
						searchHistoryContentHTML+='All Data Sources';	
					}
					else
					{
						var dataSourceNames='';
						var searchOptionsManager=searchHistoryManager.dataDisplayManager.searchOptionsManager;
						for (var i = 0; i < this.searchHistoryData[int].dataSourceInfos.length; i++) {
							dataSourceNames+=searchOptionsManager.trimDataSourceInfoName(this.searchHistoryData[int].dataSourceInfos[i].name,dataSourceInfoDisplayNameMaxSize);
							if(i!=(this.searchHistoryData[int].dataSourceInfos.length-1))
							{
								dataSourceNames+=',';
							}
						}
						
						if(dataSourceNames.length>0)
						{
							searchHistoryContentHTML+='<span class="dsNames" title="'+dataSourceNames+'">'+this.searchHistoryData[int].dataSourceInfos.length+' data sources</span>';	
						}
					}
					searchHistoryContentHTML+='</span>';

				}
				searchHistoryContentHTML+='</span>';
				
				if(!this.searchHistoryData[int].startNumberDisplay)
				{
					hoverClass='';
				}
				else
				{
					 hoverClass='historyHover';
					 displayGoButton=true;
				}
				searchHistoryContentHTML+='<span class="searchHistoryTime '+hoverClass+'">';
				if(this.searchHistoryData[int].startNumberDisplay)
				{
					searchHistoryContentHTML+='<span class="searchHistoryStart">'+this.searchHistoryData[int].startNumberDisplay+'</span>';
					searchHistoryContentHTML+='<span class="searchHistoryEnd">'+this.searchHistoryData[int].endNumberDisplay+'</span>';
					
				}
				searchHistoryContentHTML+='</span>';
				
				if(displayGoButton)
				{
					searchHistoryContentHTML+='<span class="searchHistoryGo historyHover">';
					searchHistoryContentHTML+='All';
					searchHistoryContentHTML+='</span>';
				}
				else
				{
				}
				
				
			searchHistoryContentHTML+='</div>';
			
			$('#searchHistoryContent').append(searchHistoryContentHTML);
		}
		
	}
	
	
	