	//Class that handles display of  data
	function SearchOptionsManager(communicationsManager,addToDashboard)
	{
		this.addToDashboard=addToDashboard;
		this.communicationsManager=communicationsManager;
		this.dataCollectionStates={};
		this.displayState='hidden';
		//Used to hold information about dataSourceInfos.
		this.dataSourceInfos=new Object();
	}

	
	SearchOptionsManager.prototype.initialize=function()
	{
		
		this.initializeDataTypeInputs();
		this.initializeSearchOptionsRanges();
		var searchOptionsManager=this;
		
		$("#searchOptMenuButton").button({
			 icons: {
				 primary: "ui-icon-triangle-1-s"
				 },
			text: false
       });

		
		
		$("#data_source_infos").multiselect();
		$(".ui-multiselect").css('width','190px');
		
		 $("#searchOptions").on('mouseenter','#searchOptMenuButton',function(event){

			  if(searchOptionsManager.searchOptionsUpdated==true)
			  {
				  var searchIndexId=searchOptionsManager.getDataCollectionId();
				  var indexState=searchOptionsManager.getSearchOptionsDCStateForIndex(searchIndexId,searchOptionsManager);
				  searchOptionsManager.updateSearchOptionsMenu(indexState);
				  searchOptionsManager.searchOptionsUpdated=false;
			  }
			  
			 //Used to display dropdown menu
				var menu = $("#searchOptMenuContent").show().position({
					my : "center top",
					at : "bottom",
					of : this
				});
				//If the dateTimePicker is open close it and remove focus from 
				$( "#srch_endDate_opt" ).datetimepicker('hide');
				$('#srch_endDate_opt').blur(); 

			 $('body').one("click", function(e) {
					
				    var container = $("#searchOptMenuContent");

				    if (!container.is(e.target) // if the target of the click isn't the container...
				        && container.has(e.target).length === 0) // ... nor a descendant of the container
				    {
				        container.hide();
				    }
				    
				});

		 });

		 $("body").on('mouseleave','#searchOptMenuContent',function(event){
			 $("#searchOptMenuContent").hide();
		 });
		 
		$("#more_options").button({
			 icons: {
				 primary: "ui-icon-gear",
				 secondary: "ui-icon-triangle-1-s"
				 },
			text: false
        });
		var searchOptionsManager=this;
		var addToDashboard=this.addToDashboard;

		//Used to display dropdown menu
		 $("#dropDown").menu({

			 //This has to be modified to check for specific menu item.
			 select:function(event,ui)
			 {
				if(ui.item.children().attr('tag')=='add_to_reports')
				{
					searchOptionsManager.handleAddToReports(event,ui,addToDashboard);
				}
				if(ui.item.children().attr('tag')=='add_to_dashboard')
				{
					searchOptionsManager.handleAddToDashboard(event,ui,addToDashboard);
				}
				
			 }


		 
		 });

		 $("#searchInputBlock").on('click','#more_options',this.handleOptionsButtonClick(this));
		 $("#searchInputBlock").on('mouseenter','#more_options',this.handleOptionsButtonClick(this));
		 
		this.datePickerOptions={
				showSecond: true,
				showMillisec: true,
				currentText:'Now',
				timeFormat: 'HH:mm:ss:l',
				numberOfMonths: 1,
				changeMonth: true,
				changeYear: true,
				constrainInput:false
			};
		
	$('#srch_startDate_opt').datetimepicker(this.datePickerOptions);
	$( "#srch_endDate_opt" ).datetimepicker(this.datePickerOptions);
	
	//$( "#srch_endDate_opt" ).datetimepicker( "destroy");
	
	$('#search_options_form').on('change','#srch_index_opt',this.handleSelectIndexChange(this));
	};
	

	SearchOptionsManager.prototype.initializeSearchOptionsRanges=function()
	{
		var searchOptionsManager=this;
		//User selects a date range.
		$('#searchOptMenuContent').on('click','.range',function(){
			
			var rangeId=$(this).attr('id');
			var rangeId=rangeId.substring(6);
			var indexId=searchOptionsManager.getDataCollectionId();
			var range=null;
			var indexState=searchOptionsManager.dataCollectionStates[indexId];
			if(indexState)
			{
				//Find the correct range with the id.
				$.each(indexState.searchRanges,function(index,searchRange)
				{
					if(searchRange.id==rangeId)
					{
						range=searchRange;
					}
				});
			}
			
			if(range)
			{
				$('#srch_startDate_opt').val(range.startNumber);
				$('#srch_endDate_opt').val(range.endNumber);
				//$( "#srch_startDate_opt" ).effect('highlight', {}, 900);
				//$( "#srch_endDate_opt" ).effect('highlight', {}, 900);
				//notifyUserSmall(range.name+' selected.');
				$("#searchOptMenuContent").hide();
				
				notifyUser('Message','Date range changed, click "Go" to search.',2000,false);
			}
			
			
		});
		
	};


	SearchOptionsManager.prototype.initializeDataTypeInputs=function()
	{
		var searchOptionsManager=this;
		$('.dataType').change(
		
				function(event)
				{
					var selectedDataType=$('#dataTypeSelection').find('input[name="dataType"]:checked').val();
					searchOptionsManager.handleDataTypeSelection(selectedDataType);
				}
		);
		
		
	};

	SearchOptionsManager.prototype.handleDataTypeSelection=function(selectedDataType)
	{
		var currentDataCollection=this.getDataCollectionId();
		//Save the data type selected.
		this.communicationsManager.saveSearchOptionsStateDataType(currentDataCollection,selectedDataType,this);
	};
	

	SearchOptionsManager.prototype.handleSaveSearchOptionsStateResponse=function(searchOptionsManager)
	{
		return function(data){
			if(data.stateChanged==true)
			{
				searchOptionsManager.loadSearchOptionsData(true);
			}
		};
		
	};

	
	
	//Method to load search optidatePickerOptionsa.
	SearchOptionsManager.prototype.loadSearchOptionsData=function(reload)
	{
		var indexId=this.getDataCollectionId();
		if(indexId)
		{
			if(!this.dataCollectionStates[indexId] || reload==true) //If not already loaded.
			{
				this.communicationsManager.getSearchOptionsData(indexId,false,this);
			}
			else
			{
				this.updateSearchOptionsState(indexId);	
			}
		}
		else
		{
			notifyUser("Error","Index id is null",2000,true);
		}
		
	};
	
	//Method that handles the response.
	SearchOptionsManager.prototype.handleLoadSearchOptionsDataResponse=function(searchOptionsManager)
	{
		return function(responseData)
		{
			if(responseData.error==false)
			{
				searchOptionsManager.dataCollectionStates[responseData.searchOptionsDataCollectionStateJson.id]=responseData.searchOptionsDataCollectionStateJson;
				searchOptionsManager.updateSearchOptionsState(responseData.searchOptionsDataCollectionStateJson.id);	
			}
			else
			{
				notifyUser("Error",responseData.message,2000,true);
			}
			
		};
		
		
	};

	SearchOptionsManager.prototype.getSearchOptionsDCStateForIndex=function(indexId,searchOptionsManager)
	{
		var indexStateR=null;
		$.each(searchOptionsManager.dataCollectionStates,function(key,indexState)
				{
					if(key==indexId)
					{
						indexStateR=indexState;
						return indexState;
					}
				});

		return indexStateR;	
	};
	


	//Method called when the select box for search index changes.
	SearchOptionsManager.prototype.handleSelectIndexChange=function(searchOptionsManager)
	{
		return function(event)
		{
			var searchIndexId=$(this).val();
			searchOptionsManager.loadSearchOptionsData(false);
			searchOptionsManager.loadDataSourceInfos(searchIndexId,searchOptionsManager,null);
		};
		
	};
	
	SearchOptionsManager.prototype.updateSearchOptionsState=function(searchIndexId)
	{
				var indexState=this.getSearchOptionsDCStateForIndex(searchIndexId,this);
				this.updateSearchOptionsState2(indexState.startNumber, indexState.endNumber, indexState.xAxisDataType, indexState.inputLabel);
				this.searchOptionsUpdated=true;
	};
	
	SearchOptionsManager.prototype.updateSearchOptionsMenu=function(indexState)
	{
		$('#searchOptMenuContentCol1').html('');
		var rangeHTML='';
		$.each(indexState.searchRanges,function(index,range){
			if(range.noDataAvailable==false)
			{
				rangeHTML=rangeHTML+'<span id="range_'+range.id+'" class="range">'+range.name+'</span>';	
			}
		});
		$('#searchOptMenuContentCol1').html(rangeHTML);
		
		var name=indexState.name;
		if(name.length>30)
		{
			name=name.substring(0,30)+'..';
		}
		
		

		var dataCollectionHTML='';
		dataCollectionHTML+='<span class="menuDCNameValue">'+name+'</span>';
		dataCollectionHTML+='<span class="menuDCLabel">Start:</span>'
		dataCollectionHTML+='<span class="menuDCValue">'+indexState.startNumberOriginal+'</span>'
		dataCollectionHTML+='<span class="menuDCLabel">End:</span>'
		dataCollectionHTML+='<span class="menuDCValue">'+indexState.endNumberOriginal+'</span>'
		dataCollectionHTML+='<span class="menuDCLabel">Entries:</span>';
		dataCollectionHTML+='<span class="menuDCValue">'+indexState.numEntries+'</span>';
	
		$('#searchOptMenuDCInfo').html('');
		$('#searchOptMenuDCInfo').html(dataCollectionHTML);
		
		var dataType=indexState.xAxisDataType;
		
		var dataTypeInput=$('#dataTypeSelection').find('input[value="'+dataType+'"]');
		
		dataTypeInput.prop('checked',true);
		
		
	};

	SearchOptionsManager.prototype.updateSearchOptionsState2=function(startNumber,endNumber,xAxisDataType,inputLabel)
	{
				

				$('#srch_startDate_opt').val(startNumber);
				$('#srch_endDate_opt').val(endNumber);

				$('#xAxisDataTypeOpt').val(xAxisDataType);
				if(inputLabel)
				{
					$('#startNumLabel').html('Start '+inputLabel+':');
					$('#endNumLabel').html('End '+inputLabel+':');
				}

				if(xAxisDataType=='DATE')
				{
					$('#srch_startDate_opt').datetimepicker('destroy');
					$( "#srch_endDate_opt" ).datetimepicker('destroy');
					$('#srch_startDate_opt').datetimepicker(this.datePickerOptions);
					$( "#srch_endDate_opt" ).datetimepicker(this.datePickerOptions);
				}
				else
				{
					$('#srch_startDate_opt').datetimepicker('destroy');
					$( "#srch_endDate_opt" ).datetimepicker('destroy');
				}
		
	};

	
	//Method called when the select box for search index changes and new set of data source infos are to be loaded.
	//selectedDataSourceInfoId is the id of the default dataSourceInfoId to be selected.
	SearchOptionsManager.prototype.loadDataSourceInfos=function(searchIndexId,searchOptionsManager,dataSourceInfoJsons)
	{
		var dataSourceInfoJson=searchOptionsManager.dataSourceInfos[searchIndexId];
		//Use communicationsManager to load data.
		if(dataSourceInfoJson==null)
			{
				searchOptionsManager.communicationsManager.getDataSourceInfosForDataCollection(searchIndexId,searchOptionsManager,dataSourceInfoJsons);
			}
		else//Data is already available, call method to set it .
			{
				searchOptionsManager.changeDataSourceInfosSelectBox(dataSourceInfoJson,searchOptionsManager,dataSourceInfoJsons);
			}
	};

	//Method called when the json response for getDataSourceInfos is returned.
	SearchOptionsManager.prototype.handleGetDataSourceInfosResponse=function(searchIndexId,searchOptionsManager,dataSourceInfoJsons)
	{
		return function(jsonResponse)
		{
			
			//Save for future use.
			searchOptionsManager.dataSourceInfos[searchIndexId]=jsonResponse;
			searchOptionsManager.changeDataSourceInfosSelectBox(jsonResponse,searchOptionsManager,dataSourceInfoJsons);
			//This is to make the display of search options slightly smoother when the page is loaded.
			$('#searchOptions').css('visibility','visible');
		};
	};

	
	//Method called to change the data in the select box for data source.
	SearchOptionsManager.prototype.changeDataSourceInfosSelectBox=function(jsonResponse,searchOptionsManager,selectedDataSourceInfoJsons)
	{
		var sourceSelect=$("#data_source_infos");
		var searchOptionsManager=this;
		sourceSelect.empty();
		$.each(jsonResponse.dataSourcesInfos,function(index,dataSourceInfo){
			var dataSourceInfoName=searchOptionsManager.trimDataSourceInfoName(dataSourceInfo.name,dataSourceInfoDisplayNameMaxSize);
			var option = $('<option></option>').attr("value",dataSourceInfo.id).text(dataSourceInfoName);
			if(searchOptionsManager.isSelected(dataSourceInfo.id, selectedDataSourceInfoJsons))
			{
				option.attr('selected','selected');
			}
			sourceSelect.append(option);
		});
		
		$("#data_source_infos").multiselect("refresh");
		$(".ui-multiselect").css('width','190px');
		$(".ui-multiselect-menu").css('width','320px');
	};
	
	
	SearchOptionsManager.prototype.isSelected=function(dataSourceInfoId,selectedDataSourceInfoJsons)
	{
		//If none are marked as selected, then default to selected for all.
		if(selectedDataSourceInfoJsons==null||selectedDataSourceInfoJsons.length==0)
		{
			return true;
		}
		
		for (var int = 0; int < selectedDataSourceInfoJsons.length; int++) {
			if(selectedDataSourceInfoJsons[int].id==dataSourceInfoId)
			{
					return true;
			}
		}
		
		return false;
	}
	
	
	
	//Method used to trim the name of the data source.
	SearchOptionsManager.prototype.trimDataSourceInfoName=function(name,maxLength)
	{
		if (typeof(name) != "undefined" && name != null)
		{
			if(name.length>maxLength)
			{
				return ".."+name.substring(name.length-maxLength);
			}
		}
		
		return name;
	};
	
	//Method that handles option button click.
	SearchOptionsManager.prototype.handleOptionsButtonClick=function(searchOptionsManager)
	{
		return function(event)
		{
			//Used to display dropdown menu
			var menu = $("#dropDown").show().position({
				my : "left top",
				at : "left bottom",
				of : this
			});
			
			
			 $(document).one("click", function() {
					menu.hide();
				});

			$("body").on('mouseout','#dropDown',function(){
				   menu.hide();
				});

			$("body").on('mouseover','#dropDown',function(){
				   menu.show();
				});

			event.preventDefault();
			//searchOptionsManager.toggleOptions();
			return false;
		};
		
	};
	
	//Method that handles add to reports click.
	SearchOptionsManager.prototype.handleAddToReports=function(event,ui,addToDashboardDialog)
	{
		addToDashboardDialog.setTitle("Add to Report");
		addToDashboardDialog.setIsReport(true);
		addToDashboardDialog.showDialog();
		event.preventDefault();
		return false;
	};

	//Method that handles add to dashboard click.
	SearchOptionsManager.prototype.handleAddToDashboard=function(event,ui,addToDashboardDialog)
	{
			addToDashboardDialog.setTitle("Add to Dashboard");
			addToDashboardDialog.setIsReport(false);
			addToDashboardDialog.showDialog();
			event.preventDefault();
			return false;
		
	};
	
	SearchOptionsManager.prototype.toggleOptions=function()
	{
		$("#searchOptions").toggle();
	};

	SearchOptionsManager.prototype.getStartDate=function()
	{
		var startDate=$('#srch_startDate_opt').val();
		if(startDate=="")
			{
				startDate=null;
			}
		return startDate;
	};
	

	SearchOptionsManager.prototype.xAxisDataType=function()
	{
		var dataType=$('#xAxisDataTypeOpt').val();
		if(dataType=="")
			{
				dataType=null;
			}
		return dataType;
	};


	//Method used to set the index.
	SearchOptionsManager.prototype.setSelectedIndex=function(index)
	{
		var searchIndex=$('#srch_index_opt').val(index);
	};

	//Method used to set the dataSource.
	SearchOptionsManager.prototype.setSelectedDataSource=function(dataSourceInfoJsons,indexId,searchOptionsManager)
	{
		//If not already on page load it and set the dataSourceInfoId as selected.
		this.loadDataSourceInfos(indexId,this,dataSourceInfoJsons);
		
	};

	
	
	SearchOptionsManager.prototype.getDataCollectionId=function()
	{
		var searchIndex=$('#srch_index_opt').val();
		return searchIndex;
	};

	//Return the value from the dataSource select box.
	SearchOptionsManager.prototype.getDataSourceInfoId=function()
	{
		var searchIndex=$('#data_source_infos').val();
		return searchIndex;
	};
	
	SearchOptionsManager.prototype.getEndDate=function()
	{
		var endDate=$('#srch_endDate_opt').val();
		if(endDate=="")
			{
				endDate=null;
			}
		return endDate;
	};
	
	SearchOptionsManager.prototype.getStartDateInMillis=function()
	{
		var startDate=$('#srch_startDateMillis_opt').val();
		if(startDate=="")
			{
				startDate=null;
			}
		return startDate;
	};
	
	
	SearchOptionsManager.prototype.getEndDateInMillis=function()
	{
		var endDate=$('#srch_endDateMillis_opt').val();
		if(endDate=="")
			{
				endDate=null;
			}
		return endDate;
	};
	