	//Class that handles display of  data
	function TailDataManager(communicationsManager,tailResultsDisplay)
	{
		this.communicationsManager=communicationsManager;
		this.tailResultsDisplay=tailResultsDisplay;
		this.paused=true;
		this.tailActive=false;
		this.currentChartInfoId=null;
		this.color=null;
	}

	
	
	TailDataManager.prototype.initialize=function()
	{
		var tailDataManager=this;
	}
	

	TailDataManager.prototype.setColor=function(color)
	{
		this.color=color;
	}

	
	TailDataManager.prototype.isTailActive=function()
	{
		return this.tailActive;
	}

	TailDataManager.prototype.isTailPaused=function()
	{
		return this.paused;
	}

	
	TailDataManager.prototype.startTail=function()
	{
		notifyUser("Message", "Tail started.", 2000,false);
		this.tailActive=true;
		this.paused=false;
		this.communicationsManager.getLastXData(this,-1,true,this.currentChartInfoId,200);
	}

	TailDataManager.prototype.stopTail=function()
	{
		notifyUser("Message", "Tail stopped.", 2000,false);
		this.tailActive=false;
		this.paused=true;
	}

	TailDataManager.prototype.setCurrentChartInfoId=function(currentChartInfoId)
	{
		this.currentChartInfoId=currentChartInfoId;
	}
	
	TailDataManager.prototype.pauseTail=function()
	{
		this.tailActive=true;
		this.paused=true;
	}
	
	TailDataManager.prototype.continueTail=function()
	{
		this.tailActive=true;
		this.paused=false;
		this.repeatTailRequest(-1);
	}
	
	
	TailDataManager.prototype.repeatTailRequest=function(startNum)
	{
		if(this.tailActive==true && this.paused==false)
		{
			this.communicationsManager.getLastXData(this,startNum,false,this.currentChartInfoId,200);	
		}
		
	}
	
	TailDataManager.prototype.handleGetLastXResponse=function(firstRequest)
	{
		var tailDataManager=this;
		return function(response)
		{
			var startNum=-1;
			var tailResults=response.resultDataUnits;
			
			if(tailResults && tailResults.length>0)
			{
				//The highest date value fetched is the next startNum.
				startNum=response.resultDataUnits[0].resultData.dateInMillis;
				startNum=startNum-1;
			}

			//For all requests other than the first request check if the total number of results(total results returned from the shards) is greater than the number of results returned 
			//and the request is not the first request, then there are possibly entries skipped.(basically checking if the results returned is a subset of the total results returned.).
			if(response.totalResults>response.resultDataUnits.length && firstRequest==false)
			{
				response.entriesSkipped=true;
			}
			else
			{
				response.entriesSkipped=false;
			}
			
			console.info("returned entries:"+tailResults.length);
			tailDataManager.tailResultsDisplay.displayTailResults(response,tailDataManager.color);
			
			if(tailDataManager.paused==false && tailDataManager.tailActive==true && response.numSearches>0)
			{
				//Repeat tail request every 3 seconds.
				setTimeout(function(){tailDataManager.repeatTailRequest(startNum);},1500);
			}
		};
		
	}