	//Class that handles all communications with the server.
	function CommunicationsManager()
	{
		
	}

	CommunicationsManager.prototype.loadLogData=function(logDataHandlerObject,pageNumber,chartInfoId)
	{
		
		var requestCount=getURLParameterRequestCount();
		
		$.getJSON('/data/?action=logPageData&pageNumber='
				+ pageNumber+'&chartInfoId='+chartInfoId+'&requestCount='+requestCount, this.logDataJSonResponseHandler(logDataHandlerObject,chartInfoId)).fail(function(){
					
					logDataHandlerObject.handleGetLogDataResponseError();
				});

		
	};

	CommunicationsManager.prototype.loadLogDataUnit=function(logDataUnitHandlerObject,logDataIdentifierStr,logEntryClicked,moreClick)
	{
		
		var requestCount=getURLParameterRequestCount();
		
		$.post('/data/?action=logDataUnit&requestCount='+requestCount,{logDataIdentifier:logDataIdentifierStr},logDataUnitHandlerObject.handleLoadLogDataUnitResponse(logDataUnitHandlerObject,logEntryClicked,moreClick));
				
	};
	

	CommunicationsManager.prototype.saveLogEntryState=function(logEntryStates,listener)
	{
		$.post('/data/?action=saveLogDataState',{json:JSON.stringify(logEntryStates)},listener.handleSaveLogEntryStateResponse());
	};
	
	CommunicationsManager.prototype.getLastXData=function(listener,startNum,firstRequest,currentChartInfoId,numResults)
	{
		var params=new Object();
		if(typeof startNum != 'undefined')
		{
			params.startNum=startNum;	
			params.chartInfoId=currentChartInfoId;
			params.numResults=numResults;
		}
		$.post('/data/?action=lastXResults',params,listener.handleGetLastXResponse(firstRequest)).fail(function(){
			notifyUser('Error','Error getting tail data.',4000,true);
		});;
	}

	
	CommunicationsManager.prototype.reDoSearchesDashChartInfo=function(tailRequests,clearExistingSearches,dashboardChartInfoId,listener)
	{
		var params=new Object();
			params.requestType='DASHBOARDCHARDDATA';
			params.tailRequest=tailRequests;
			params.clearExistingSearches=clearExistingSearches;
			params.dashboardChartDataId=dashboardChartInfoId;

			$.post('/data/?action=reDoSearchRequest',params,listener.handleReDoSearchesDashChartInfoResponse()).fail(function(){
			notifyUser('Error','Error repeating search.',4000,true);
		});;
	}

	CommunicationsManager.prototype.reDoSearchesDashChartInfo=function(tailRequests,clearExistingSearches,dashboardChartInfoId,listener,startDate,endDate,xAxisDataType)
	{
		var params=new Object();
			params.requestType='DASHBOARDCHARDDATA';
			params.tailRequest=tailRequests;
			params.clearExistingSearches=clearExistingSearches;
			params.dashboardChartDataId=dashboardChartInfoId;
			params.startDate=startDate;
			params.endDate=endDate;
			params.xAxisDataType=xAxisDataType;

			$.post('/data/?action=reDoSearchRequest',params,listener.handleReDoSearchesDashChartInfoResponse()).fail(function(){
			notifyUser('Error','Error repeating search.',4000,true);
		});;
	}
	
	CommunicationsManager.prototype.reDoSearchTailDataCollection=function(tailRequests,dataCollectionId,listener)
	{
		var params=new Object();
			params.requestType='DATACOLLECTION';
			params.tailRequest=tailRequests;
			params.dataCollectionId=dataCollectionId;

			$.post('/data/?action=reDoSearchRequest',params,listener.handleReDoSearchTailDataCollection()).fail(function(){
			notifyUser('Error','Error tailing data collection.',4000,true);
		});;
	}
	
	CommunicationsManager.prototype.getNearByLogData=function(logEntryId,chartInfoId,beforeOrAfter,nearByLogType,numResults,intervalInSeconds,listener,resultDataUnit,selectedDSIds)
	{
		var params=new Object();
		params.logDataIdentifier=logEntryId;
		params.chartInfoId=chartInfoId;
		params.beforeOrAfter=beforeOrAfter;
		params.intervalInSeconds=intervalInSeconds;
		params.nearByLogType=nearByLogType;
		params.numResults=numResults;
		params.dataSourceIds=selectedDSIds;
		
		$.post('/data/?action=nearByResults',params,listener.handleGetNearByLogDataResponse(params,resultDataUnit));
	};


	CommunicationsManager.prototype.closeNearByLogData=function(chartInfoId,listener)
	{
		var params=new Object();
		params.chartInfoId=chartInfoId;
		$.post('/data/?action=clearNearByResults',params,listener.handleCloseNearByLogResponse(params));
	};


	//Function used to handle response from chartData action.lo
	CommunicationsManager.prototype.logDataJSonResponseHandler=function(logDataHandlerObject,chartInfoId)
	{
		return function(jsonResponse)
		{
			logDataHandlerObject.handleGetLogDataResponse(jsonResponse,chartInfoId);
		};
		
	};

	
	CommunicationsManager.prototype.redoExistingSearch=function(chartDataHandlerObject)
	{
		$.get('/chart/?action=repeatExistingSearches',chartDataHandlerObject.handleRepeatExistingSearchResponse(chartDataHandlerObject));
		
	};
	
	CommunicationsManager.prototype.getFlaggedData=function(listener)
	{
		$.get('/chart/?action=flaggedDataOperation&operation=GET',listener.handleGetFlaggedDataResponse());
	};

	
	CommunicationsManager.prototype.clearFlaggedData=function(listener)
	{
		$.get('/chart/?action=flaggedDataOperation&operation=CLEAR',listener.handleClearFlaggedDataResponse());
	};
	
	CommunicationsManager.prototype.loadChartData=function(chartDataHandlerObject,startDate,endDate,index,refresh)
	{
		//As of now the startDate/endDate,index are not used.
		var requestCount=getURLParameterRequestCount();
		$.getJSON('/chart/?action=chartData&startDate='+startDate+'&endDate='+endDate+'&index='+index+'&requestCount='+requestCount,this.loadChartDataJSonResponseHandler(chartDataHandlerObject,this,refresh));
		
	};
	
	//Function used to handle response from chartData action.
	CommunicationsManager.prototype.loadChartDataJSonResponseHandler=function(chartDataHandlerObject,communicationsManager,refresh)
	{
		return function(jsonResponse)
		{
			var chartDataArray=[];
			$.each(jsonResponse.chartDataList,
					function(i,JsonChartDataListItem)
					{
						var chartDataItem=communicationsManager.getChartDataItemFromJsonChartData(JsonChartDataListItem);
						chartDataItem.resultDataIndex=parseInt(chartDataItem.metaData.resultDataIndex); //This is to prevent colors from shifting around when a series is hidden.
						chartDataItem.color=chartDataItem.metaData.resultDataColor;
						chartDataItem.index=i;
						chartDataArray.push(chartDataItem);
					});
			if(refresh==true)
			{
				chartDataHandlerObject.handleRefreshChartDataResponse(chartDataArray,jsonResponse);
			}else
			{
				chartDataHandlerObject.handleGetChartDataResponse(chartDataArray,jsonResponse);	
			}
			
		};
		
	};
	
	//Function that returns chartData object from the json response chartDataItem.
	CommunicationsManager.prototype.getChartDataItemFromJsonChartData=function(JsonChartDataItem)
	{
		
		var chartData=new Object();
		chartData.labels=[];
		chartData.chartDataNodes=[];
		chartData.data=[];
		chartData.metaData=JsonChartDataItem.metaData;
		chartData.allResultsPopulated=JsonChartDataItem.allResultsPopulated;
		chartData.searchInstanceState=JsonChartDataItem.searchInstanceState;
		chartData.dataSourceInfoJsons=JsonChartDataItem.dataSourceInfoJsons;
		
		var firstDate=0;
		$.each(JsonChartDataItem.chartDataNodeList,
				function(i,chartDataNode) {
					
					if(i==0)
					{
							firstDate=chartDataNode.startDate;
					}
					
			
					if (i% parseInt(JsonChartDataItem.metaData.labelDisplayFrequency) == 0) {
						chartData.labels.push([chartDataNode.startDate-firstDate,chartDataNode.label ]);
					}
					
					chartData.chartDataNodes.push(chartDataNode);
					chartData.data.push([(chartDataNode.startDate-firstDate),chartDataNode.value ]);
				});

		chartData.resolutionInMilliseconds=parseInt(JsonChartDataItem.metaData.resolutionInMilliseconds);
		chartData.fieldNumber=JsonChartDataItem.fieldNumber;
		return chartData;
	};
	
	CommunicationsManager.prototype.search=function(startDate, endDate, dataCollectionId,resultBucketSize,dataSourceInfoId) {

		$('#search_form').submit();
	};
	//Method that submits the search form after setting action to drillDown.
	CommunicationsManager.prototype.drillDown=function(startDate, endDate, resultBucketSize,dateDelta,chartDataIndex,requestCount) {
		$('#srch_action').val("drillDown");
		if(startDate!=null)
		{
			$('#srch_startDate_millis').val(startDate);	
		}
		if(endDate!=null)
		{
			$('#srch_endDate_millis').val(endDate);
		}
		if(chartDataIndex!=null)
		{
			$('#srch_drillDown_chartDataIndex').val(chartDataIndex);
		}
		
		$('#requestCount').val(requestCount);
		
		this.search(null,null,null, resultBucketSize);
	};
	
	CommunicationsManager.prototype.sendRemoveResultDataRequest=function(chartInfoId,removeAllButThis,responseHandlerFunction)
	{
		var requestCount=getURLParameterRequestCount();
		if(typeof removeAllButThis !='undefined' && removeAllButThis==true)
		{
			$.get('/chart/?action=removeResultData&chartInfoId='+chartInfoId+'&requestCount='+requestCount+'&removeAllButThis=true',responseHandlerFunction);	
		}
		else
		{
			$.get('/chart/?action=removeResultData&chartInfoId='+chartInfoId+'&requestCount='+requestCount+'&removeAllButThis=false',responseHandlerFunction);
		}
		
	};

	CommunicationsManager.prototype.setTreeSelectionState=function(selectedIds)
	{
		$.post('/data/?action=setTreeSelectionState',{ids:JSON.stringify(selectedIds)});
	};

	CommunicationsManager.prototype.findStartPatternForFiles=function(selectedIds)
	{
		$.post('/data/?action=findStartPatternForFiles',{ids:JSON.stringify(selectedIds)});
	};
	
	CommunicationsManager.prototype.loadFindStartPatternResult=function(startPatternResultHandler)
	{
		$.post('/data/?action=findStartPatternForFilesResult',startPatternResultHandler.handleLoadFindStartPatternResult(startPatternResultHandler));
	};
	
	CommunicationsManager.prototype.validateStartPattern=function(validatePatternResultHandler,pattern,filePath)
	{
		$.get('/data/?action=validateStartPattern&pattern='+pattern+'&id='+filePath,validatePatternResultHandler.handleValidateStartPatternResult(validatePatternResultHandler));
	};

	CommunicationsManager.prototype.addToSearchEngine=function(holderDataArray)
	{
		$.post('/data/?action=addToSearchEngine',{holderDataList:JSON.stringify(holderDataArray)},this.addToSearchEngineResponse);
	};
	
	CommunicationsManager.prototype.addToSearchEngineResponse=function(data)
	{
		//Reload the page, the parameter is to avoid reload from cache.
		location.reload(true);
	};

	//Method that fetches information about dataCollections for page.
	CommunicationsManager.prototype.getDataCollectionsForPage=function(pageNumber,entriesPerPage,listener)
	{
		$.get('/data/?action=getDataCollectionsPageList&pageNumber='+pageNumber+'&numEntriesPerPage='+entriesPerPage,listener.dataCollectionPageResponseHandler(listener)).fail(function(){
			notifyUser('Error','Error getting data collection list.',4000,true);
		});
	};

	//Method that fetches information about dataCollections for page.
	CommunicationsManager.prototype.loadTasks=function(listener)
	{
		$.get('/data/?action=getTaskList',listener.getTasksResponseHandler(listener)).fail(function(){
			notifyUser('Error','Error getting task list.',4000,true);
		});
	};
	
	//Method that fetches information about dataCollections. fieldinfos parameter is true if the fieldInfos is to be returned for the dataCollection.
	CommunicationsManager.prototype.getDataCollectionInfo=function(dataCollectionIds,listener)
	{
		$.post('/data/?action=getDataCollection',{ids:JSON.stringify(dataCollectionIds)},listener.dataCollectionResponseHandler);
		//$.get('/data/?action=getDataCollection&id='+dataCollectionId,listener.dataCollectionResponseHandler);
	};

	
	//Method that fetches information about dataCollections. fieldinfos parameter is true if the fieldInfos is to be returned for the dataCollection.
	CommunicationsManager.prototype.getDataCollectionInfoWithFields=function(dataCollectionIds,listener,currentLogStateNumber)
	{
		var fieldInfosParm='';
		fieldInfosParm='&fieldInfos='+true;
		
		$.post('/data/?action=getDataCollection'+fieldInfosParm,{ids:JSON.stringify(dataCollectionIds)},listener.dataCollectionResponseHandler(currentLogStateNumber));
		//$.get('/data/?action=getDataCollection&id='+dataCollectionId,listener.dataCollectionResponseHandler);
	};

	
	//Method that gets the searchOptions data like index startDate/endDate.
	CommunicationsManager.prototype.getSearchOptionsData=function(indexId,refresh,listener)
	{
		var requestCount=getURLParameterRequestCount();
		$.get('/chart/?action=searchOptionsState&requestCount='+requestCount+"&dataCollectionId="+indexId+"&reload="+refresh,listener.handleLoadSearchOptionsDataResponse(listener));
	};


	//Method that gets the searchOptions data like index startDate/endDate.
	CommunicationsManager.prototype.saveSearchOptionsStateDataType=function(indexId,dataType,listener)
	{
		var requestCount=getURLParameterRequestCount();
		$.post('/chart/?action=saveSearchOptionsState&requestCount='+requestCount+"&dataCollectionId="+indexId+"&dataType="+dataType+'&stateType=xAxisDataTypeState',listener.handleSaveSearchOptionsStateResponse(listener));
	};

	//Method that gets the searchOptions data like index startDate/endDate.
	CommunicationsManager.prototype.createReport=function(name,description,listener)
	{
		$.get('/report/?action=createReport&reportName='+name+'&reportDescription='+description,listener.handleCreateReportResponse(listener));
	};

	
	CommunicationsManager.prototype.createDashboard=function(name,isReport,listener)
	{
		$.post('/dash/?action=createDashboard&name='+name+'&isReport='+isReport,listener.handleCreateDashboardResponse(listener));
	};

	
	CommunicationsManager.prototype.addToDashboard=function(description,dashboardId,dashboardItemName,isReport,listener)
	{
		$.post('/dash/?action=addToDashboard&id='+dashboardId+'&isReport='+isReport,{desc:description,itemName:dashboardItemName},listener.handleAddToDashboardResponse(listener));
	};

	CommunicationsManager.prototype.addLogEntryToReport=function(reportId,logEntryIdentifiers,logEntryStates,listener)
	{
		$.post('/dash/?action=addLogDataToReport',{dashboardId:reportId,json:JSON.stringify(logEntryIdentifiers)},listener.handleAddLogEntryToReportResponse(listener,logEntryStates));
	};


	CommunicationsManager.prototype.addDescriptionEntryToReport=function(reportId,description,addAfterId,listener)
	{
		$.post('/dash/?action=addDescriptionToReport',{dashboardId:reportId,description:description,addNewItemAfter:addAfterId},listener.handleAddDescriptionEntryToReportResponse(listener));
	};


	CommunicationsManager.prototype.updateDescriptionChartDataItem=function(dashboardId,description,chartDataId,dashboardDescriptionDialog)
	{
		$.post('/dash/?action=updateDescriptionEntry',{chartDataId:dashboardId,description:description,chartDataId:chartDataId},dashboardDescriptionDialog.handleUpdateDescriptionEntryResponse(dashboardDescriptionDialog));
	};

	
	
	CommunicationsManager.prototype.saveSettings=function(name,dashboardId,numColumns,chartDataItemIds,legend,listener)
	{
		$.post('/dash/?action=saveDashboardSettings&name='+name+'&legend='+legend+'&id='+dashboardId+'&numCols='+numColumns,{ids:JSON.stringify(chartDataItemIds)},listener.handleSaveSettingsResponse(listener));
	};
	
	CommunicationsManager.prototype.loadDashboardChartData=function(chartDataHandlerObject,dashChartId,auth,report)
	{
		var refreshData=false;
		//Refresh data for dashboards.
		if(report==false)
			{
				refreshData=true;
			}
		//The data returned is same as that for chart data and so the same handler is used that parses the data
		$.getJSON('/report/?action=getDashboardChartData&dashChartId='+dashChartId+'&auth='+auth+'&refreshData='+refreshData,this.loadChartDataJSonResponseHandler(chartDataHandlerObject,this));
	};

	CommunicationsManager.prototype.loadDashboardLogEntryData=function(chartDataHandlerObject,dashChartId,auth)
	{
		//The data returned is same as that for chart data and so the same handler is used that parses the data
		$.getJSON('/report/?action=getDashboardLogEntryData&dashChartId='+dashChartId+'&auth='+auth,chartDataHandlerObject.loadLogEntryJSonResponseHandler(dashChartId));
	};
	
	CommunicationsManager.prototype.sendDeleteReportRequest=function(reportManager,reportId)
	{
		//The data returned is same as that for chart data and so the same handler is used that parses the data
		$.getJSON('/report/?action=deleteReport&reportId='+reportId,reportManager.deleteReportRequestResponseHandler);
	};

	//Method that gets the searchOptions data like index startDate/endDate.
	CommunicationsManager.prototype.editReport=function(name,description,reportId,listener)
	{
		$.get('/report/?action=editReport&reportName='+name+'&reportId='+reportId+'&reportDescription='+description,listener.handleEditReportResponse(listener));
	};
	
	//Method that loads the dataSourceInfos for a index.
	CommunicationsManager.prototype.getDataSourceInfosForDataCollection=function(searchIndexId,searchOptionsManager,dataSourceInfoJsons)
	{
		$.get('/report/?action=getDataSourceInfos&dataCollectionId='+searchIndexId,searchOptionsManager.handleGetDataSourceInfosResponse(searchIndexId,searchOptionsManager,dataSourceInfoJsons));
	};

	//Method used to save chartInfo state
	CommunicationsManager.prototype.saveChartInfoState=function(chartInfoId,hidden)
	{
		$.get('/chart/?action=saveChartInfoState&chartInfoId='+chartInfoId+'&hidden='+hidden);
	};

	//Method used to save chartInfo state
	CommunicationsManager.prototype.hideAllButCurrentChartInfo=function(chartInfoId,handler)
	{
		$.get('/chart/?action=showHideChartInfo&operation=hide&chartInfoId='+chartInfoId,handler.handleShowHideResponse());
	};

	
	//Method used to save chartInfo state
	CommunicationsManager.prototype.showAllChartInfo=function(handler)
	{
		$.get('/chart/?action=showHideChartInfo&operation=show',handler.handleShowHideResponse());
	};
	
	//Handle file operation
	CommunicationsManager.prototype.sendDeleteRequest=function(selectedIds,fileOperationsManager)
	{
		$.post('/data/?action=dataFileOperation&operation=delete',{ids:JSON.stringify(selectedIds)},fileOperationsManager.handleDeleteFileResponse());
	};

	//Handle file operation
	CommunicationsManager.prototype.sendRenameRequest=function(id,fileOperationsManager,newName,data)
	{
		$.get('/data/?action=dataFileOperation&operation=rename&newName='+newName+'&id='+id,fileOperationsManager.handleRenameFileResponse(data));
	};

	//Handle file operation
	CommunicationsManager.prototype.sendCreateFolderRequest=function(fileOperationsManager,name,parentId,data)
	{
		$.get('/data/?action=dataFileOperation&operation=createFolder&name='+name+'&parentId='+parentId,fileOperationsManager.handleCreateFolderResponse(data));
	};
	
	//Handle file operation
	CommunicationsManager.prototype.sendMoveFileRequest=function(fileOperationsManager,movedIds,parentId,data)
	{
		$.post('/data/?action=dataFileOperation&operation=move',{movedIds:JSON.stringify(movedIds),destinationId:parentId},fileOperationsManager.handleMoveFileResponse(fileOperationsManager,movedIds,parentId,data));
	};

	//Used to get PlanData for the user.
	CommunicationsManager.prototype.getPlanData=function(responseHandler)
	{
		$.get('/user/allPlanData?action=allPlanData',responseHandler.handleGetPlanDataResponse());
	};

	//Request to change plan data.
	CommunicationsManager.prototype.changePlanRequest=function(planData,responseHandler)
	{
		$.post('/user/changePlan?action=changePlan',{json:JSON.stringify(planData)},responseHandler.handleChangePlanResponse());
	};

	CommunicationsManager.prototype.sendMessageToSupport=function(formData,contactSupportForm)
	{
		$.post('/user?action=contactSupportMessage',formData,contactSupportForm.handleSendMessageToSupportResponse(contactSupportForm));
	};
	
	
	function getURLParameterRequestCount()
	{
	 var name='requestCount';
	 var value=decodeURI((RegExp(name+'='+'(.+?)(&|$)').exec(location.search)||[,null])[1]);
	 
	 if(value!='null' && value)
	 {
		 return parseInt(value);
	 }
	 
	 return 0;
	}

	
	
	CommunicationsManager.prototype.createAlert=function(comparsionType,comparsionValue,seconds,chartDataId,chartInfoId,alertName,listener,edit)
	{
		var params=new Object();
		params.action='alertOperations';
		params.operation='CREATE';
		if(edit==true)
		{
				params.operation='UPDATE';
		}
		
		params.comparisonType=comparsionType;
		params.comparisonValue=comparsionValue;
		params.intervalInSeconds=seconds;
		params.chartInfoId=chartInfoId;
		params.dashboardChartDataId=chartDataId;
		params.alertName=alertName;
		$.post('/dash/',params,listener.handleCreateAlertResponse(params));		
	};

	
	CommunicationsManager.prototype.updateAlertInfo=function(chartDataId,emails,postURL,enabled,listener)
	{
		var params=new Object();
		params.action='alertOperations';
		params.operation='UPDATE_ALERTINFO';
		params.dashboardChartDataId=chartDataId;
		params.emails=emails;
		params.enabled=enabled;
		params.postURL=postURL;
		
		$.post('/dash/',params,listener.handleUpdateAlertInfoResponse(params));		
	};
	
	CommunicationsManager.prototype.deleteAlert=function(chartDataId,chartInfoId,listener)
	{
		var params=new Object();
		params.action='alertOperations';
		params.operation='DELETE';
		params.chartInfoId=chartInfoId;
		params.dashboardChartDataId=chartDataId;
		$.post('/dash/',params,listener.handleDeleteAlertResponse(params));		
	};

	
	CommunicationsManager.prototype.createDataCollection=function(name,listener)
	{
		$.get('/data/?action=createDataCollection&name='+name,listener.handleCreateDataCollectionResponse(listener));		
	};

	CommunicationsManager.prototype.createFieldExtract=function(name,regex,dataCollectionId,listener)
	{
		$.get('/data/?action=createFieldExtract&name='+name+'&regex='+regex+'&dataCollectionId='+dataCollectionId,listener.handleAddFieldExtractResponse(listener));		
	};

	CommunicationsManager.prototype.editFieldExtract=function(fieldId,name,regex,dataCollectionId,listener)
	{
		$.get('/data/?action=createFieldExtract&name='+name+'&regex='+regex+'&dataCollectionId='+dataCollectionId+'&fieldId='+fieldId,listener.handleEditFieldExtractResponse(listener));		
	};

	
	CommunicationsManager.prototype.deleteFieldExtract=function(id,dataCollectionId,listener)
	{
		$.get('/data/?action=deleteFieldExtract&id='+id+'&dataCollectionId='+dataCollectionId,listener.handleDeleteFieldExtractResponse(listener));		
	};

	CommunicationsManager.prototype.deleteUser=function(id,listener)
	{
		$.get('/user/?action=deleteUser&id='+id,listener.handleDeleteUserResponse(id,listener));		
	};


	CommunicationsManager.prototype.createUser=function(data,listener,captchaResponse)
	{
		$.post('/user/?action=createUser&captchaResponse='+captchaResponse,data,listener.handleCreateUserResponse(listener));		
	};

	CommunicationsManager.prototype.loginUser=function(data,listener,captchaResponse)
	{
		$.post('/user/?action=login2&captchaResponse='+captchaResponse,data,listener.handleLoginUserResponse(listener));		
	};

	CommunicationsManager.prototype.forgotPassword=function(data,listener)
	{
		$.post('/user/?action=forgotPassword&test=false',data,listener.handleForgotPasswordSubmitResponse(listener));		
	};

	
	CommunicationsManager.prototype.updateUser=function(data,listener)
	{
		$.post('/user/?action=update2',data,listener.handleUpdateUserResponse(listener));		
	};

	
	CommunicationsManager.prototype.deleteDataCollection=function(id,listener)
	{
		$.get('/data/?action=deleteDataCollection&id='+id,listener.handleDeleteClickResponse(listener));		
	};

	CommunicationsManager.prototype.pauseDataCollection=function(id,listener)
	{
		$.get('/data/?action=updateDataCollectionOperation&id='+id+'&operation=PAUSE',listener.handleDataCollectionOpearationResponse(listener));		
	};

	CommunicationsManager.prototype.continueDataCollection=function(id,listener)
	{
		$.get('/data/?action=updateDataCollectionOperation&id='+id+'&operation=CONTINUE',listener.handleDataCollectionOpearationResponse(listener));		
	};

	
	CommunicationsManager.prototype.deleteDataCollectionShard=function(searchIndexId,shardId,listener)
	{
		$.get('/data/?action=deleteDataCollectionShard&searchIndexId='+searchIndexId+'&shardId='+shardId,listener.handleDeleteShardClickResponse(listener));		
	};

	
	CommunicationsManager.prototype.cancelTask=function(id,listener)
	{
		$.get('/data/?action=taskOperation&taskId='+id+'&operation=cancel',listener.handleCancelTaskResponse(listener));		
	};

	CommunicationsManager.prototype.deleteDashboardChartData=function(chartDataId,dashboarId,listener)
	{
		$.get('/dash/?action=deleteDashboardChartData&dashChartId='+chartDataId+'&dashboardId='+dashboarId,listener.handleDeleteChartDataResponse(listener));		
	};
	CommunicationsManager.prototype.deleteDashboard=function(dashboarId,listener)
	{
		$.get('/dash/?action=deleteDashboard&dashboardId='+dashboarId,listener.handleDeleteDashboardResponse(listener));		
	};
	CommunicationsManager.prototype.saveDashboardChartData=function(chartDataId,timePeriod,name,listener)
	{
		$.get('/dash/?action=saveDashboardChartData&timePeriod='+timePeriod+'&id='+chartDataId+'&name='+name,listener.handleSaveSettingsResponse(listener));		
	};

	CommunicationsManager.prototype.addSampleDataToSearchEngine=function(entryCount,indexName,organizationId,delaySeed,parseFields,prefix,mainDataHubService,listener,dataSourceName)
	{
		var params=new Object();
		params.action='addSampleDataToSearchEngine';
		params.entryCount=entryCount;
		params.indexName=indexName;
		params.organizationId=organizationId;
		params.delaySeed=delaySeed;
		params.parseFields=parseFields;
		params.prefix=prefix;
		params.mainDataHubService=mainDataHubService;
		params.dataSourceName=dataSourceName;
		
		$.post('/data/',params,listener.handleAddSampleDataToSearchEngineResponse(params));	
	};