	//Manager class that has responsibility of coordinating actions.
	function AlertsManager()
	{
		this.communicationsManager=new CommunicationsManager();
		this.addEditAlertsDialog=new AddEditAlertsDialog(this.communicationsManager,this);
	}
	

	AlertsManager.prototype.initialize=function ()
	{
		var alertsManager=this;
		var emailsOriginalVal=$('#emails').val();
		$('.addAlert').click(function(){
				var chartDataId=getURLParameter('itemId');
				var chartInfoId=$(this).closest('.chartInfoAlert').attr('id');
				alertsManager.addEditAlertsDialog.showDialog(chartDataId,chartInfoId,false);
			}
		);

		$('.deleteAlert').click(function(){
			var chartDataId=getURLParameter('itemId');
			var chartInfoId=$(this).closest('.chartInfoAlert').attr('id');
			alertsManager.communicationsManager.deleteAlert(chartDataId,chartInfoId,alertsManager);
		}
		);
		
		$('.editAlert').click(function(){
			var chartDataId=getURLParameter('itemId');
			var chartInfoId=$(this).closest('.chartInfoAlert').attr('id');
			alertsManager.addEditAlertsDialog.showDialog(chartDataId,chartInfoId,true);
		}
		);

		$('#saveAlertContacts').click(function(){
			var chartDataId=getURLParameter('itemId');
			
			var enabled=$('#enabledBox').is(':checked');
			var emails=$('#emails').val();
			var postURL=$('#postUrl').val();
			var error=false;
			if(!emails || emails.length==0)
			{
					//notifyUser('Error','No value entered.',3000,true);
			}
			else
			{
				var emailArray=emails.split(',');
				
				
				$.each( emailArray, function( index, value ) {
					if(value && value.length > 0)
					{
						if(!isEmail(value.trim()) && error==false)
						{
							notifyUser('Error','Email entered '+value+' is not valid.',3000,true);
							error=true;
						}
					}
				});
				

			}
			
			//If no errors save.
			if(error==false)
			{
				alertsManager.communicationsManager.updateAlertInfo(chartDataId, emails,postURL,enabled,alertsManager);
			}
			
		}
		);
		
		
		$('#emails').focusout(function(){
			var emails=$('#emails').val();
			if(emails.trim()!=emailsOriginalVal.trim())
			{
				notifyUser('Message','Do not forget to save the change.',3000,false);	
			}
			
		})
		
		var chartDataId=getURLParameter('itemId');
		alertsManager.communicationsManager.loadDashboardChartData(this,chartDataId,null,true);
		
	};

	
	
	AlertsManager.prototype.handleUpdateAlertInfoResponse=function(param)
	{
		
		return function(response)
		{
			
			if(response.error==false)
			{
				notifyUser('Message','Saved.',3000,false);
			}
			else
			{
				notifyUser('Error',response.errorMessage,3000,true);	
			}
		}
		
	};
	
	AlertsManager.prototype.handleGetChartDataResponse=function(chartDataArray,jsonResponse)
	{
		
		var chartManager=new ChartManager(this.communicationsManager,"#chartDataDash","line");
		chartManager.setShowPoints(false);
		
		var chartName=jsonResponse.metaData.name;
		var description=jsonResponse.metaData.description;
		if(description && description.length > 0 && description!='undefined')
		{
			description=' - '+description;
			chartManager.setChartName(chartName+description);
		}
		else
		{
			if(chartName)
			{
				chartManager.setChartName(chartName);
			}
			
		}

		chartManager.setChartData(chartDataArray, jsonResponse);
		chartManager.setChartDataState();
		chartManager.plotChart();
		
	};

	AlertsManager.prototype.handleDeleteAlertResponse=function ()
	{
		return function(response)
		{
			
			if(response.error==false)
			{
				notifyUser('Message','Alert Deleted.',3000,false);
				window.location.reload();
			}
			else
			{
				notifyUser('Error',response.errorMessage,3000,true);	
			}

		}

	};
	

	$(document).ready(function() {
		var alertsManager=new AlertsManager();
		alertsManager.initialize();
		$('body').css('visibility','visible');
	});
