//This is used to track the total number of new results, used for selenium tests.
var totalNewResults=0;
//Used to track total number of alerts generated, used in selenium tests.
var totalAlertsGenerated=0;
//Manager class that has responsibility of coordinating actions.
	function DashboardManager()
	{
		this.communicationsManager=new CommunicationsManager();	
		this.dashboardSettingsDialog=new DashboardSettingsDialog(this.communicationsManager,this);
		this.dashboardCDSettingsDialog=new DashChartDataSettingsDialog(this.communicationsManager,this);
		this.dashboardDescriptionDialog=new DashboardDescriptionDialog(this.communicationsManager,this);
		this.dashboardSearchOptionsDialogManager=new DashboardSearchOptionsDialogManager(this.communicationsManager,this);
		this.chartManagerHolder={};
		this.requestCount=0;
		this.currentActiveChartDataItemId=null;
		this.numChartsOnPage=0;
		
		//========== For Contact support dialog.
		var contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_minDialog');
		
		var initialText='Subject: Help me with xyz. \n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		contactSupportDialog.setInitialText(initialText);
		
		$('#contactSupport3').click(function(){
			contactSupportDialog.setMessageAddendum('Any Addendum');
			contactSupportDialog.showDialog();
		});

		//Handlers used for notification from contactSupportForm
		this.handleValidationFailure=function(message)
		{
			notifyUser("Error", message, 3000,true);
		};

		//Handlers used for notification from contactSupportForm	
		this.handleSendingMessageNotification=function(message)
		{
			notifyUser("Message", message, 3000,false);
		};

		//Handlers used for notification from contactSupportForm
		this.handleMessageSentNotificationSuccess=function(message)
		{
			notifyUser("Message", message, 5000,false);
			contactSupportDialog.hideDialog();
		};

		//========== For Contact support dialog end
	}
	

	DashboardManager.prototype.initialize=function ()
	{
		$('.settingsIcon').
			button({
				icons : {
					primary : "ui-icon-triangle-1-s"
					//primary : "ui-icon-gear"
				},
				text : false
			});
		
		var dashboardManager=this;
		
		//Used to display dropdown menu
		 $("#dropDown_chartData").menu({
			 //This has to be modified to check for specific menu item.
			 select:dashboardManager.handleMenuSelection(dashboardManager)

		 });
		 
		 $(".settingsIcon").mouseenter(this.handleTriggerMenu(this));
			
		$('#settings_button').click(this.handleSettingsClick(this));
		$('#reorder_opt_button').click(this.handleSettingsClick(this));
		$('#full_screen').click(this.handleFullScreenClick(this));	
		$("#selectDashboard").on('change',this.handleDashboardSelectionChange(this));
		$('body').on('click',"#delete_dashboard",this.handleDeleteButtonClick(this));
		
		var allCharts=$('div[id^="chartDataDash_"]');
		if(typeof allCharts)
		{
			this.numChartsOnPage=allCharts.length;
		}
		this.dashboardSettingsDialog.initialize();
		this.dashboardSearchOptionsDialogManager.initialize();
		this.setHeightForChartDataDiv();
		this.loadChartData();
	};


	
	DashboardManager.prototype.handleMenuSelection=function (dashboardManager)
	{
			return function(event,ui)
			 {
				var tag=ui.item.children().attr('tag');
				if(tag=='reorder_chartDataDash')
				{
					dashboardManager.dashboardSettingsDialog.showDialog();
				}
				else if(tag=='alerts')
				{
					window.location='/dashboard/dashboardAlerts.jsp?itemId='+dashboardManager.currentActiveChartDataItemId;
				}
				else if(tag=='new_description')
				{
					dashboardManager.dashboardDescriptionDialog.showDialog(dashboardManager.currentActiveChartDataItemId);
				}
				else if(tag=='update2_description')
				{
					dashboardManager.dashboardDescriptionDialog.showDialog(dashboardManager.currentActiveChartDataItemId,dashboardManager.currentActiveChartDataItemId);
				}
				else if(tag=='delete_chartDataDash')
				{
					
					event.preventDefault();
					$('<div></div>').appendTo('body')
				    .html('<div><h6>Are you sure?</h6></div>')
				    .dialog({
				        modal: true,
				        title: 'Confirmation Dialog',
				        zIndex: 10000,
				        autoOpen: true,
				        width: 'auto',
				        resizable: false,
				        dialogClass:'delChartData',
				        buttons: {
				            Yes: function () {
				                $(this).dialog("close");
				                var dashboardId=$('#selectDashboard').val();
				                $('#chartDataDiv_'+dashboardManager.currentActiveChartDataItemId).remove();
				        		dashboardManager.communicationsManager.deleteDashboardChartData(dashboardManager.currentActiveChartDataItemId, dashboardId, dashboardManager);
				            },
				            No: function () {
				                $(this).dialog("close");
				            }
				        },
				        close: function (event, ui) {
				            $(this).remove();
				        }
				    });
					
					
				}
				else if(tag=='settings_chartDataDash')
				{
					dashboardManager.dashboardCDSettingsDialog.showDialog(dashboardManager.currentActiveChartDataItemId);
				}				
				else if(tag=='repeatSearch')
				{
					chartManager=dashboardManager.chartManagerHolder["#chartDataDash_"+dashboardManager.currentActiveChartDataItemId];
					var chartDataList=chartManager.jsonResponse.chartDataList;
					
					var dataCollectionId=null;
					if(chartDataList.length>0)
					{
						dataCollectionId=chartDataList[chartDataList.length-1].metaData.searchIndexId;
					}
					
					if(dataCollectionId!=null)
					{
						dashboardManager.dashboardSearchOptionsDialogManager.displaySearchOptionsDialog(dataCollectionId,this);	
					}
					else
					{
						notifyUser("Error",'Could not find data collecton to search.', 3000,true);	
					}
					
					
				}
				else if(tag=='tailSearch')
				{
					dashboardManager.communicationsManager.reDoSearchesDashChartInfo(true,false,dashboardManager.currentActiveChartDataItemId,dashboardManager);
				}
			 };
		
		
	};
	
	DashboardManager.prototype.handleReDoSearchesDashChartInfoResponse=function ()
	{
		return function(response)
		{
			if(response.error==true)
			{
				notifyUser("Error", response.errorMessage, 3000,true);				
			}
			else
			{
				window.location.href = "/";
			}
			
		};
			
	}
	
	DashboardManager.prototype.handleTriggerMenu=function (dashboardManager)
	{
		
		return function(event)
		{

			 var chartDataDashId=$(this).attr('id');
			 
			 var chartItemType=$(this).parent().find("input[name='type']").val();
			 
			 dashboardManager.setMenuFor(chartItemType);

			 chartDataDashId=chartDataDashId.substring(9);
			 dashboardManager.currentActiveChartDataItemId=chartDataDashId;

			 
			 
			//Used to display dropdown menu
			var menu = $("#dropDown_chartData").show().position({
				at : "left top",
				my : "right bottom",
				of : this
			});
			
			
			 $(document).one("click", function() {
					menu.hide();
				});
			 
			 
			$("#dropDown_chartData").mouseleave(function(){
				   menu.hide();
				   
				});

			$("#dropDown_chartData").mouseenter(function(){
				   menu.show();
				});

			event.preventDefault();
			//searchOptionsManager.toggleOptions();
			return false;
		};
	};
	
	
	DashboardManager.prototype.setMenuFor=function (menuType)
	{
		
			if(menuType=='LOG_ENTRY')
			{
				
				$('#dropDown_chartData').find('a[tag="new_description"]').parent().css('display','block');
				$('#dropDown_chartData').find('a[tag="update2_description"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="alerts"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="repeatSearch"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="tailSearch"]').parent().css('display','none');
			}
			else if(menuType=='DESCRIPTION')
			{
				$('#dropDown_chartData').find('a[tag="update2_description"]').parent().css('display','block');
				$('#dropDown_chartData').find('a[tag="new_description"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="alerts"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="repeatSearch"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="tailSearch"]').parent().css('display','none');
			}
			else
			{
				$('#dropDown_chartData').find('a[tag="new_description"]').parent().css('display','block');
				$('#dropDown_chartData').find('a[tag="update2_description"]').parent().css('display','none');
				$('#dropDown_chartData').find('a[tag="alerts"]').parent().css('display','block');
				$('#dropDown_chartData').find('a[tag="repeatSearch"]').parent().css('display','block');
				$('#dropDown_chartData').find('a[tag="tailSearch"]').parent().css('display','block');
			}
			
			if(report==true)
			{
				$('#dropDown_chartData').find('a[tag="alerts"]').parent().css('display','none');
			}
		
	};
	
	
	DashboardManager.prototype.handleSearchOptionsDialogSubmit=function(startDate,endDate,dataType,dataCollectionId)
	{
		var dashboardManager=this;
			dashboardManager.communicationsManager.reDoSearchesDashChartInfo(false,false,dashboardManager.currentActiveChartDataItemId,dashboardManager,startDate,endDate,dataType,dataCollectionId);
	};
	
	
	DashboardManager.prototype.handleDashboardSelectionChange=function (dashboardManager)
	{
		
		return function()
		{
			var dashboardId=$("#selectDashboard").val();
			var url=dashboardManager.getURL();
			window.location.replace(url+'?id='+dashboardId);
		};
	};

	DashboardManager.prototype.handleDeleteChartDataResponse=function (dashboardManager)
	{
		
		return function()
		{
			var url=dashboardManager.getURL();

			window.location.replace(url);
		};
	};

	DashboardManager.prototype.getURL=function ()
	{
		var url='/dashboard/dashboard.jsp';
		if(report==true)
		{
			url='/reports/report.jsp';
		}
		return url;
	};
	
	DashboardManager.prototype.handleDeleteDashboardResponse=function (dashboardManager)
	{
		
		return function()
		{
			var url=dashboardManager.getURL();

			window.location.replace(url);
		};
	};

	//Method called after the chart data has been loaded.
	DashboardManager.prototype.handleGetChartDataResponse=function(chartDataArray,jsonResponse)
	{
	
		var dashboardManager=this;
			
		var dashChartDataId=jsonResponse.metaData.dashChartDataId;
		
		var emptyResults=jsonResponse.metaData.emptyResults;
		var chartManager=null;
		
			//check if chartManager has already been created.
			chartManager=dashboardManager.chartManagerHolder["#chartDataDash_"+dashChartDataId];
			
			if(chartManager==null)
			{
				chartManager=new ChartManager(dashboardManager.communicationsManager,"#chartDataDash_"+dashChartDataId,"line");
				chartManager.setShowPoints(false);
				var chartName=jsonResponse.metaData.name;
				var description=jsonResponse.metaData.description;
				if(description && description.length > 0 && description!='undefined')
				{
					description=' - '+description;
					chartManager.setChartName(chartName+description);
				}
				else
				{
					if(chartName)
					{
						chartManager.setChartName(chartName);
					}
					
				}
				dashboardManager.chartManagerHolder["#chartDataDash_"+dashChartDataId]=chartManager;
			}
			
			if(numColumnsDashboard<=1)
			{
				chartManager.setShowPoints(true);
			}
			
			var chartInfoManager=null;
			if(displayLegend==true)
			{
				
				chartInfoManager=dashboardManager.chartManagerHolder["#searches_"+dashChartDataId];
				if(chartInfoManager==null)
					{
						chartInfoManager=new ChartInfoManager(chartManager,dashboardManager.communicationsManager,dashboardManager,"#searches_"+dashChartDataId,true);
						if(numColumnsDashboard>1)
						{
							chartInfoManager.setUseMiniInfo();
						}
						
						chartInfoManager.initialize();
						dashboardManager.chartManagerHolder["#searches_"+dashChartDataId]=chartInfoManager;
					}
			}
			
			
			chartManager.setChartData(chartDataArray, jsonResponse);
			chartManager.setChartDataState();
			chartManager.plotChart();
			if(displayLegend==true)
			{
			//Display chart information.
				chartInfoManager.displayChartInfo();
			}
	
		if(emptyResults=='true' && report==false)//Display message only for dashboard and not for report.
		{
			chartManager=dashboardManager.chartManagerHolder["#chartDataDash_"+dashChartDataId];
			if(chartManager)
			{
				//Mark that there is no data.
				$("#chartDataDash_"+dashChartDataId).attr('chart_error','true');
				chartManager.displayErrorMessage('No new data available:'+this.lastRefreshTime);	
			}
			
		}
		else
		{
			$("#chartDataDash_"+dashChartDataId).attr('chart_error','false');	
		}
		
		this.requestCount-=1;
		
		//This is used for debugging purposes -selenium tests.-START
		var numResultsAllChartInfos=jsonResponse.metaData.numResultsAllChartInfos;
		if(typeof numResultsAllChartInfos != 'undefined')
		{
			numResultsAllChartInfos=parseInt(numResultsAllChartInfos);
		}
		else
		{
			numResultsAllChartInfos=0;
		}
		totalNewResults+=numResultsAllChartInfos;
		if(debugInfoOnPage==true && report==false)
		{
			$("#chartDataDash_"+dashChartDataId).remove('.numResultsLastSearch');
			$("#chartDataDash_"+dashChartDataId).prepend('<span class="senInfo numResultsLastSearch" title="NumResultsLastSearch:'+numResultsAllChartInfos+'"/>');
		}
		//This is used for debugging purposes -selenium tests. -END
		
		var alertsGenerated=jsonResponse.metaData.alertGenerated;
		if(typeof alertsGenerated != 'undefined' && alertsGenerated=='true')
		{
			totalAlertsGenerated+=1;
			$("#chartDataDash_"+dashChartDataId).remove('.alertGenerated');
			$("#chartDataDash_"+dashChartDataId).prepend('<span class="alertGenerated"/>');
		}
		
	};

	DashboardManager.prototype.loadChartData=function ()
	{
		var currentdate = new Date(); 
		this.lastRefreshTime= currentdate.getHours() + ":"  
        + currentdate.getMinutes() + ":" 
        + currentdate.getSeconds();
		
		var datetime = " Refresh time - "+this.lastRefreshTime;
		//The report variable is set in report.jsp and dashboard.jsp
		var isReport=report;
		
		var chartDivs=$('div[id^=chartDataDash_]');
		var dashboardManager=this;
		var totalCharts=chartDivs.size();
		//Make sure that all charts have been refreshed before sending a new refresh request.
		if(dashboardManager.requestCount==0)
		{
			//ReportVariable set in the dashboard.jsp page
			if(report==false)
			{
				$('#refresh_time').text(datetime);	
			}
			
			
			//For each chart div, find the report id from the dev and request for report data.
			$.each(chartDivs,function(index,chartDiv){
			
				
				var type=$(chartDiv).children('input[name="type"]').val();
				
				if(type=='CHART' || !type)
				{
	
					
					dashboardManager.requestCount+=1;
					var id=chartDiv.id;
					var dashChartDataId=id.substring(14);
	
					//$('#delete_'+dashChartDataId).live('click',dashboardManager.handleDeleteReportClick(dashboardManager,dashChartDataId));
						var auth=getURLParameter("auth");

						//If there are errors, have a bigger delay before sending requests, wait for 5 requests before throttling.
						var hasError=$(chartDiv).attr('chart_error');
						
						if(typeof $(chartDiv).data('errorCount')=='undefined')
						{
							$(chartDiv).data('errorCount',0);
						}
						
						if(hasError=='true')
						{
							
							$(chartDiv).data('errorCount',$(chartDiv).data('errorCount')+1);
						}
						else
						{
							$(chartDiv).data('errorCount',0);
						}
						 //if there is more than 6 continuous errors requests the above code will throttle future requests to every 10 seconds.
						if(hasError=='true' && $(chartDiv).data('errorCount')>6 && report==false)
						{
							
							setTimeout(function(){
								dashboardManager.communicationsManager.loadDashboardChartData(dashboardManager,dashChartDataId,auth,report);
							},10000);
							
						}else
						{
							dashboardManager.communicationsManager.loadDashboardChartData(dashboardManager,dashChartDataId,auth,report);		
						}
						
						
						
						
				}
				else if (type=='LOG_ENTRY')
				{
					//dashboardManager.communicationsManager.loadDashboardLogEntryData(dashboardManager,dashChartDataId,auth);
				}
				else if (type=='DESCRIPTION')
				{
				}
				//var  editReportDialog=new EditReportDialog(dashboardManager.communicationsManager,dashboardManager,dashChartDataId);
				//editReportDialog.initialize();
				//$('#edit_'+dashChartDataId).live('click',editReportDialog.handleEditReportClick(editReportDialog,dashChartDataId));
			});
			
		}
		
		
		//dashboardRefreshInterval,report variable is set in the dashboardBody.jsp,dashboard.jsp from Configuration.dashboardRefreshInterval
		if(report==false)//Refresh only for dashboard, not for reports.
		{
			setTimeout(function(){
				dashboardManager.loadChartData();
			},dashboardRefreshInterval);
		}
		
	};

	
	DashboardManager.prototype.setHeightForChartDataDiv=function ()
	{
		$("[id^=chartDataDiv_]").each(function(i,chartDataDiv){
		
			
			var chartDataType=$(chartDataDiv).find("input[name='type']").val();
			if(chartDataType=='CHART')
			{
				var width=$(chartDataDiv).width();
				var height=width*.42;
				$(chartDataDiv).height(height);
			}
			
		});
	};
	
	DashboardManager.prototype.handleSettingsClick=function (dashboardManager)
	{
		return function(event)
		{
			dashboardManager.dashboardSettingsDialog.showDialog();
		};
		
	};

	DashboardManager.prototype.handleDeleteButtonClick=function (dashboardManager)
	{
		return function(event)
		{
			
			event.preventDefault();
			$('<div></div>').appendTo('body')
		    .html('<div><h6>Are you sure?</h6></div>')
		    .dialog({
		        modal: true,
		        title: 'Delete Dashboard',
		        zIndex: 10000,
		        autoOpen: true,
		        width: 'auto',
		        resizable: false,
		        buttons: {
		            Yes: function () {
		                $(this).dialog("close");
		                var dashboardId=$('#selectDashboard').val();
		        		dashboardManager.communicationsManager.deleteDashboard(dashboardId, dashboardManager);
		            },
		            No: function () {
		                $(this).dialog("close");
		            }
		        },
		        close: function (event, ui) {
		            $(this).remove();
		        }
		    });
			
		};
		
	};

	DashboardManager.prototype.handleFullScreenClick=function (dashboardManager)
	{
		return function(event)
		{
			var fullScreenParamValue=getURLParameter('fullScreen');
			var fullScreenVal='true';
			if(fullScreenParamValue && fullScreenParamValue=='true')
			{
				fullScreenVal='false';
			}
			
				
			var url=document.URL;
			
			url=addParameter(url, 'fullScreen', fullScreenVal);
			window.location.replace(url);
		};
		
	};
	//Method called when a new chart data is selected, can be caused by multiple events.
	DashboardManager.prototype.handleChartInfoEventSelectChartData=function(flotChartDataItem)
	{
		
	};
	//Method called after logEntry has been loaded.
	DashboardManager.prototype.loadLogEntryJSonResponseHandler=function(dashChartId)
	{
		return function(jsonResponse)
		{
			$("#chartDataDash_"+dashChartId).html(jsonResponse.resultContent);
		};
	};
	
	
	
	function getURLParameter(name)
	{
	 return decodeURI((RegExp(name+'='+'(.+?)(&|$)').exec(location.search)||[,null])[1]);
	}
	
	$(document).ready(function() {
		var dashboardManager=new DashboardManager();
		dashboardManager.initialize();
		$('body').css('visibility','visible');
	});
	
	
