	//Manager class that has responsibility of coordinating actions.
	function DashboardSearchOptionsDialogManager(communicationsManager,listener)
	{
		this.communicationsManager=communicationsManager;
		this.listener=listener;
		this.responseData=null;
	}
	

	DashboardSearchOptionsDialogManager.prototype.initialize=function ()
	{
		
		var dashboardSearchOptionsDialogManager=this;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 690,
				  minHeight:200,
				  resizable: false
			};
		$('#dashboardSearchOptionsDialog').dialog(dialogOptions);
		
		$('#dashboardSearchOptionsDialog').on('change','.dataType',function(event){
			var selectedDataType=$('#dataTypeSelection').find('input[name="dataType"]:checked').val();
			dashboardSearchOptionsDialogManager.handleDataTypeSelection(selectedDataType);
		});
		

		$('#repeat_search_button').click(function(event){
			
			var startDate=$('#srch_startDate_opt').val();
			var dataType=dashboardSearchOptionsDialogManager.responseData.searchOptionsDataCollectionStateJson.xAxisDataType;
			var endDate=$('#srch_endDate_opt').val();	
			var dataCollectionId=dashboardSearchOptionsDialogManager.dataCollectionId;
			dashboardSearchOptionsDialogManager.hideDialog();
			dashboardSearchOptionsDialogManager.listener.handleSearchOptionsDialogSubmit(startDate,endDate,dataType,dataCollectionId);
		});
		
		//User selects a date range.
		$('#dashboardSearchOptionsDialog').on('click','.range',function(){
			
			var rangeId=$(this).attr('id');
			var rangeId=rangeId.substring(6);
			var indexId=dashboardSearchOptionsDialogManager.dataCollectionId;
			var range=null;
			var indexState=dashboardSearchOptionsDialogManager.responseData.searchOptionsDataCollectionStateJson;
			if(indexState)
			{
				//Find the correct range with the id.
				$.each(indexState.searchRanges,function(index,searchRange)
				{
					if(searchRange.id==rangeId)
					{
						range=searchRange;
					}
				});
			}
			
			if(range)
			{
				$('#srch_startDate_opt').val(range.startNumber);
				$('#srch_endDate_opt').val(range.endNumber);
				//$( "#srch_startDate_opt" ).effect('highlight', {}, 900);
				//$( "#srch_endDate_opt" ).effect('highlight', {}, 900);
				//notifyUserSmall(range.name+' selected.');
			}
			
			
		});
	};

	
	DashboardSearchOptionsDialogManager.prototype.handleDataTypeSelection=function(selectedDataType)
	{
		var currentDataCollection=this.dataCollectionId;
		//Save the data type selected.
		this.communicationsManager.saveSearchOptionsStateDataType(currentDataCollection,selectedDataType,this);
	};
		

	DashboardSearchOptionsDialogManager.prototype.handleSaveSearchOptionsStateResponse=function(dashboardSearchOptionsDialogManager)
	{
		var dashboardSearchOptionsDialogManager=this;
		return function(data){
			var currentDataCollection=dashboardSearchOptionsDialogManager.dataCollectionId;
			dashboardSearchOptionsDialogManager.communicationsManager.getSearchOptionsData(currentDataCollection,true,dashboardSearchOptionsDialogManager);
		};
		
	};
	

	DashboardSearchOptionsDialogManager.prototype.displaySearchOptionsDialog=function (dataCollectionId)
	{
		
		this.dataCollectionId=dataCollectionId;
		this.communicationsManager.getSearchOptionsData(dataCollectionId,true,this);
	};

	
	DashboardSearchOptionsDialogManager.prototype.displayDialog=function()
	{
		$('#dashboardSearchOptionsDialog').dialog('open');
		$('#dashboardSearchOptionsDialog').dialog('option','title','Repeat Search');
	}


	DashboardSearchOptionsDialogManager.prototype.hideDialog=function()
	{
		$('#dashboardSearchOptionsDialog').dialog('close');
		$('#dashboardSearchOptionsDialog').click();
	}

	
	DashboardSearchOptionsDialogManager.prototype.displaySearchOptionsResults=function(responseData)
	{

			var datePickerOptions={
					showSecond: true,
					showMillisec: true,
					currentText:'Now',
					timeFormat: 'HH:mm:ss:l',
					numberOfMonths: 1,
					changeMonth: true,
					changeYear: true,
					constrainInput:false
				};
			
			
			
			var searchOptDCState=responseData.searchOptionsDataCollectionStateJson;
			$('#srch_startDate_opt').val(searchOptDCState.startNumber);
			$('#srch_endDate_opt').val(searchOptDCState.endNumber);
			$('#startNumLabel').html('Start '+searchOptDCState.inputLabel+':');
			$('#endNumLabel').html('End '+searchOptDCState.inputLabel+':');

			if(searchOptDCState.xAxisDataType=='DATE')
			{
				$('#srch_startDate_opt').datetimepicker('destroy');
				$( "#srch_endDate_opt" ).datetimepicker('destroy');
				$('#srch_startDate_opt').datetimepicker(datePickerOptions);
				$( "#srch_endDate_opt" ).datetimepicker(datePickerOptions);
			}
			else
			{
				$('#srch_startDate_opt').datetimepicker('destroy');
				$( "#srch_endDate_opt" ).datetimepicker('destroy');
			}

			

			var name=searchOptDCState.name;
			if(name.length>30)
			{
				name=name.substring(0,30)+'..';
			}
			
			var dataCollectionHTML='';
			dataCollectionHTML+='<span class="menuDCNameValue">'+name+'</span>';
			dataCollectionHTML+='<span class="menuDCLabel">Start:</span>'
			dataCollectionHTML+='<span class="menuDCValue">'+searchOptDCState.startNumberOriginal+'</span>'
			dataCollectionHTML+='<span class="menuDCLabel">End:</span>'
			dataCollectionHTML+='<span class="menuDCValue">'+searchOptDCState.endNumberOriginal+'</span>'
			dataCollectionHTML+='<span class="menuDCLabel">Entries:</span>';
			dataCollectionHTML+='<span class="menuDCValue">'+searchOptDCState.numEntries+'</span>';
		
			$('#searchOptMenuDCInfo').html('');
			$('#searchOptMenuDCInfo').html(dataCollectionHTML);
			
			$('#searchOptMenuContentCol1').html('');
			var rangeHTML='';
			$.each(searchOptDCState.searchRanges,function(index,range){
				
				if(range.noDataAvailable==false)
				{
					rangeHTML=rangeHTML+'<span id="range_'+range.id+'" class="range">'+range.name+'</span>';	
				}
			});
			$('#searchOptMenuContentCol1').html(rangeHTML);
			
			var dataType=searchOptDCState.xAxisDataType;
			
			var dataTypeInput=$('#dataTypeSelection').find('input[value="'+dataType+'"]');
			
			dataTypeInput.prop('checked',true);
		
	}
	
	DashboardSearchOptionsDialogManager.prototype.handleLoadSearchOptionsDataResponse=function (dashboardSearchOptionsDialogManager)
	{
		var dashboardSearchOptionsDialogManager=this;
		return function(responseData)
		{
			if(responseData.error==false)
			{
				dashboardSearchOptionsDialogManager.displaySearchOptionsResults(responseData);
				dashboardSearchOptionsDialogManager.displayDialog();
				dashboardSearchOptionsDialogManager.responseData=responseData;				
			}
			else
			{
				notifyUser("Error",responseData.message,2000,true);
			}

		};
	};
	
	
	
