	//Manager class that has responsibility of coordinating actions.
	function AddToDashboardDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=eventListener;
		this.isReport=false;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 480,
				  minHeight:280,
				  resizable: false
			};
		$('#addToDashboard').dialog(dialogOptions);
	}
	

	AddToDashboardDialog.prototype.initialize=function ()
	{

	};

	AddToDashboardDialog.prototype.setIsReport=function (isReport)
	{
		this.isReport=isReport;
	};

	
	AddToDashboardDialog.prototype.hideDialog=function ()
	{
		$('#addToDashboard').dialog('close');
	};
	
	AddToDashboardDialog.prototype.showDialog=function ()
	{
		var addToDashboardDialog=this;
		$("#addToDashboard").html("");
		$("#addToDashboard").load('/dialog/addToDashboardDialog.jsp?isReport='+addToDashboardDialog.isReport, function() {
			$("#add_toDashboard_button").click(addToDashboardDialog.handleAddToDashboard(addToDashboardDialog));
		});

		
		$('#addToDashboard').dialog('open');
	};
		
	AddToDashboardDialog.prototype.setTitle=function (title)
	{
		$('#addToDashboard').dialog('option','title',title);
	};
	
	
	
	AddToDashboardDialog.prototype.handleAddToDashboard=function (addToDashboardDialog)
	{
		return function(event) {
			
			var dashboardId=$('#selectDashboard').val();
			var name=$("#dashboardName").val();
			//If a name has been specified.
			
			//If the name specified is same as a existing dashboard ,then use it.
			if(name.length>0)
			{
				var id = $('#selectDashboard option').filter(function() {
				return $(this).html().toLowerCase() == name.trim().toLowerCase();
				}).val();
				
				if(id && id!=null && typeof id != 'undefined')
				{
					dashboardId=id;
					name='';
				}
				
			}
			
			if(name.length>0)
			{
				addToDashboardDialog.communicationsManager.createDashboard(name,addToDashboardDialog.isReport,addToDashboardDialog);
			}
			else
			{
				addToDashboardDialog.addToDashboard(dashboardId);
			}
			
			event.preventDefault();
		};
	};
	
	AddToDashboardDialog.prototype.addToDashboard=function (dashboardId)
	{
		var dashboardItemName=$("#dashboardItemName").val();
		var description=$("#reportDescription").val();
		this.hideDialog();
		this.communicationsManager.addToDashboard(description,dashboardId,dashboardItemName,this.isReport,this);
		
	};
	
	
	AddToDashboardDialog.prototype.handleCreateDashboardResponse=function (addToDashboardDialog)
	{
		return function(data)
		{
			if(data.error==true)
			{
				notifyUser("Error",data.errorMessage,5000,true);
			}
			else
			{
				addToDashboardDialog.addToDashboard(data.dashboardId);
			}
		
				
		};
		
		
	};

	
	AddToDashboardDialog.prototype.handleAddToDashboardResponse=function (addToDashboardDialog)
	{
		return function(data)
		{
			
			if(data.error==true)
			{
				notifyUser("Error",data.errorMessage,5000,true);
			}
			else
			{
				
				if(addToDashboardDialog.isReport==false)
				{
						window.location.replace("/dashboard/dashboard.jsp?id="+data.dashboardId);	
				}
				else
				{
						window.location.replace("/reports/report.jsp?id="+data.dashboardId);
				}
			}
		};
		
		
	};

	
		