	//Manager class that has responsibility of coordinating actions.
	function AddLogEntryToReportDialog(communicationManager,eventListener)
	{
		this.eventListener=eventListener;
		this.communicationManager=communicationManager;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 480,
				  minHeight:280,
				  resizable: false
			};
		$('#addLogEntryToReport').dialog(dialogOptions);
	}

	AddLogEntryToReportDialog.prototype.setLogEntryIds=function (logEntryIds,logEntryStates)
	{
		this.logEntryIds=logEntryIds;
		this.logEntryStates=logEntryStates;
	};
	

	AddLogEntryToReportDialog.prototype.initialize=function ()
	{

	};
	
	AddLogEntryToReportDialog.prototype.hideDialog=function ()
	{
		$('#addLogEntryToReport').dialog('close');
	};
	
	AddLogEntryToReportDialog.prototype.showDialog=function ()
	{
		var addLogEntryToReportDialog=this;
		$("#addLogEntryToReport").html("");
		$("#addLogEntryToReport").load('/dialog/addLogEntryToReportDialog.jsp', function() {
			$("#add_toReport_button2").click(addLogEntryToReportDialog.handleAddToDashboard(addLogEntryToReportDialog));
		});

		
		$('#addLogEntryToReport').dialog('open');
	};
		
	AddLogEntryToReportDialog.prototype.setTitle=function (title)
	{
		$('#addLogEntryToReport').dialog('option','title',title);
	};
	
	
	
	AddLogEntryToReportDialog.prototype.handleAddToDashboard=function (addLogEntryToReportDialog)
	{
		return function(event) {
			
			
			var name=$("#dashboardName2").val();
			
			if(name.length>0)//If name specified, create new dashboard.
			{
				addLogEntryToReportDialog.communicationManager.createDashboard(name,"true",addLogEntryToReportDialog);	
			}
			else
			{
				var dashboardId=$('#selectDashboard2').val();
				addLogEntryToReportDialog.addLogEntryToReport(dashboardId);
			}
			
			event.preventDefault();
		};
	};


	AddLogEntryToReportDialog.prototype.handleCreateDashboardResponse=function (addLogEntryToReportDialog)
	{
		return function(data)
		{
			
			if(data.error==true)
			{
				notifyUser("Error",data.errorMessage,5000,true);
			}
			else
			{
				addLogEntryToReportDialog.addLogEntryToReport(data.dashboardId);
			}
				
		};
		
		
	};
	
	AddLogEntryToReportDialog.prototype.addLogEntryToReport=function (dashboardId)
	{
		
		this.communicationManager.addLogEntryToReport(dashboardId,this.logEntryIds,this.logEntryStates,this);
	};
	
	AddLogEntryToReportDialog.prototype.handleAddLogEntryToReportResponse=function (addLogEntryToReportDialog,logEntryStates)
	{
		return function(data)
		{
			
			if(data.error==true)
			{
				notifyUser("Error",data.errorMessage,5000,true);
			}
			else
			{
				$.cookie('addToReportId', data.dashboardId, {path: '/' });
				$('#selectedReport').html('');
				$.get('/search/logDataEntryMenu.jsp',function(data)
						{
							$('#logDataEntryMenu').replaceWith(data);
							
							addLogEntryToReportDialog.eventListener.logDataEntryMenuManager.initializeLogDataEntryMenuHandlers();
						});

				addLogEntryToReportDialog.eventListener.handleAddLogEntryToReportResponse(addLogEntryToReportDialog.eventListener,logEntryStates)(data);
				addLogEntryToReportDialog.hideDialog();
				
			
			}
			

		};
		
	};

		
