	//Manager class that has responsibility of coordinating actions.
	function DashboardDescriptionDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=eventListener;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 880,
				  minHeight:480,
				  resizable: false
			};
		$('#dashboardDescriptionDialog').dialog(dialogOptions);
	}
	

	DashboardDescriptionDialog.prototype.initialize=function ()
	{

	};
	
	DashboardDescriptionDialog.prototype.hideDialog=function ()
	{
		$('#dashboardDescriptionDialog').dialog('close');
	};
	
	DashboardDescriptionDialog.prototype.showDialog=function (insertAfterChartDataId,chartDataId)
	{
		var dashboardDescriptionDialog=this;
		var dashboardId=$("#selectDashboard").val();
		$("#dashboardDescriptionDialog").html("");
		var url='/dashboard/dialog/addEditDescriptionDialog.jsp?&dashboardId='+dashboardId;
		if(chartDataId)
		{
			url='/dashboard/dialog/addEditDescriptionDialog.jsp?dashboardChartDataId='+chartDataId+'&dashboardId='+dashboardId;
		}
		
		$("#dashboardDescriptionDialog").load(url, function() {
			$(this).dialog("option", "title","Description");
			new nicEditor({iconsPath : '../js/nicEdit/nicEditorIcons.gif',
				buttonList:['bold','italic','underline','left','center','right','justify','ol','ul','indent','outdent','forecolor','bgcolor','fontSize','fontFamily','fontFormat']}).panelInstance('descriptionEditor');
			//$('#descriptionEditor').jqte();
			$('#cancel_description').click(function(){dashboardDescriptionDialog.hideDialog();});
			$('#save_description').click(dashboardDescriptionDialog.handleSaveDescriptionClick(dashboardDescriptionDialog,insertAfterChartDataId));
			$('#update_description').click(dashboardDescriptionDialog.handleUpdateDescriptionClick(dashboardDescriptionDialog,chartDataId));
			
		});

		
		$('#dashboardDescriptionDialog').dialog('open');
	};

	
	
	DashboardDescriptionDialog.prototype.handleUpdateDescriptionClick=function (dashboardDescriptionDialog,chartDataId)
	{
		return function(event) {
			
			var nicInstance = nicEditors.findEditor('descriptionEditor');
			var description = nicInstance.getContent();
			var dashboardId=$("#selectDashboard").val();
			dashboardDescriptionDialog.communicationsManager.updateDescriptionChartDataItem(dashboardId,description,chartDataId,dashboardDescriptionDialog);
			
			
		};
	};

	
	DashboardDescriptionDialog.prototype.handleSaveDescriptionClick=function (dashboardDescriptionDialog,insertAfterChartDataId)
	{
		return function(event) {
			
			var nicInstance = nicEditors.findEditor('descriptionEditor');
			var description = nicInstance.getContent();

			var dashboardId=$("#selectDashboard").val();
			dashboardDescriptionDialog.communicationsManager.addDescriptionEntryToReport(dashboardId,description,insertAfterChartDataId,dashboardDescriptionDialog);
			
			
		};
	};

	DashboardDescriptionDialog.prototype.handleAddDescriptionEntryToReportResponse=function (dashboardDescriptionDialog)
	{
		return function(data)
		{
			dashboardDescriptionDialog.hideDialog();
			location.reload();	
		};
		
	};


	DashboardDescriptionDialog.prototype.handleUpdateDescriptionEntryResponse=function (dashboardDescriptionDialog)
	{
		return function(data)
		{
			dashboardDescriptionDialog.hideDialog();
			location.reload();	
		};
		
	};

	
		