	//Manager class that has responsibility of coordinating actions.
	function DataCollectionDetails()
	{
		this.communicationsManager=new CommunicationsManager();		
		this.addFieldExtractDialog=new AddFieldExtractDialog(this.communicationsManager,this);
	
	}
	

	DataCollectionDetails.prototype.initialize=function ()
	{
		
		$('#delete_data_collection').button();
		$('#delete_data_collection').click(this.handleDeleteClick(this,this.communicationsManager));
		$('.deleteShard').button({
			icons : {
				primary : "ui-icon-circle-close"
				//primary : "ui-icon-gear"
			},
			text : false
		});

		$('.deleteFieldInfo').button({
			icons : {
				primary : "ui-icon-circle-close"
				//primary : "ui-icon-gear"
			},
			text : false
		});

		

		
		
		
		$('.editFieldInfo').click(this.handleEditFieldExtractClick(this,this.communicationsManager));
		$('.deleteShard').click(this.handleDeleteShardClick(this,this.communicationsManager));
		$('.deleteFieldInfo').click(this.handleDeleteFieldClick(this,this.communicationsManager));
		$('#add_field_extractions').click(this.handleAddFieldExtractClick(this,this.communicationsManager));
		
		
	};

	
	DataCollectionDetails.prototype.handleEditFieldExtractClick=function (dataCollectionDetails,communicationManager)
	{

		return function(event)
		{
			var editFieldButton=this;
			var fieldId=$(editFieldButton).attr('id');
			var dataCollectionId=$('#delete_data_collection').attr('value');
			dataCollectionDetails.addFieldExtractDialog.setEditMode(true);
			dataCollectionDetails.addFieldExtractDialog.showDialog(fieldId,dataCollectionId);
			event.preventDefault();
		};
		
	};
	
	
	DataCollectionDetails.prototype.handleAddFieldExtractClick=function (dataCollectionDetails,communicationManager)
	{

		return function(event)
		{
			dataCollectionDetails.addFieldExtractDialog.setEditMode(false);
			dataCollectionDetails.addFieldExtractDialog.showDialog('','');
			event.preventDefault();
		};
		
	};
	
	DataCollectionDetails.prototype.handleDeleteFieldClick=function (dataCollectionDetails,communicationManager)
	{

		return function(event)
		{
	
			event.preventDefault();
			var deleteButton=this;
			$('<div></div>').appendTo('body')
		    .html('<div><h6>Are you sure?</h6></div>')
		    .dialog({
		        modal: true,
		        title: 'Confirmation Dialog',
		        zIndex: 10000,
		        autoOpen: true,
		        width: 'auto',
		        resizable: false,
		        buttons: {
		            Yes: function () {
		                $(this).dialog("close");
		                var fieldId=$(deleteButton).attr('id');
		                communicationManager.deleteFieldExtract(fieldId,$('#delete_data_collection').attr('value'),dataCollectionDetails);
		            },
		            No: function () {
		                $(this).dialog("close");
		            }
		        },
		        close: function (event, ui) {
		            $(this).remove();
		        }
		    });
			
		};
		
	};
	
	DataCollectionDetails.prototype.handleDeleteShardClick=function (dataCollectionDetails,communicationManager)
	{

		return function(event)
		{
	
			event.preventDefault();
			var deleteButton=this;
			$('<div></div>').appendTo('body')
		    .html('<div><h6>Are you sure?</h6></div>')
		    .dialog({
		        modal: true,
		        title: 'Confirmation Dialog',
		        zIndex: 10000,
		        autoOpen: true,
		        width: 'auto',
		        resizable: false,
		        buttons: {
		            Yes: function () {
		                $(this).dialog("close");
		                var shardId=$(deleteButton).attr('id');
		                communicationManager.deleteDataCollectionShard($('#delete_data_collection').attr('value'),shardId,dataCollectionDetails);
		            },
		            No: function () {
		                $(this).dialog("close");
		            }
		        },
		        close: function (event, ui) {
		            $(this).remove();
		        }
		    });
			
			
			
		};
		
	};
	
	DataCollectionDetails.prototype.handleDeleteClick=function (dataCollectionDetails,communicationManager)
	{

		return function(event)
		{
	
			event.preventDefault();
			$('<div></div>').appendTo('body')
		    .html('<div><h6>Are you sure?</h6></div>')
		    .dialog({
		        modal: true,
		        title: 'Confirmation Dialog',
		        zIndex: 10000,
		        autoOpen: true,
		        width: 'auto',
		        resizable: false,
		        buttons: {
		            Yes: function () {
		                $(this).dialog("close");
		                communicationManager.deleteDataCollection($('#delete_data_collection').attr('value'),dataCollectionDetails);
		            },
		            No: function () {
		                $(this).dialog("close");
		            }
		        },
		        close: function (event, ui) {
		            $(this).remove();
		        }
		    });
			
			
			
		};
		
	};

	DataCollectionDetails.prototype.handleDeleteClickResponse=function (response)
	{
		return function(jsonResponse)
		{
			var url='http://'+window.location.host+'/datapages/data.jsp';
			window.location=url;
			
		};
		
	};


	DataCollectionDetails.prototype.handleDeleteShardClickResponse=function (response)
	{
		return function(jsonResponse)
		{
			location.reload();	
		};
		
	};

	DataCollectionDetails.prototype.handleDeleteFieldExtractResponse=function (response)
	{
		return function(jsonResponse)
		{
			location.reload();	
		};
		
	};
	
	$(document).ready(function() {
		var dataCollectionDetails=new DataCollectionDetails();
		dataCollectionDetails.initialize();
	});
	
	
