	//Manager class that has responsibility of coordinating actions.
	function AddFieldExtractDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.editMode=false;
		this.eventListener=eventListener;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 440,
				  minHeight:290,
				  resizable: false
			};
		$('#newFieldExtractDialogHolder').dialog(dialogOptions);
	}
	

	AddFieldExtractDialog.prototype.initialize=function ()
	{

	};

	AddFieldExtractDialog.prototype.setEditMode=function (val)
	{
		this.editMode=val;
	};

	
	AddFieldExtractDialog.prototype.hideDialog=function ()
	{
		$('#newFieldExtractDialogHolder').dialog('close');
	};
	
	AddFieldExtractDialog.prototype.showDialog=function (fieldId,dataCollectionId)
	{
		var addFieldExtractDialog=this;
		$("#newFieldExtractDialogHolder").html("");
		$("#newFieldExtractDialogHolder").load('/dialog/newFieldExtractionDialog.jsp?fieldId='+fieldId+'&dataCollectionId='+dataCollectionId, function() {
			$(this).dialog("option", "title","Add New Field Extract");
			$("#add_fieldExtr_dialog").click(addFieldExtractDialog.handleCreateFieldExtract(addFieldExtractDialog));
			$("#cancel_fieldExtr_dialog").click(addFieldExtractDialog.handleCancel(addFieldExtractDialog));
			
		});

		
		$('#newFieldExtractDialogHolder').dialog('open');
	};
		
	AddFieldExtractDialog.prototype.handleCreateFieldExtract=function (addFieldExtractDialog)
	{
		return function(event) {
			
			var dataCollectionId=$('#delete_data_collection').attr('value');
			var fieldName=$('#fieldName').val();
			var regEx=$('#regEx').val();
			var fieldId=$('#fieldId').val();
			var error=false;
			if(!fieldName.trim())
			{
				$('#fieldNameLab').css('color','red');
				error=true;
			}
			if(!regEx.trim())
			{
				$('#regExLab').css('color','red');
				error=true;
			}

			if(error)
			{
				return;
			}
			
			
			addFieldExtractDialog.hideDialog();
			if(addFieldExtractDialog.editMode==false)
			{
				addFieldExtractDialog.communicationsManager.createFieldExtract(fieldName,regEx,dataCollectionId,addFieldExtractDialog);
			}
			else
			{
				addFieldExtractDialog.communicationsManager.editFieldExtract(fieldId,fieldName,regEx,dataCollectionId,addFieldExtractDialog);
			}
			
			event.preventDefault();
		};
	};

	AddFieldExtractDialog.prototype.handleCancel=function (addFieldExtractDialog)
	{
		return function(event) {
			
			addFieldExtractDialog.hideDialog();
			event.preventDefault();
		};
	};

	
	AddFieldExtractDialog.prototype.handleAddFieldExtractResponse=function (addFieldExtractDialog)
	{
		return function(data)
		{
			location.reload();	
		};
		
		
	};


	AddFieldExtractDialog.prototype.handleEditFieldExtractResponse=function (addFieldExtractDialog)
	{
		return function(data)
		{
			location.reload();	
		};
		
		
	};

		