	//Manager class that has responsibility of coordinating actions.
	function ConfigureFieldForLogDialog(communicationsManager,dataManager)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=dataManager;
		
		//Calculate dialog height/width based on window height/width.
		   var wWidth = $(window).width();
	        var dWidth = wWidth * 0.8;
	        var wHeight = $(window).height();
	        var dHeight = wHeight * 0.7;
	        var configDialog=this;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  width:dWidth,
				  height: dHeight,
				  resizable: false,
				  title: 'Configure Data Collection',
				  close: function( event, ui ) {
					  configDialog.eventListener.handleConfigureDialogCloseEvent();
				  }
			};
		$('#configure_fields_dialog').dialog(dialogOptions);
		
		
		
	}
	
	
	
	ConfigureFieldForLogDialog.prototype.renderFields=function (fields,currentLogEntryIndex)
	{
		this.currentLogEntryIndex=currentLogEntryIndex;
		var configureFieldForDialog=this;
		$('#data_configuration').empty();
		if(fields)
		{
			$.each(fields,function(i,field)
					{
						var checked='checked="true"';
						var checkedClass='';
						if(field.selected==false)
							{
								checked='';
								checkedClass='holderUnselected';
							}
						var id='NEW';
						if(field.id)
						{
							id=field.id;
						}
						
						var finalHTML=configureFieldForDialog.getFieldRowHTML(field,checked,id,checkedClass,i);
						$('#data_configuration').append(finalHTML);
						
					});
			
			if(fields.length==0)
			{
				this.addNewField(this);
			}
		}else
		{
			this.addNewField(this);
		}
	};

	//Returns the HTML for a field row.
	ConfigureFieldForLogDialog.prototype.getFieldRowHTML=function (field,checked,id,checkedClass,i)
	{
		var fieldNameHTML='<td><input type="text" class="fieldInput" name="fieldName" value="'+field.fieldName+'"/></td>';
		var fieldRegexHTML='<td><input type="text" class="fieldInput" name="fieldRegex" value="'+field.fieldRegex+'"/></td>';
		var selectHTML='<td><input class="selectField" type="checkbox" '+checked+'" value="'+i+'"/></td>';
		var deleteHTML='<td><input  type="hidden" value="'+id+'"/><a href="" class="deleteField"><img src="/images/close2.jpg" class="deleteFieldImg" title="Remove"/></a></td>';
		var finalHTML='<tr id="configRow'+i+'" class="'+checkedClass+'">'+fieldNameHTML+fieldRegexHTML+selectHTML+deleteHTML+'</tr>';
		return finalHTML;
	}

	ConfigureFieldForLogDialog.prototype.initialize=function ()
	{
		$("#configure_next").button();
		$("#configure_add_field").button();
		
		$("#configure_next").click(this.handleNextButtonClick(this));
		$("#configure_add_field").click(this.handleAddFieldButtonClick(this));
		
		$("#configure_fields_dialog").on("click",".selectField",this.handleCheckBoxClick());
		$("#configure_fields_dialog").on("click",".deleteField",this.handleRemovefieldClick());
		
	};
	
	ConfigureFieldForLogDialog.prototype.hideDialog=function ()
	{
		$('#configure_fields_dialog').dialog('close');
	};
	
	ConfigureFieldForLogDialog.prototype.showDialog=function ()
	{
		$('#configure_fields_dialog').dialog('open');
	};

	
	
	ConfigureFieldForLogDialog.prototype.getSelectedFieldInfos=function (configureFieldForLogDialog)
	{
		var fields=new Array();
		$('tbody#data_configuration').find('tr').each(function() {
		   
			var fieldInfo=new Object();
			
			var inputs=$(this).find('input');
			
			var fieldName=$(inputs[0]).attr('value');
			var regex=$(inputs[1]).attr('value');
			var selected=$(inputs[2]).is(':checked');
			var id=$(inputs[3]).attr('value');
			fieldInfo.fieldName=fieldName;
			fieldInfo.fieldRegex=regex;
			fieldInfo.selected=selected;
			fieldInfo.id=id;
			
			if(selected==true && fieldName!=null && fieldName!='' && regex!=null && regex!='')
			{
					fields.push(fieldInfo);
			}
			
		});
		return fields;
	};
	
	ConfigureFieldForLogDialog.prototype.handleNextButtonClick=function (configureFieldForLogDialog)
	{
		return function(event) {
			event.preventDefault();

			//Save the fields for the log
			//configureFieldForLogDialog.setDataCollectionStateToHolder();
			var fieldInfos=configureFieldForLogDialog.getSelectedFieldInfos(configureFieldForLogDialog);
			configureFieldForLogDialog.eventListener.handleSaveFieldInfoEvent(fieldInfos,configureFieldForLogDialog.currentLogEntryIndex);
			configureFieldForLogDialog.hideDialog();
			//configureFieldForLogDialog.eventListener.handleAddToSearchEngine();
		};
	};
	
	
	ConfigureFieldForLogDialog.prototype.handleAddFieldButtonClick=function (configureFieldForLogDialog)
	{
		return function(event) {
			event.preventDefault();
			configureFieldForLogDialog.addNewField(configureFieldForLogDialog);
		};
	};

	
	ConfigureFieldForLogDialog.prototype.addNewField=function (configureFieldForLogDialog)
	{
			var newfield={
					fieldName:'',
					fieldRegex:''
			};
			var finalHTML=configureFieldForLogDialog.getFieldRowHTML(newfield,'checked="true"','NEW','',0);
			$('#data_configuration').prepend(finalHTML);
	};

	
	ConfigureFieldForLogDialog.prototype.handleCheckBoxClick=function ()
	{
		return function(event) {
			
			var selected=true;
			var holderIndex=$(this).attr("value");
			if ($(this).is(':checked')) {
				selected=true;
		    } else {
		    	selected=false;
		    }
			if(selected==true)
				{
					$('#configRow'+holderIndex).toggleClass("holderUnselected",false);
				}
			else
				{
					$('#configRow'+holderIndex).toggleClass("holderUnselected",true);
				}
		};
	};

	//Used to remove the table tr when a remove field button is clicked.
	ConfigureFieldForLogDialog.prototype.handleRemovefieldClick=function ()
	{
		return function(event) {
			$(this).parent().parent().remove();
		};
	};