	//Manager class that has responsibility of coordinating actions.
	function /**
	 * @author tingumr
	 *
	 */
	/**
	 * @author tingumr
	 *
	 */
	DataCollectionNameDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=eventListener;

		   var wWidth = $(window).width();
		   var dWidth = wWidth * 0.8;
	        var wHeight = $(window).height();
	        var dHeight = wHeight * 0.7;
	        
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: dWidth,
				  minHeight:dHeight,
				  resizable: false,
				  title:'Add to Search'
			};
		$('#data_collection_name_dialog').dialog(dialogOptions);
		
	}
	

	DataCollectionNameDialog.prototype.initialize=function ()
	{
		$("#dataCollection_add").button();
		$("#dataCollection_add").click(this.handleAddToSearchEngine(this));	

	};
	
	DataCollectionNameDialog.prototype.hideDialog=function ()
	{
		$('#data_collection_name_dialog').dialog('close');
	};
	
	DataCollectionNameDialog.prototype.showDialog=function ()
	{
		$('#data_collection_name_dialog').dialog('open');
	};
		
	DataCollectionNameDialog.prototype.renderResultData=function (resultData,dataCollectionNameDialog)
	{
		$('#data_collection').empty();		
		$.each(resultData.findStartPatternStateHolderList,function(i,holder)
				{
					var finalPattern=holder.getFinalPattern();
					var checked='checked="true"';
					var checkedClass='';
					if(holder.selected==false)
						{
							checked='';
							checkedClass='holderUnselected';
						}
					
					var deleteButtonHTML='<td><input class="selectDataFile" type="checkbox" '+checked+'" value="'+i+'"/></td>';
					
					var filePathHTML='<td class="filePath">'+holder.filePath+'</td>';
					var startPatternHTML='<td><input type="text" class="patternInput" value="'+finalPattern+'"/></td>';
					var validateButtonHTML='<td><button class="validateButton" value="'+i+'">Validate</button></td>';
					var dataCollectionHTML=dataCollectionNameDialog.getDataCollectionHTML(i,holder);
					//var configureButtonHTML='<td><button class="configureButton" value="'+i+'">Configure</button></td>';
					var configureButtonHTML='<td></td>';
					var finalHTML='<tr id="row'+i+'" class="'+checkedClass+'">'+deleteButtonHTML+filePathHTML+startPatternHTML+validateButtonHTML+dataCollectionHTML+configureButtonHTML+'</tr>';
					$('#data_collection').append(finalHTML);
					

					 
					$('#dataCollectionCombo'+i).combobox();
					//Set the dataCollectionValue on the hidden combo box input if saved.
					if(holder.dataCollectionValue != undefined)
						{
							$('#dataCollectionCombo'+i).combobox('value',holder.dataCollectionValue);
						}
					

				});
		
		//Unbind the event.
		$("#data_collection_name_dialog").off('click');
		$("#data_collection_name_dialog").on("click",".selectDataFile",this.handleCheckBoxClick(this));
		$(".validateButton").button();
		$("#data_collection_name_dialog").on("click",".validateButton",this.handleValidateButtonClick(this));
		
		$(".configureButton").button();
		$("#data_collection_name_dialog").on("click",".configureButton",this.handleConfigureButtonClick(this));
		

		
	};

	//Method that returns the HTML to be used for the data collection combo box.
	DataCollectionNameDialog.prototype.getDataCollectionHTML=function (i,holder)
	{
		var optionsHTML=$('#dataCollectionNameSelection').html();
		
		var dataCollectionHTML='<select id="dataCollectionCombo'+i+'">'+optionsHTML+'</select>';
		return '<td>'+dataCollectionHTML+'</td>';

	};
	
	DataCollectionNameDialog.prototype.handleValidateButtonClick=function (dataCollectionNameDialog)
	{

		
		return function(event) {
			event.preventDefault();
			//Save the state of patterns and data collection names to the holder object.
			dataCollectionNameDialog.setDataCollectionStateToHolder();
			
			var holderIndex=$(this).attr("value");
			dataCollectionNameDialog.eventListener.handleValidateButtonClickEvent(holderIndex);
			dataCollectionNameDialog.hideDialog();
		};
	};
	

	DataCollectionNameDialog.prototype.handleConfigureButtonClick=function (dataCollectionNameDialog)
	{

		
		return function(event) {
			event.preventDefault();

			//Save the state of patterns and data collection names to the holder object.
			dataCollectionNameDialog.setDataCollectionStateToHolder();
			
			var holderIndex=$(this).attr("value");
			dataCollectionNameDialog.eventListener.handleConfigureButtonClickEvent(holderIndex);
			dataCollectionNameDialog.hideDialog();
		};
	};
	
	
	DataCollectionNameDialog.prototype.setDataCollectionStateToHolder=function ()
	{
		var patterns=this.getAllPatterns();
		var dataCollectionInfoValues=this.getAllDataCollectionValues();
		//Save all the patterns in ResultData
		this.eventListener.setPatternsOnResultData(patterns);
		//Save all data collection names in ResultData 
		this.eventListener.setDataCollectionValuesOnResultData(dataCollectionInfoValues);
	};
	
	//Used to validate the data in the data collection dialog.
	DataCollectionNameDialog.prototype.validateDataCollectionForm=function ()
	{
		var dataCollectionInfoValues=this.getAllDataCollectionValues();
		//Check if for all selected log files, there is a non empty data collection name.
		var noValuesSelected=true;
		var nameNotSpecified=false;
		var dataCollectionNameDialog=this;
		$.each(dataCollectionInfoValues,function(i,dataCollectionInfo)
				{
					if(dataCollectionInfo.isSelected==true)
						{
							noValuesSelected=false;
						//This is a check for empty or null
							if(!dataCollectionInfo.selectedText)
								{
									if(!dataCollectionInfo.inputValue)
										{
											dataCollectionNameDialog.displayErrorMessage(globalMessages.getMessage('dataCollection_nameError'),7000);
											nameNotSpecified=true;
											//Note that this return only breaks the $.each loop.
											return false;
										}
								}
							
						}
				});
		
		//If a name has not been specified for the data collection.
		if(nameNotSpecified==true)
		{
			return false;
		}

		if(noValuesSelected==true)//No files selected for add to search.
			{
				dataCollectionNameDialog.displayErrorMessage(globalMessages.getMessage('dataCollection_noSel'),4000);
				return false;
			}
	};
	
	
	DataCollectionNameDialog.prototype.displayErrorMessage=function (message,fadeDelay)
	{
		$('#dataCollection_error').html('<span id="error_message" class="error">'+message+'</span>');
		$('#error_message').show().delay(fadeDelay).fadeOut();
	};
		
	
	DataCollectionNameDialog.prototype.handleAddToSearchEngine=function (dataCollectionNameDialog)
	{
		return function(event) {
			event.preventDefault();

			var result=dataCollectionNameDialog.validateDataCollectionForm();
			if(result==false)
				{
					return;
				}

			//Save the state of patterns and data collection names to the holder object.
			dataCollectionNameDialog.setDataCollectionStateToHolder();
			
			dataCollectionNameDialog.hideDialog();
			dataCollectionNameDialog.eventListener.handleAddToSearchEngine();
		};
	};
		
	
	
	DataCollectionNameDialog.prototype.handleCheckBoxClick=function (dataCollectionNameDialog)
	{
		
		return function(event) {
			
			var $this = $(this);
			var selected=true;
			var holderIndex=$(this).attr("value");
			if ($this.is(':checked')) {
				selected=true;
		    } else {
		    	selected=false;
		    }
			dataCollectionNameDialog.eventListener.handleCheckBoxClick(holderIndex,selected);
			
			
			if(selected==true)
				{
					$('#row'+holderIndex).toggleClass("holderUnselected",false);
				}
			else
				{
					$('#row'+holderIndex).toggleClass("holderUnselected",true);
				}
			
			
			
		};
	};
	DataCollectionNameDialog.prototype.getAllPatterns=function ()
	{
	    var patternInputs = $('.patternInput');

	    var values = [];
	    patternInputs.each(function(i,patternInput) {
	      values.push($(patternInput).val());
	    });
		return values;
	};
	
	//Component that gets selection state of DataCollections.
	DataCollectionNameDialog.prototype.getAllDataCollectionValues=function ()
	{
	    var dataCollectionNameInputs = $("[id^=dataCollectionCombo]");
	    
	    var values = [];
	    dataCollectionNameInputs.each(function(i,name) {
	    	var dataCollectionInfo=new Object();
	    	var dataCollectionSelectId=$('#dataCollectionCombo'+i+' :selected').val();
	    	var dataCollectionSelectedText=$('#dataCollectionCombo'+i+' :selected').text();
	    	
	    	//Find if the user has selected or unselected the row. This information is also present in DataManager.resultData.findStartPatternStateHolderList.
	    	//This info is found again here as it is required for validation.
	    	var rowSelectedClass=$('#row'+i).attr('class');
	    	var isSelected=true;
	    	if(rowSelectedClass=='holderUnselected')
	    		{
	    			isSelected=false;
	    		}
	    	
	    	dataCollectionInfo["isSelected"]=isSelected;
	    	dataCollectionInfo["selectedId"]=dataCollectionSelectId;
	    	dataCollectionInfo["selectedText"]=dataCollectionSelectedText;
	    	dataCollectionInfo["inputValue"]=$('#dataCollectionCombo'+i).combobox('value');
	    	if(dataCollectionInfo.inputValue!=dataCollectionSelectedText)
	    		{
	    			dataCollectionInfo["newDataCollection"]=true;
	    		}
	    	//Rest of the code has to understand the new dataCollectionInfo object.
	    	
	    	values.push(dataCollectionInfo);
	    });
		return values;
	};
	
