	//Manager class that has responsibility of coordinating actions.
	function ValidateStartPatternDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=eventListener;
		this.contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_validatePattern');
		this.displayContentDialog=new DisplayContentDialog();
		var initialText='Subject:Help with the Start Pattern\n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		this.lastDisplayedContent='';
		this.contactSupportDialog.setInitialText(initialText);
		//Calculate dialog height/width based on window height/width.
			   var wWidth = $(window).width();
		        var dWidth = wWidth * 0.95;
		        var wHeight = $(window).height();
		        var dHeight = wHeight * 0.94;
		
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  width:dWidth,
				  height: dHeight,
				  resizable: false,
				  title: 'Find Start Pattern'
			};
		$('#validate_start_pattern_dialog').dialog(dialogOptions);
		
		
	}
	

	ValidateStartPatternDialog.prototype.initialize=function ()
	{
		var validateStartPatternDialog=this;
		//Dependent on the combobox.js
		$("#patternSelection").combobox();
		
		$("#validate").button();
		$("#validate_next").button();
		$("#validate").click(this.handleValidateButtonClick(this));
		$("#validate_next").click(this.handleNextButtonClick(this));
		$('#contactSupport3').click(function(){
			var messageAddendum=validateStartPatternDialog.lastDisplayedContent;
			validateStartPatternDialog.contactSupportDialog.setMessageAddendum(messageAddendum);
			validateStartPatternDialog.contactSupportDialog.showDialog();
		});

		$('#patternHelp').click(function(){
			validateStartPatternDialog.displayContentDialog.setTitle('Pattern Help');
			validateStartPatternDialog.displayContentDialog.showDialog('/help/patternHelp.jsp');
		});
		
	};

	ValidateStartPatternDialog.prototype.setFindStartPatternResultHolder=function (resultHolder)
	{
		this.findStartPatternResultHolder=resultHolder;
		
		//Set the pattern
		//As the pattern is auto detected, no need to explicitly add it, for that reason the below line is commented.
		//$("#patternSelection").prepend("<option value='"+resultHolder.pattern.pattern+"'>"+resultHolder.pattern.pattern+"</option>");
		//http://jsfiddle.net/BbWza/442/
		$("#patternSelection").combobox('value',resultHolder.getFinalPattern());
	    //$('.ui-autocomplete-input').autocomplete('close');
		
		//Load content.
	    this.validateStartPattern(resultHolder.getFinalPattern(),resultHolder.filePath);
	};

	
	ValidateStartPatternDialog.prototype.hideDialog=function ()
	{
		$('#validate_start_pattern_dialog').dialog('close');
	};
	
	ValidateStartPatternDialog.prototype.showDialog=function ()
	{
		$('#validate_start_pattern_dialog').dialog('open');
	};

	//Method to validate the start pattern.
	ValidateStartPatternDialog.prototype.validateStartPattern=function (pattern,filePath)
	{
		this.communicationsManager.validateStartPattern(this,pattern,filePath);
		
	};

	//Handler for response to validate start pattern
	ValidateStartPatternDialog.prototype.handleValidateButtonClick=function (validateStartPatternDialog)
	{
		return function(event)
		{
			
			var pattern=$("#patternSelection").combobox('value');
			filePath=validateStartPatternDialog.findStartPatternResultHolder.filePath;
			validateStartPatternDialog.validateStartPattern(pattern,filePath);
		
		};
	};

	//Handler for response to validate start pattern
	ValidateStartPatternDialog.prototype.handleNextButtonClick=function (validateStartPatternDialog)
	{
		return function(event)
		{
			validateStartPatternDialog.hideDialog();
			var pattern=$("#patternSelection").combobox('value');
			validateStartPatternDialog.eventListener.handleValidateStartPatternDialogCompleteEvent(pattern,validateStartPatternDialog.findStartPatternResultHolder);
		
		};
	};

	
	//Handler for response to validate start pattern
	ValidateStartPatternDialog.prototype.handleValidateStartPatternResult=function (validateStartPatternDialog)
	{
		return function(data)
		{
			notifyUser("Message", data.message,2000, data.error);
			validateStartPatternDialog.displayValidateContentResult(data.startPatternState);
		};
	};
	
	ValidateStartPatternDialog.prototype.displayValidateContentResult=function (data)
	{
		var validateStartPatternDialog=this;
		$('#validate_start_pattern_content').empty();
		$('#validate_start_pattern_content').html('<div id="valPatternRes"><span class="valPattern"><b>Pattern=</b>'+data.findStartPatternStateHolderList[0].pattern+'</span><span class="valClass"><b>Parser=</b>'+data.findStartPatternStateHolderList[0].parserClass+'</span></div>');
		$.each(data.findStartPatternStateHolderList[0].matchedDataUnits,function(i,dataUnit)
				{
					$('#validate_start_pattern_content').append('<div class="pattern_result_entry">'+dataUnit.content+'</div>');
					validateStartPatternDialog.lastDisplayedContent+=dataUnit.content+'\n';
				});
	};
	
	

	//Handlers used for notification from contactSupportForm
	ValidateStartPatternDialog.prototype.handleValidationFailure=function(message)
	{
		this.eventListener.handleValidationFailure(message);
	};

	//Handlers used for notification from contactSupportForm	
	ValidateStartPatternDialog.prototype.handleSendingMessageNotification=function(message)
	{
		this.eventListener.handleSendingMessageNotification(message);
	};

	//Handlers used for notification from contactSupportForm
	ValidateStartPatternDialog.prototype.handleMessageSentNotificationSuccess=function(message)
	{
		notifyUser("Message", message, 3000,false);
		this.contactSupportDialog.hideDialog();
	};