function UserPermissionManager(listener)
{
	this.configuration={
			basicForm:true,
			basicPerm:true,
			permDC:true,
			basicPhone:true,
			basicLogin:true,
			basicLoginText:'Login',
			basicEmail:true,
			basicCompany:false
	};
	this.ufm=new UserFormManager(this);
	this.communicationManager=new CommunicationsManager();

	this.contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_userPermissions');
	
	var initialText='Subject:Help me with xyz. \n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
	this.lastDisplayedContent='';
	this.contactSupportDialog.setInitialText(initialText);

}

UserPermissionManager.prototype.initialize=function()
{
	var userPermissionManager=this;
	this.ufm.displayForm(null,this.configuration,'#userFormContainer');	
	$('#user_select').change(this.handleUserSelection(this));
	$('#create_user').click(this.handleCreateButtonClick(this));
	$('#delete_user').click(this.handleDeleteButtonClick(this));
	
	$('#contactSupport3').click(function(){
		userPermissionManager.contactSupportDialog.showDialog();
	});

	$('#goBackToAccount').button().click(function(){
		window.location='/user/my_account.jsp';
	});
	
	
};

UserPermissionManager.prototype.handleCreateButtonClick=function(userPermissionManager)
{
	return function(event)
	{
		
		var userId=$('#user_select').find("option:selected").attr("value");
		if(userId)
		{
			$('#user_select').find("option:selected").prop("selected",false);
		}
		userPermissionManager.configuration.readonlyLogin=false;
		userPermissionManager.ufm.displayForm(null,userPermissionManager.configuration,'#userFormContainer');
		//notifyUser("Create User", "Complete the form and submit", 3000, false);
	};
	
};


UserPermissionManager.prototype.handleCreateUserNotification=function(errorMessage,userJson,isError)
{
	if(isError==true)
	{
		notifyUser("Error", errorMessage, 6000, true);
	}
	else
	{
		var optionHTML='<option value="'+userJson.persistanceId+'">'+userJson.login+'</option>';
		if(userJson.permissions.admin==true)
		{
				optionHTML='<option value="'+userJson.persistanceId+'">'+userJson.login+'        admin</option>';
		}
		
		$('#user_select').prepend(optionHTML);
		notifyUser("Message",'User with login:'+userJson.login+' created.', 4000, false);
	}
};

UserPermissionManager.prototype.handleUpdateUserNotification=function(errorMessage,userJson,isError)
{
	if(isError==true)
	{
		notifyUser("Error", errorMessage, 6000, true);
	}
	else
	{
		notifyUser("Message",'User information updated.', 4000, false);
	}
};


UserPermissionManager.prototype.handleDeleteButtonClick=function(userPermissionManager)
{
	return function(event)
	{
		var userId=$('#user_select').find("option:selected").attr("value");
		if(userId)
		{
			userPermissionManager.communicationManager.deleteUser(userId,userPermissionManager);
		}else
		{
			notifyUser("Error", "Select user to delete.",3000,true);
		}
	};
	
};

UserPermissionManager.prototype.handleDeleteUserResponse=function(userId,userPermissionManager)
{
	return function(data)
	{
		if(data.error==true)
		{
			notifyUser("Error", data.message, 3000, true);
		}
		else
		{
			$('#user_select').find('option[value="'+userId+'"]').remove();
			if(userPermissionManager.ufm.getCurrentUserId()==userId)
			{
				userPermissionManager.ufm.displayForm(null,userPermissionManager.configuration,'#userFormContainer');
			}
			notifyUser("Message", 'User Deleted', 3000, false);
		}
	};
};




UserPermissionManager.prototype.handleUserSelection=function(userPermissionManager)
{
	return function(event)
	{
		var userId = $(this).find("option:selected").attr("value");
		userPermissionManager.configuration.readonlyLogin=true;
		userPermissionManager.ufm.displayForm(userId,userPermissionManager.configuration,'#userFormContainer');
	};
	
};

UserPermissionManager.prototype.handleUserFormErrorNotification=function(errorType)
{
	if(errorType=='errorValidatingFields')
	{
		notifyUser('Error', 'Error validating form.',3000, true);
	}
};


$(document).ready(function() {
	var userPermissionManager=new UserPermissionManager();
	userPermissionManager.initialize();
});

//Handlers used for notification from contactSupportForm
UserPermissionManager.prototype.handleValidationFailure=function(message)
{
	notifyUser("Error", message, 3000,true);
};

//Handlers used for notification from contactSupportForm	
UserPermissionManager.prototype.handleSendingMessageNotification=function(message)
{
	notifyUser("Message", message, 3000,false);
};

//Handlers used for notification from contactSupportForm
UserPermissionManager.prototype.handleMessageSentNotificationSuccess=function(message)
{
	notifyUser("Message", message, 5000,false);
	this.contactSupportDialog.hideDialog();
};