	function CustomPlanDialog(communicationsManager,eventListener)
	{
		this.communicationsManager=communicationsManager;
		this.eventListener=eventListener;
		var dialogOptions={
				modal: true,
				autoOpen:false,
				  height: 'auto',
				  minWidth: 800,
				  minHeight:280,
				  resizable: false
			};
		$('#customPlanDialog').dialog(dialogOptions);
	}
	


	CustomPlanDialog.prototype.initialize = function(maxEntries) {

	var customPlanDialog=this;
	var select1 = $("#dataPerDay");
	var slider1 = $("<div id='slider1'></div>").insertAfter(select1).slider({
		min : 1,
		max : maxEntries,
		range : "min",
		value : select1[0].selectedIndex + 1,
		slide : function(event, ui) {
			select1[0].selectedIndex = ui.value - 1;
			customPlanDialog.setPrice();
		}
	});
	
	$("#dataPerDay").change(function() {
		slider1.slider("value", this.selectedIndex + 1);
		customPlanDialog.setPrice();
	});

	var select2 = $("#retainPeriod");
	var slider2 = $("<div id='slider2'></div>").insertAfter(select2).slider({
		min : 1,
		max : maxEntries,
		range : "min",
		value : select2[0].selectedIndex + 1,
		slide : function(event, ui) {
			select2[0].selectedIndex = ui.value - 1;
			customPlanDialog.setPrice();
		}
	});

	$("#retainPeriod").change(function() {
		slider2.slider("value", this.selectedIndex + 1);
		customPlanDialog.setPrice();
	});

	$('#savePlan').button();
	$("#savePlan").click(this.handleSavePlan(this));	

	$('#cancel').button();
	$("#cancel").click(this.handleCancel(this));	

	
	// Change required to remove the X close button.
	$('#customPlanDialog').dialog({
		open : function() {
		}
	});

	customPlanDialog.setPrice();
};
	
	CustomPlanDialog.prototype.hideDialog=function ()
	{
		$('#customPlanDialog').dialog('close');
	};
	
	CustomPlanDialog.prototype.showDialog=function ()
	{
		$('#customPlanDialog').dialog('open');
	};
	
	
	CustomPlanDialog.prototype.handleSavePlan=function (customPlanDialog)
	{
		return function(event) {
			event.preventDefault();
			customPlanDialog.hideDialog();
			var dataPerDayOptionVal = $("#dataPerDay").val();
			var retainPeriodOptionVal = $("#retainPeriod").val();
			
			customPlanDialog.eventListener.handleSaveCustomPlan(dataPerDayOptionVal,retainPeriodOptionVal,customPlanDialog.eventListener);
			
		};
	};
	
	CustomPlanDialog.prototype.handleCancel=function (customPlanDialog)
	{
		return function(event) {
			event.preventDefault();
			customPlanDialog.hideDialog();
		};
	};
	
	//Method calculates and sets the price.
	CustomPlanDialog.prototype.setPrice=function ()
	{
		var dataPerDayOptionVal = parseInt($("#dataPerDay").val());
		var retainPeriodOptionVal = parseInt($("#retainPeriod").val());
		
		if(isNaN(dataPerDayOptionVal))
			{
				dataPerDayOptionVal=0;
			}
		if(isNaN(retainPeriodOptionVal))
			{
				retainPeriodOptionVal=0;
			}
		
		var price=this.eventListener.calculateListPrice(this.eventListener.customPlan.customPlans[dataPerDayOptionVal],this.eventListener.customPlan.customPlans[retainPeriodOptionVal]);
		
		$('#cust_price').html(price + '$');
	
	};