	function LoginFormManager(listener)
	{
		this.communicationsManager=new CommunicationsManager();
		this.configuration={
		};
		this.hasErrors=false;
		this.listener=listener;
	}


	LoginFormManager.prototype.initialize=function()
	{
	};


	LoginFormManager.prototype.displayForm=function(configuration,loadDivName)
	{
		if(configuration!=null)
		{
			this.configuration=configuration;
		}
		var dataToSend=jQuery.extend(true,{},this.configuration);
		var loginFormManager=this;
		$(loadDivName).html('');
		$.post('/user/loginForm.jsp',dataToSend,loginFormManager.handleLoadLoginFormDataResponse(loginFormManager,dataToSend,loadDivName));
		
	};

	LoginFormManager.prototype.handleLoadLoginFormDataResponse=function(loginFormManager,dataToSend,loadDivName)
	{
		return function(data)
		{
			$(loadDivName).html(data);
			$('#loginButton').button();
			$('#loginButton').unbind('click');
			$('#loginButton').click(loginFormManager.handleLoginButtonClick(loginFormManager));
		};
	};

	LoginFormManager.prototype.handleLoginUserResponse=function(loginFormManager)
	{
		return function(data)
		{
			if(data.error==true)
			{
					loginFormManager.listener.handleLoginUserErrorNotification(data.message,data.userJson,data.error);
			}
			else //If no errors add new option to the users list.
			{
				loginFormManager.listener.handleLoginUserSuccessNotification(data.message,data.userJson,data.error);
				window.location='/datapages/data.jsp';
			}
		};
	};


	
	LoginFormManager.prototype.handleLoginButtonClick=function(loginFormManager)
	{
		return function(event)
		{
			//Clear existing errors.
			$('.inputErrorLogin').html('');
			loginFormManager.hasErrors=false;
			var formValues=loginFormManager.getFormValues();
			loginFormManager.validateForm(formValues);
			if(loginFormManager.hasErrors==true)
			{
				if(loginFormManager.listener)
				{
					loginFormManager.listener.handleLoginUserFormErrorNotification('errorValidatingFields');
				}
			}
			else
			{
				var captchaResponse;
				if(typeof useCaptcha !== 'undefined' && useCaptcha==true)
				{
					captchaResponse=loginFormManager.listener.getCaptchaValue();	
				}
				
				//If there is a method canSubmitForm, check
				if(typeof loginFormManager.listener.canSubmitForm=='function')
				{
					if(loginFormManager.listener.canSubmitForm()==true)
					{
						loginFormManager.communicationsManager.loginUser(formValues,loginFormManager,captchaResponse);	
					}
				}
				else
				{
					loginFormManager.communicationsManager.loginUser(formValues,loginFormManager,captchaResponse);
				}
				
			}
		};
	};


	
	LoginFormManager.prototype.getFormValues=function()
	{
		var formValue=new Object();
		
			formValue.login=$('#loginLogin.basicInputLogin').val();

			formValue.password=$('#passwordLogin.basicInputLogin').val();
			
			return formValue;

	};

	
	LoginFormManager.prototype.validateForm=function(formValues)
	{
		
			
			if('login' in formValues)
			{
				if(formValues.login.trim().length<=0)
				{
					this.addErrorMessage('#loginLogin.basicInputLogin','Login is required.');	
				}
				else if(formValues.login.trim().length<4)
				{
					this.addErrorMessage('#loginLogin.basicInputLogin','Login can not be less than 4 characters.');	
				}
			}

			if(formValues.password.trim().length<=0)
			{
				this.addErrorMessage('#passwordLogin.basicInputLogin','Password is required.');
			}
			else if(formValues.password.trim().length<8)
			{
				this.addErrorMessage('#passwordLogin.basicInputLogin','Password length should be atleast 8.');
			}
		
	};
	
	
	LoginFormManager.prototype.addErrorMessage=function(field,message)
	{
		this.hasErrors=true;
		$(field).next().html(message);
	};
	
	