var seleniumErrorMessage=null;
//Manager class that has responsibility of coordinating actions.
	function LoginManager()
	{
		this.communicationsManager=new CommunicationsManager();
		this.configuration={
				basicForm:true,
				basicPerm:false,
				permDC:false,
				basicPhone:false,
				basicEmail:false,
				basicLoginText:'Email',
				basicLogin:true,
				validateLoginAsEmail:true,
				basicCompany:true,
				readonlyLogin:false,
				userRegistration:true,
				superUserPassword:false,
				submitButtonLabel:'Register'
		};
		
		this.configuration.superUserPassword=managedService;

		this.loginConfiguration={
		};
		
		this.ufm=new UserFormManager(this);
		this.forgotPasswordDialog=new ForgotPasswordDialog(this.communicationsManager,this);
		this.loginUserForm=new LoginFormManager(this);
		
		
		this.contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_loginRegister');
		
		var initialText='Subject:Help me with xyz. \n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		this.lastDisplayedContent='';
		this.contactSupportDialog.setInitialText(initialText);

		
	}
	
	
	LoginManager.prototype.canSubmitForm=function()
	{
		if(typeof useCaptcha !== 'undefined' && useCaptcha==true)
		{
			var captchaResponse=this.getCaptchaValue();
			if(!captchaResponse || captchaResponse.length<10)
			{
				notifyUser('Error', 'Check the "I am not a robot" box, it is a service from google to avoid evil bots.',5000, true,'show');	
				return false;
			}
		}
		return true;
	}
	
	LoginManager.prototype.getCaptchaValue=function()
	{
		var captchaResponse;
			captchaResponse=grecaptcha.getResponse();
		return captchaResponse;

	};


	LoginManager.prototype.initialize=function()
	{
		var loginManager=this;
		var currentUserId=$('#user_id_current').val();
		this.ufm.displayForm(currentUserId, this.configuration, '#userFormContainer');
		this.loginUserForm.displayForm(this.loginConfiguration, '#loginFormContainer');
		this.forgotPasswordDialog.initialize();
		$('body').on('click','#forgot_password_link',function(event){
			event.preventDefault();
			loginManager.forgotPasswordDialog.showDialog();
		});
		
		$('#contactSupport3').click(function(){
			loginManager.contactSupportDialog.showDialog();
		});
		
	};
	
	LoginManager.prototype.handleLoginUserErrorNotification=function(message,userJson,error)
	{
		if(message  && message=='emailNotPresent')
		{
			seleniumErrorMessage='emailNotPresent';
			notifyUser("Error", 'Could not find user with specified login.', 4000, error);
		}
		else if(message  && message=='passwordNoMatch')
		{
			seleniumErrorMessage='invalidPassword';
			notifyUser("Error", 'Invalid password.', 4000, error);
		}
		else
		{
			notifyUser("Error", message, 3000, error);	
		}
		grecaptcha.reset();
		
	};
	

	LoginManager.prototype.handleLoginUserFormErrorNotification=function(errorCode)
	{
		
	};


	LoginManager.prototype.handleLoginUserSuccessNotification=function(message,userJson,error)
	{
		$.removeCookie('addToReportId',{path: '/' });
	};

	
	LoginManager.prototype.handleUserFormErrorNotification=function(errorType)
	{
		if(errorType=='errorValidatingFields')
		{
			notifyUser('Error', 'Error validating form.',3000, true);
		}
	};
	
	LoginManager.prototype.handleCreateUserNotification=function(errorMessage,userJson,isError)
	{
		if(isError==true)
		{
			notifyUser("Error", errorMessage, 6000, true);
		}
		else
		{
			$.removeCookie('addToReportId',{path: '/' });
			window.location='/user/my_account.jsp';
		}
	};

	


	
	$(document).ready(function() {
		var loginManager=new LoginManager();
		loginManager.initialize();
	});
	
	//Handlers used for notification from contactSupportForm
	LoginManager.prototype.handleValidationFailure=function(message)
	{
		notifyUser("Error", message, 3000,true);
	};

	//Handlers used for notification from contactSupportForm	
	LoginManager.prototype.handleSendingMessageNotification=function(message)
	{
		notifyUser("Message", message, 3000,false);
	};

	//Handlers used for notification from contactSupportForm
	LoginManager.prototype.handleMessageSentNotificationSuccess=function(message)
	{
		notifyUser("Message", message, 5000,false);
		this.contactSupportDialog.hideDialog();
	};