	//Manager class that has responsibility of coordinating actions.
	function MyAccountManager()
	{
		this.communicationsManager=new CommunicationsManager();
		this.customPlanDialog=new CustomPlanDialog(this.communicationsManager, this);
		this.planDatas=null;
		this.customPlan=null;
		this.currentSelectedPlan=null;
		this.contactSupportForm=new ContactSupportForm(this);
		this.configuration={
				basicForm:true,
				basicPerm:false,
				permDC:false,
				basicPhone:true,
				basicEmail:true,
				basicLogin:true,
				basicLoginText:'Login',
				basicCompany:true,
				readonlyLogin:true
		};
		
		this.contactSupportConfig={
				displayHeading:true,
				displayFromBox:true
		};
		this.ufm=new UserFormManager(this);

	}

	MyAccountManager.prototype.handleUserFormErrorNotification=function(errorType)
	{
		if(errorType=='errorValidatingFields')
		{
			notifyUser('Error', 'Error validating form.',3000, true);
		}
	};
	
	
	MyAccountManager.prototype.handleUpdateUserNotification=function(errorMessage,userJson,isError)
	{
		if(isError==true)
		{
			notifyUser("Error", errorMessage, 6000, true);
		}
		else
		{
			notifyUser("Message",'User information updated.', 4000, false);
		}
	};

	
	
	MyAccountManager.prototype.initialize=function()
	{
		//Load plan data for the page.
		this.communicationsManager.getPlanData(this);
		$("#changeplanbutton").button();
		$("#changeplanbutton").click(this.handleChangePlanClick(this));
		
		
		$('#admin_user_permission').button(
		{
			icons:{primary:'ui-icon-person'}
		}		
		);
		$('#admin_user_permission').click(function(){
			window.location='/user/user_and_permissions.jsp';	
		});
		$('#admin_datacollection_permission').button();
		
		var currentUserId=$('#user_id_current').val();
		this.ufm.displayForm(currentUserId, this.configuration, '#userFormContainer');
		
		var initialText='Subject:Help me with xyz. \n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		this.contactSupportForm.displayContactSupportForm('#contactSupportContainer', this.contactSupportConfig,null,initialText);
		
		$('.authTokenHelp').click(function(){
			notifyUser("Message", $(this).attr("title"), 6000, false);
		});

		$('#admin_page').button(
				{
					icons:{primary:'ui-icon-gear'}
				}		
			).click(function(){
				
				window.location='/admin/admin.jsp';
			});

	};

	
	MyAccountManager.prototype.handleGetPlanDataResponse=function ()
	{
		var myAccountManager=this;
		
		return function(jsonResponse)
		{
			myAccountManager.planDatas=jsonResponse.planDataJsons;
			if(typeof jsonResponse.customPlan !='undefined')
			{
				myAccountManager.customPlan=jsonResponse.customPlan;	
			}
			
			var planDataHTML=myAccountManager.getPlanDataHTML(jsonResponse.currentPlan,"currentPlan",false,false);
			$('#mycurrentplan').append(planDataHTML);	
			
			for ( var int = 0; int < jsonResponse.planDataJsons.length; int++) {
				//Skip the planData for anonymous user. anonymousUser variable is set in the staticIncluces_js.jsp
				if(jsonResponse.planDataJsons[int].planId=='freeAnonymous' && anonymousUser==false)
					{

					}
				else
					{
						var planDataHTML='';
						if(jsonResponse.planDataJsons[int].planId=='dedicatedBox')
							{
							//Show dedicated services only if not managed service.
								if(managedService==false)
								{
									planDataHTML=myAccountManager.getPlanDataDedicatedBoxHTML(jsonResponse.planDataJsons[int],jsonResponse.planDataJsons[int].planId);	
								}
								
							}
						else
							{
								if(managedService==false)
								{
									//Do not display custom plan from non managed service.
									if(jsonResponse.planDataJsons[int].planId!='custom')
									{
										planDataHTML=myAccountManager.getPlanDataHTML(jsonResponse.planDataJsons[int],jsonResponse.planDataJsons[int].planId,true,false);
									}
									else
									{
										continue;
									}
								}
								else //For managed service, only display custom plan.
								{
									if(jsonResponse.planDataJsons[int].planId=='custom')
									{
										planDataHTML=myAccountManager.getPlanDataHTML(jsonResponse.planDataJsons[int],jsonResponse.planDataJsons[int].planId,true,false);	
									}
								}
								
							}
						$('#availableplans').append(planDataHTML);	
					}
				
				
			}

			if(typeof jsonResponse.customPlan !='undefined')
				{
					//Initialize the customPlanDialog, after custom plans are loaded.
					myAccountManager.customPlanDialog.initialize(jsonResponse.customPlan.customPlans.length);

					//Initialize the custom plan select boxes.
					var customPlans=jsonResponse.customPlan.customPlans;
					for ( var int2 = 0; int2 < customPlans.length; int2++) {
						$('#dataPerDay').append('<option value="'+int2+'">'+customPlans[int2].metaData.uploadLimitPerDay+'</option>');
						$('#retainPeriod').append('<option value="'+int2+'">'+customPlans[int2].metaData.retainDays+'</option>');
					}

					$(document).on('click','#customPlanButton',function(event){
						event.preventDefault();
						myAccountManager.customPlanDialog.showDialog();
					});

				}
			
			//Handle radio button selection
			$(document).on('change',"input[type='radio']",function () {
				var selection=$(this).val();
				
				myAccountManager.currentSelectedPlan=selection;
				if(selection=='custom')
					{
						myAccountManager.customPlanDialog.showDialog();					
					}
			
			});
			
			
			
			
			
		};
	};
	
	
	$(document).ready(function() {
		var myAccountManager=new MyAccountManager();
		myAccountManager.initialize();
	});

	MyAccountManager.prototype.getPlanDataHTML=function(planData,id,displayRadio,radioChecked)
	{
		
		var radio='<input type="radio" name="planId" value="'+planData.planId+'" id="rad_'+planData.planId+'"/>';
		if(radioChecked)
		{
			radio='<input type="radio" name="planId" checked="true" value="'+planData.planId+'" id="rad_'+planData.planId+'" disabled/>';
		}
		
		if(displayRadio==false)
			{
				radio='';
			}
		
		var planName=planData.planName;
		var customPlanChangeHTML='';
		if(id=="custom")
		{
				customPlanChangeHTML='<a href="" id="customPlanButton">modify</a>';
		}
		var priceHTML='';
		//Do not display price for managed service.
		if(managedService==false)
		{
			priceHTML='<div class="planCost">'+planData.listPrice+' $</div>';
		}
		
		var planDataHTML='<div class="planData" id="'+id+'">'+
			'<div class="planRadio">'+
			radio+
			'</div>'+
			'<div class="planName">'+planName+customPlanChangeHTML+'</div>'+
			'<div class="planDetails"><span class="uploadLimit">'+planData.metaData.uploadLimitPerDay+'</span> per day , retain for <span class="retainDays">'+planData.metaData.retainDays+'</span></div>'+
			priceHTML+
			'</div>';
		
			return planDataHTML;
	};


	MyAccountManager.prototype.getPlanDataDedicatedBoxHTML=function(planData,id)
	{
		
		var radio='<input type="radio" name="planId" value="'+planData.planId+'" id="rad_'+planData.planId+'" disabled/>';
		
		var planName=planData.planName;
		
		var planDataHTML='<div class="planData" id="'+id+'">'+
			'<div class="planRadio">'+
			radio+
			'</div>'+
			'<div class="planName">'+planName+'</div>'+
			'<div class="planDetails">Dedicated box on the cloud or on premisis, contact  <a href="/support" class="generalLink" id="contact_support">support</a> for details. License cost starting at $100 a month.</span></div>'+
			'</div>';
		
			return planDataHTML;
	};

	
	//Event generated when the save button is clicked on the savePlan dialog to save a custom plan.
	MyAccountManager.prototype.handleSaveCustomPlan=function (dataPerDayOptionVal,retainPeriodOptionVal,myAccountManager)
	{
		var customPlanData=myAccountManager.getPlanWithId(myAccountManager.planDatas,'custom');
		//Save maxLimitBytes and retaindays.
		
		customPlanData.maxIndexLimitBytes=myAccountManager.customPlan.customPlans[parseInt(dataPerDayOptionVal)].maxIndexLimitBytes;
		customPlanData.maxRetainLimitHours=myAccountManager.customPlan.customPlans[parseInt(retainPeriodOptionVal)].maxRetainLimitHours;

		//Save the rates.
		customPlanData.ratePerMegabyteUpload=myAccountManager.customPlan.customPlans[parseInt(dataPerDayOptionVal)].ratePerMegabyteUpload;
		customPlanData.ratePerRetainHour=myAccountManager.customPlan.customPlans[parseInt(retainPeriodOptionVal)].ratePerRetainHour;
		
		//Calculate the new list price based on custom values selected.
		customPlanData.listPrice=myAccountManager.calculateListPrice(customPlanData,customPlanData);
		//Save the labels.
		customPlanData.metaData.uploadLimitPerDay=myAccountManager.customPlan.customPlans[parseInt(dataPerDayOptionVal)].metaData.uploadLimitPerDay;
		customPlanData.metaData.retainDays=myAccountManager.customPlan.customPlans[parseInt(retainPeriodOptionVal)].metaData.retainDays;

		var customPlanHTML=myAccountManager.getPlanDataHTML(customPlanData,customPlanData.planId,true,true);
		
		$('#custom').replaceWith(customPlanHTML);

		//This is required because the currentSelectedPlan is to set if the dialog is triggered by the custom link.
		var selection=$('#rad_custom').val();
		myAccountManager.currentSelectedPlan=selection;
		notifyUser("Message",'Click "Change Plan" button to change the current plan.', 3000,false);
	};
	
	//Calculate the listPrice for planData
	MyAccountManager.prototype.calculateListPrice=function (planDataUpload,planDataRetain)
	{
		
		
		var rateForUpload=parseFloat(planDataUpload.ratePerMegabyteUpload)*(parseInt(planDataUpload.maxIndexLimitBytes)/(1024*1024));
		var rateForRetain=parseFloat(planDataRetain.ratePerRetainHour)*parseInt(planDataRetain.maxRetainLimitHours);
		var listPriceInCents=rateForUpload+rateForRetain;
		//Return result in dollars.
		console.log(planDataUpload.ratePerMegabyteUpload+' '+planDataUpload.maxIndexLimitBytes+' '+planDataRetain.ratePerRetainHour+' '+planDataRetain.maxRetainLimitHours);
		console.log('price:'+Math.round(listPriceInCents/100));
		return Math.round(listPriceInCents/100); 
	};

	
	MyAccountManager.prototype.getPlanWithId=function (planDatas,planId)
	{
		for ( var int = 0; int < planDatas.length; int++) {
			
			if(planDatas[int].planId==planId)
				{
					return planDatas[int];
				}
		}
		return null;
	};
	
	//Called when user clicks change plan button
	MyAccountManager.prototype.handleChangePlanClick=function ()
	{
		var myAccountManager=this;
		return function(event) {
			if(myAccountManager.currentSelectedPlan)
			{
				var planData=myAccountManager.getPlanWithId(myAccountManager.planDatas, myAccountManager.currentSelectedPlan);	
				myAccountManager.communicationsManager.changePlanRequest(planData,myAccountManager);
			}
			else
			{
				notifyUser("Message", "Plan not selected", 3000, true);
			}
			
			
		};
		
	};
	
	//Response from changePlan request
	MyAccountManager.prototype.handleChangePlanResponse=function ()
	{
		return function(jsonResponse)
		{
			if(jsonResponse.error==false)
				{
					location.reload();
				}
			else
				{
					alert('Error changing plan, contact support.');
				}
			
		};
	};
	
	
	//Handlers used for notification from contactSupportForm
	MyAccountManager.prototype.handleValidationFailure=function(message)
	{
		notifyUser("Error", message, 3000,true);
	};

	//Handlers used for notification from contactSupportForm	
	MyAccountManager.prototype.handleSendingMessageNotification=function(message)
	{
		notifyUser("Message", message, 3000,false);
	};

	//Handlers used for notification from contactSupportForm
	MyAccountManager.prototype.handleMessageSentNotificationSuccess=function(message)
	{
		notifyUser("Message", message, 5000,false);
		this.contactSupportForm.displayContactSupportForm('#support_container1', this.configuration,null,this.initialText);
	};
	