var seleniumErrorMessage=null;
function UserFormManager(listener)
	{
		this.communicationsManager=new CommunicationsManager();
		this.configuration={
				basicForm:true,
				basicPerm:true,
				permDC:true,
				basicPhone:true,
				basicLogin:true,
				basicCompany:false
				
		};
		this.userId=null;
		this.hasErrors=false;
		this.listener=listener;
	}


	UserFormManager.prototype.getCurrentUserId=function()
	{
		return this.userId;
	};

	
	UserFormManager.prototype.initialize=function()
	{
	};


	UserFormManager.prototype.displayForm=function(userId,configuration,loadDivName)
	{
		this.userId=userId;
		if(configuration!=null)
		{
			this.configuration=configuration;
		}
		var dataToSend=jQuery.extend(true,{},this.configuration);
		if(userId!=null)
		{
			dataToSend.userId=userId;	
		}
		var userFormManager=this;
		$(loadDivName).html('');
		$.post('/user/newUserForm.jsp',dataToSend,userFormManager.handleLoadFormDataResponse(userFormManager,dataToSend,loadDivName));
		
	};

	UserFormManager.prototype.handleLoadFormDataResponse=function(userFormManager,dataToSend,loadDivName)
	{
		return function(data)
		{
			$(loadDivName).html(data);
			$('#basicSubmitButtonCreate').button();
			$('#basicSubmitButtonUpdate').button();
			
			$('#basicSubmitButtonCreate').unbind('click');
			$('#basicSubmitButtonUpdate').unbind('click');
			$('.addRemButton').unbind('click');
			
			$('#basicSubmitButtonCreate').click(userFormManager.handleSubmitButtonClickCreate(userFormManager));
			$('#basicSubmitButtonUpdate').click(userFormManager.handleSubmitButtonClickUpdate(userFormManager));
			$('.addRemButton').click(userFormManager.handleAddRemoveFromSelectClick(userFormManager));
			
			
		};
	};

	UserFormManager.prototype.handleCreateUserResponse=function(userFormManager)
	{
		return function(data)
		{
			if(data.error==true)
			{
				if(data.errorCode && data.errorCode=='emailExists')
				{
					seleniumErrorMessage='emailExists';
					userFormManager.listener.handleCreateUserNotification('Error Creating User',data.userJson,data.error);
					
					userFormManager.addErrorMessage('#login.basicInput',data.message);
				}
				else
				{
					seleniumErrorMessage='error';
					userFormManager.listener.handleCreateUserNotification(data.message,data.userJson,data.error);
				}
			}
			else //If no errors add new option to the users list.
			{
				userFormManager.listener.handleCreateUserNotification(data.message,data.userJson,data.error);
				userFormManager.configuration.readonlyLogin=true;
				userFormManager.displayForm(data.userJson.persistanceId, userFormManager.configuration, '#userFormContainer');
			}
		};
	};

	UserFormManager.prototype.handleUpdateUserResponse=function(userFormManager)
	{
		return function(data)
		{
			userFormManager.listener.handleUpdateUserNotification(data.message,data.userJson,data.error);
			if(data.error==false)
			{
					userFormManager.displayForm(data.userJson.persistanceId, userFormManager.configuration, '#userFormContainer');	
			}
			
		};
	};

	
	UserFormManager.prototype.handleAddRemoveFromSelectClick=function(userFormManager)
	{
		return function(event)
		{
			var id=$(this).attr('id');
			
			if(id=='basicButtonAddAll')
			{
				var optionsHTML=$('#availableDC').html();
				$('#assignedDC').append(optionsHTML);
				$('#availableDC').html('');
			}
			else if(id=='basicButtonRemoveAll')
			{
				var optionsHTML=$('#assignedDC').html();
				$('#assignedDC').html('');
				$('#availableDC').append(optionsHTML);
			}
			else if(id=='basicButtonAdd')
			{
				$('#availableDC option:selected').each(function(){
					
					var outherHTML=$("<div/>").append($(this).clone()).html();
					console.log(outherHTML);
					$('#assignedDC').append(outherHTML);
					$(this).remove();
				});
			}
			else if(id=='basicButtonRemove')
			{
				$('#assignedDC option:selected').each(function(){
					
					var outherHTML=$("<div/>").append($(this).clone()).html();
					$('#availableDC').append(outherHTML);
					$(this).remove();
				});
			}

		};
	};
	
	
	UserFormManager.prototype.handleSubmitButtonClickCreate=function(userFormManager)
	{
		return function(event)
		{
			//Clear existing errors.
			$('.inputError').html('');
			userFormManager.hasErrors=false;
			var formValues=userFormManager.getFormValues();
			userFormManager.validateForm(formValues);
			if(userFormManager.hasErrors==true)
			{
				if(userFormManager.listener)
				{
					userFormManager.listener.handleUserFormErrorNotification('errorValidatingFields');
				}
			}
			else
			{
				
				var captchaResponse;
				if(typeof useCaptcha !== 'undefined' && useCaptcha==true)
				{
					captchaResponse=userFormManager.listener.getCaptchaValue();	
				}
				
				//If there is a method canSubmitForm, check
				if(typeof userFormManager.listener.canSubmitForm=='function')
				{
					if(userFormManager.listener.canSubmitForm()==true)
					{
						userFormManager.communicationsManager.createUser(formValues,userFormManager,captchaResponse);	
					}
				}
				else
				{
					userFormManager.communicationsManager.createUser(formValues,userFormManager,captchaResponse);
				}
			}
		};
	};

	UserFormManager.prototype.handleSubmitButtonClickUpdate=function(userFormManager)
	{
		return function(event)
		{
		
			//Clear existing errors.
			$('.inputError').html('');
			userFormManager.hasErrors=false;
			var formValues=userFormManager.getFormValues();
			userFormManager.validateForm(formValues);
			if(userFormManager.hasErrors==true)
			{
				if(userFormManager.listener)
				{
					userFormManager.listener.handleUserFormErrorNotification('errorValidatingFields');
				}
			}
			else
			{
				userFormManager.communicationsManager.updateUser(formValues,userFormManager);
			}
		};
	};
	
	UserFormManager.prototype.getFormValues=function()
	{
		var formValue=new Object();
		formValue.basicInfo=false;
		formValue.permBasicInfo=false;
		formValue.permDCInfo=false;
		if(this.userId!=null)
		{
			formValue.userId=this.userId;
		}
		
		if(this.configuration.userRegistration)
		{
			formValue.userRegistration=this.configuration.userRegistration;
		}
		
		if($('#basicInfo').length>0)
		{
			formValue.basicInfo=true;
			formValue.firstName=$('#firstname.basicInput').val();	
			
			formValue.lastName=$('#lastname.basicInput').val();
			if($('#login.basicInput').length>0)
			{
				formValue.login=$('#login.basicInput').val();
			}

			if($('#email.basicInput').length>0)
			{
				formValue.email=$('#email.basicInput').val();
			}
			formValue.password=$('#password.basicInput').val();
			formValue.company=$('#company.basicInput').val();
			
			if($('#suPassword').length>0)
			{
				formValue.suPassword=$('#suPassword').val();
			}
			if($('#phone.basicInput').length>0)
			{
				formValue.phone=$('#phone.basicInput').val();	
			}
		}

		if($('#permBasicInfo').length>0)
		{
			formValue.permBasicInfo=true;
			formValue.admin=$('#adminUser.basicInputCheck').is(':checked');
			formValue.addRemoveData=$('#addRemoveData.basicInputCheck').is(':checked');
			formValue.provideAccessToNewDataCollections=$('#accessNewDC.basicInputCheck').is(':checked');
		}

		if($('#permDCInfo').length>0)
		{
			formValue.permDCInfo=true;
			formValue.assignedDCValues=this.getAllSelectBoxValues('#assignedDC option');
			//This is so that the POST works fine, without this value for assingedDCValues is null.
			formValue.assignedDCValues=JSON.stringify(formValue.assignedDCValues);
		}
		return formValue;

	};
	
	
	UserFormManager.prototype.getAllSelectBoxValues=function(selectId)
	{
		var assignedDCs=[];
		assignedDCs=$(selectId).map(function(i,n){
			return $(n).val();
		}).get();
		return assignedDCs;
	};
	
	UserFormManager.prototype.validateForm=function(formValues)
	{
		
		if(formValues.basicInfo==true)
		{
			
			if(formValues.firstName.trim().length<=0)
			{
				this.addErrorMessage('#firstname.basicInput','First name is required.');
			}
			if(formValues.lastName.trim().length<=0)
			{
				this.addErrorMessage('#lastname.basicInput','Last name is required.');
			}
			if('login' in formValues)
			{
				if(formValues.login.trim().length<=0)
				{
					this.addErrorMessage('#login.basicInput','Login is required.');	
				}
				else if(formValues.login.trim().length<4)
				{
					this.addErrorMessage('#login.basicInput','Login can not be less than 4 characters.');	
				}
				else if (this.configuration.validateLoginAsEmail==true)
				{
					if(isEmail(formValues.login)==false)
					{
						this.addErrorMessage('#login.basicInput','Email entered is not valid.');
					}
				}
			}
			if('email' in formValues)
			{
				if(formValues.email.trim().length<=0)
				{
					this.addErrorMessage('#email.basicInput','Email is required.');
				}
				else if(isEmail(formValues.email)==false)
				{
					this.addErrorMessage('#email.basicInput','Email entered is not valid.');
				}
			}
			if(formValues.password.trim().length<=0)
			{
				this.addErrorMessage('#password.basicInput','Password is required.');
			}
			else if(formValues.password.trim().length<8)
			{
				this.addErrorMessage('#password.basicInput','Password length should be atleast 8.');
			}

			if('phone' in formValues)
			{
				if(formValues.phone.trim().length > 0)
				{
//					var regex=/^\+?([0-9]{2})\)?[-. ]?([0-9]{4})[-. ]?([0-9]{4})$/;
//					if(regex.test(formValues.phone.trim())==false)
//					{
//						console.log('phoneTest:'+regex.test(formValues.phone.trim()));
//						this.addErrorMessage('#phone.basicInput','Phone number entered is not valid.');
//					}
				}
				
			}
			
			
		}
		
	};
	
	UserFormManager.prototype.addErrorMessage=function(field,message)
	{
		this.hasErrors=true;
		$(field).next().html(message);
	};
	
	