	//Manager class that has responsibility of coordinating actions.
	function PricingPageUtil()
	{
		this.communicationsManager=new CommunicationsManager();
		this.planDatas=null;
		this.customPlan=null;
		this.currentSelectedPlan=null;

		this.initialText='Subject:Plan \n\nSuggestions,Questions,Report Bug etc\n\n\n\n\n\n\n\nPhone(Optional):';
		this.contactSupportDialog=new ContactSupportFormDialog(this.communicationManager,this,'_loginRegister');
		this.contactSupportDialog.setInitialText(this.initialText);
	}

	
	PricingPageUtil.prototype.initialize=function()
	{
		//Load plan data for the page.
		this.communicationsManager.getPlanData(this);
		var pricingPageutil=this;
		
		$('#contactSupport3').click(function(){
			pricingPageutil.contactSupportDialog.showDialog();
		});

	};

	
	PricingPageUtil.prototype.handleGetPlanDataResponse=function ()
	{
		var pricingPageUtil=this;
		
		return function(jsonResponse)
		{
			pricingPageUtil.planDatas=jsonResponse.planDataJsons;
			pricingPageUtil.customPlan=jsonResponse.customPlan;
			
			for ( var int = 0; int < jsonResponse.planDataJsons.length; int++) {
				//Skip the planData for anonymous user. anonymousUser variable is set in the staticIncluces_js.jsp
				if(jsonResponse.planDataJsons[int].planId=='freeAnonymous')
					{

					}
				else
					{
						var planDataHTML='';
						if(jsonResponse.planDataJsons[int].planId=='dedicatedBox')
							{
								planDataHTML=pricingPageUtil.getPlanDataDedicatedBoxHTML(jsonResponse.planDataJsons[int],jsonResponse.planDataJsons[int].planId);
								
							}
						else
							{
								planDataHTML=pricingPageUtil.getPlanDataHTML(jsonResponse.planDataJsons[int],jsonResponse.planDataJsons[int].planId,false,false);
							}
						$('#availableplans').append(planDataHTML);	
					}
				
				
			}

		};
	};
	
	
	$(document).ready(function() {
		var pricingPageUtil=new PricingPageUtil();
		pricingPageUtil.initialize();
	});

	PricingPageUtil.prototype.getPlanDataHTML=function(planData,id,displayRadio,radioChecked)
	{
		
		var radio='<input type="radio" name="planId" value="'+planData.planId+'" id="rad_'+planData.planId+'" />';
		if(radioChecked)
		{
			radio='<input type="radio" name="planId" checked="true" value="'+planData.planId+'" id="rad_'+planData.planId+'" />';
		}
		
		if(displayRadio==false)
			{
				radio='';
			}
		
		var planName=planData.planName;
		var planDataHTML='';
		if(id=="custom")
		{
			 planDataHTML='<div class="planData" id="'+id+'">'+
				'<div class="planName">'+planName+'</div>'+
				'<div class="planDetails"><a href="/user/login_register" class="generalLink">Register</a> to create a tailor made plan.</div>'+
				'</div>';
		}else
		{
			 planDataHTML='<div class="planData" id="'+id+'">'+
				'<div class="planRadio">'+
				radio+
				'</div>'+
				'<div class="planName">'+planName+'</div>'+
				'<div class="planDetails"><span class="uploadLimit">'+planData.metaData.uploadLimitPerDay+'</span> per day , retain for <span class="retainDays">'+planData.metaData.retainDays+'</span></div>'+
				'<div class="planCost">'+planData.listPrice+' $</div>'+
				'</div>';			
		}
		

		
			return planDataHTML;
	};


	PricingPageUtil.prototype.getPlanDataDedicatedBoxHTML=function(planData,id)
	{
		
		
		var planName=planData.planName;
		
		var planDataHTML='<div class="planData" id="'+id+'">'+
			'<div class="planName">'+planName+'</div>'+
			'<div class="planDetails">Dedicated box on the cloud or on premisis, contact  <a href="/support" class="generalLink" id="contact_support">support</a> for details. License cost starting at $100 a month.</span></div>'+
			'</div>';
		
			return planDataHTML;
	};


	
	//Calculate the listPrice for planData
	PricingPageUtil.prototype.calculateListPrice=function (planDataUpload,planDataRetain)
	{
		
		
		var rateForUpload=parseFloat(planDataUpload.ratePerMegabyteUpload)*(parseInt(planDataUpload.maxIndexLimitBytes)/(1024*1024));
		var rateForRetain=parseFloat(planDataRetain.ratePerRetainHour)*parseInt(planDataRetain.maxRetainLimitHours);
		var listPriceInCents=rateForUpload+rateForRetain;
		//Return result in dollars.
		console.log(planDataUpload.ratePerMegabyteUpload+' '+planDataUpload.maxIndexLimitBytes+' '+planDataRetain.ratePerRetainHour+' '+planDataRetain.maxRetainLimitHours);
		console.log('price:'+Math.round(listPriceInCents/100));
		return Math.round(listPriceInCents/100); 
	};

	
	PricingPageUtil.prototype.getPlanWithId=function (planDatas,planId)
	{
		for ( var int = 0; int < planDatas.length; int++) {
			
			if(planDatas[int].planId==planId)
				{
					return planDatas[int];
				}
		}
		return null;
	};
		
	//Handlers used for notification from contactSupportForm
	PricingPageUtil.prototype.handleValidationFailure=function(message)
	{
		notifyUser("Error", message, 3000,true);
	};

	//Handlers used for notification from contactSupportForm	
	PricingPageUtil.prototype.handleSendingMessageNotification=function(message)
	{
		notifyUser("Message", message, 3000,false);
	};

	//Handlers used for notification from contactSupportForm
	PricingPageUtil.prototype.handleMessageSentNotificationSuccess=function(message)
	{
		notifyUser("Message", message, 5000,false);
		this.contactSupportForm.displayContactSupportForm('#support_container1', this.configuration,null,this.initialText);
	};
