	function ContactSupportForm(listener,id)
	{
		this.communicationsManager=new CommunicationsManager();
		this.configuration={
				displayHeading:false,
				displayFromBox:false
		};
		this.listener=listener;
		this.messageAddendum=null;
		this.initialText='';
		//The id is used to distingush between forms where a page might have multiple contact support forms.
		this.id=id;
	}

	ContactSupportForm.prototype.initialize=function()
	{

	};

	ContactSupportForm.prototype.displayContactSupportForm=function(loadDivName,configuration,messageAddendum,initialText)
	{
		if(initialText)
			{
				this.initialText=initialText;
			}
		
		if(configuration!=null && configuration)
		{
			this.configuration=configuration;
		}
		if(messageAddendum)
			{
				this.messageAddendum=messageAddendum;
			}
		
		var dataToSend=jQuery.extend(true,{},this.configuration);
		$(loadDivName).html('');
		$.post('/support/supportForm.jsp?formId='+this.id,dataToSend,this.handleLoadFormDataResponse(this,dataToSend,loadDivName));
	};
	
	ContactSupportForm.prototype.handleLoadFormDataResponse=function(contactSupportForm,dataToSend,loadDivName)
	{
		return function(data)
		{
			$(loadDivName).html(data);
			$('#sendMessageButton'+contactSupportForm.id).unbind('click');
			$('#sendMessageButton'+contactSupportForm.id).button({
				icons:{primary:'ui-icon-mail-closed'}
			}).click(contactSupportForm.handleSubmitButtonClick(contactSupportForm));
			
			
			
			$("#emailMessageTextArea"+contactSupportForm.id).val(contactSupportForm.initialText);
		};
	};
	
	
	ContactSupportForm.prototype.handleSendMessageToSupportResponse=function(contactSupportForm)
	{
		return function(data)
		{
			if(data.error==true)
			{
				contactSupportForm.listener.handleValidationFailure(data.message);
			
			}
			else
			{
				contactSupportForm.listener.handleMessageSentNotificationSuccess(data.message);
			}
		};		
	};
	ContactSupportForm.prototype.handleSubmitButtonClick=function(contactSupportForm)
	{
		return function(event)
		{	
				event.preventDefault();
				var email=$("#fromEmailText"+contactSupportForm.id).val();
				if(!isEmail(email))
				{
					contactSupportForm.listener.handleValidationFailure('Email entered is not valid.');
				}
				else
				{
					var message=$("#emailMessageTextArea"+contactSupportForm.id).val();
					
					if(message.trim().length==0 || message==contactSupportForm.initialText)
					{
							contactSupportForm.listener.handleValidationFailure('Message is empty, not sending.');
					}
					else
						{
							var data={};
							data.email=email;
							data.message=message;
							data.test=false;
							if(contactSupportForm.messageAddendum)
							{
								data.messageAddendum=contactSupportForm.messageAddendum;
							}
							contactSupportForm.communicationsManager.sendMessageToSupport(data,contactSupportForm);
							contactSupportForm.listener.handleSendingMessageNotification('Sending Message');
						}
				}
		};
	};