<%@page import="com.rigabyte.data.index.http.SearchIndexPageUtils"%>
<%@page import="com.rigabyte.http.user.node.json.UserJson"%>
<%@page import="com.rigabyte.data.user.client.UserManagerClient"%>
<%@ taglib uri="http://jawr.net/tags" prefix="jwr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="data" uri="dataTags"%>
<%@page import="com.rigabyte.http.SearchUserState"%>
<%@page import="com.rigabyte.data.util.IndexUtil"%>
<%//Used to initialize the user and organization for the current session.	
UserManagerClient.initializeUser(request,response);
boolean redirected=UserManagerClient.redirectIfRequiredIfUserAnonymous(request, response);
if(redirected)
{
	return;
}
		
	UserJson user=UserManagerClient.getCurrentUser(request,true);
	pageContext.setAttribute("user",user);
	Boolean displayPopup=SearchIndexPageUtils.displayInfoPopup(request,response);
	//displayPopup=Boolean.TRUE;
	pageContext.setAttribute("displayPopup",displayPopup);
	
	SearchUserState state=IndexUtil.getSearchUserState(request);
	
	
%>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>RigaByte - Search, Analyze, Store and Compare logs, CPU, memory, IO data.</title>
<meta name="description" content="Search, analyze, store and compare any event data like log files, CPU usage data, memory usage data etc. Supports dashboards and reports."/>

<jsp:include page="/common/staticIncludes_css.jsp" />
<jwr:style src="/jawr/search.css"/>
<jsp:include page="/common/staticIncludes_js.jsp" />
<jsp:include page="/common/smoothPageLoad.jsp"/>

<%--The userMessage variable is set in the SearchRequestHandler --%>
<c:if test="${not empty requestScope.userMessage}">
	<script type="text/javascript">
		var userMessage="${requestScope.userMessage}";
	</script>
</c:if>

</head>
<body>
	<jsp:include page="/common/globalNavigation.jsp">
		<jsp:param value="search" name="menu"/>
	</jsp:include>


	<%
		//If keyword is null, set it to an empty string.
		String keyword=request.getParameter("keyword");
		if(keyword==null)
		{
			keyword="";
		}
	%>
<c:if test="${user.anonymousUser == true && displayPopup == true}">
	<jsp:include page="homePageInfoDialog.jsp" />
</c:if>



	<div id="searchInputBlock">
		<form name="search_form" action="/chart/" id="search_form" method="get">
			<label for="search_input" id="search_input_label">Search:</label>
			<input type="text" name="keyword" id="search_input" value="<%=keyword%>" maxlength="256" autocomplete="off"></input>
			<input type="hidden" name="action" value="search" id="srch_action"></input> 
			<input type="hidden" name="index" value="indexId" id="srch_index"></input>
			<input type="hidden" name="startDate" id="srch_startDate" value="0" maxlength="24"></input>
			<input type="hidden" name="endDate"  id="srch_endDate" value="0" maxlength="24"></input>
			<input type="hidden" name="startDateMillis" id="srch_startDate_millis" value="0"></input>
			<input type="hidden" name="endDateMillis"  id="srch_endDate_millis" value="0"></input>
			<input type="hidden" name="xAxisDataType"  id="xAxisDataType" value=""></input>
			<input type="hidden" name="dataSourceInfoId" value="" id="dataSourceInfoId"></input>
			<input type="hidden" name="chartDataIndex"  id="srch_drillDown_chartDataIndex" value="null"></input>
			<input type="hidden" name="requestCount"  id="requestCount" value="0"></input>
			<input type="hidden" name="successURL" value="/"></input>
			<input type="submit" name="search_submit" id="search_submit" value="GO"></input>
			<button type="submit" id="more_options"></button>
		</form>
	</div>
	<div id="searchOptions">
		<jsp:include page="searchOptions.jsp" />
	</div>

	<div id="chartAndSearchHistory">
			<div id="searchHistoryBox">
				<div id="searchHistoryHeader"><span class="searchHistoryTitle">Previous Searches and Samples</span><span id="searchHistoryClose"></span></div>
				<div id="searchHistoryContent"></div>
			</div>
			<div id="chart" class="chart">
			</div>
	</div>
	
	<div style="position:relative; width:500px; height: 0px;margin:auto;top: -260px;">
		<span id="chartLogo"></span>	
	</div>
	<jsp:include page="drilldownIndicator.jsp" />
	<div id="searches" class="searches"></div>
	<div class="gigantic pagination" id="pagination1">
	    <a href="#" class="first" data-action="first">&laquo;</a>
	    <a href="#" class="previous" data-action="previous">&lsaquo;</a>
	    <input type="text" readonly="readonly" />
	    <a href="#" class="next" data-action="next">&rsaquo;</a>
	    <a href="#" class="last" data-action="last">&raquo;</a>
	</div>
	<div id="buttonList">
	<span id="chartInfoButtonList">
		<span id="closeAllBut" class="menubox menuBoxBig" title="Close all but currently selected search"></span>
		<span id="hideAllBut" class="menubox menuBoxBig" title="Hide all but currently selected search"></span>
		<span id="showAll" class="menubox menuBoxBig" title="Show all searches."></span>
	</span>
	<span id="logDataButtonList">
		<span id="moreLogInfo" class="moreLogInfoc menubox menuBoxBig" title="Display extra information for log entries."></span>
		<span id="swatch11" class="menubox menuBoxBig"  title="Flag data and save flagged state."><input name="swatch1" type="hidden" value="#E0F2F7"/></span>
		<span id="swatch21" class="menubox menuBoxBig" title="Flag data and save flagged state."><input name="swatch2" type="hidden" value="#E0F8E0"/></span>
		<span id="swatch31" class="menubox menuBoxBig" title="Flag data and save flagged state."><input name="swatch3" type="hidden" value="#F8E0E0"/></span>
		<span id="swatch41" class="menubox menuBoxBig" title="Clear Flags"><input name="swatch4" type="hidden" value="#FFFFFF"/></span>
		<span id="flaggedButtonList">
			<span id="flagged21"  class="menubox menuBoxBig" title="View all flagged entries."><span id="flaggedText21"><%=state.getFlaggedLogEntrySet().size()%></span></span>
			<span id="flaggedClear21"  class="menubox menuBoxBig" title="Clear flagged entries."></span>
		</span>
		<span id="save21" class="menubox menuBoxBig" title="Save to Report"></span>	
		<span id="close21" class="menubox menuBoxBig" title="Clear related results if present."></span>
		<span id="tail21"  class="menubox menuBoxBig tail21" title="Tail data matching current search."></span>
		<span id="tailButtonList">
			<span id="tailpause21"  class="menubox menuBoxBig tailpause21" title="Pause"></span>
			<span id="tailplay21"  class="menubox menuBoxBig tailplay21" title="Play"></span>
			<span id="tailclear21"  class="menubox menuBoxBig tailclear21" title="Clear tail data."></span>
		</span>
		<span id="download21"  class="menubox menuBoxBig" title="Download current entries on page."></span>
		<span id="help21"  class="menubox menuBoxBig" title="Help with menu."></span>
	</span>
	</div>
	<div id="logDataSpinnerContainer"><span class="logDataSpinner">Loading...</span></div>		
	<div id="logData"></div>
	<div class="gigantic pagination" id="pagination2">
	    <a href="#" class="first" data-action="first">&laquo;</a>
	    <a href="#" class="previous" data-action="previous">&lsaquo;</a>
	    <input type="text" readonly="readonly" />
	    <a href="#" class="next" data-action="next">&rsaquo;</a>
	    <a href="#" class="last" data-action="last">&raquo;</a>
	</div>
	<div id="addToDashboard">
	</div>
	<!-- Used for addLogEntryToReportDialog. -->
	<div id="addLogEntryToReport">
	</div>
	<jsp:include page="/search/logDataEntryMenu.jsp" />
	<jsp:include page="/search/searchDropdownMenu.jsp" />
	<jsp:include page="/search/searchOptionsMenu.jsp" />
	<jwr:script src="/jawr/search.js"/>
	
	<div id="contactSupportContainer_dialog">
	</div>	
	<div id="addNewDataCollectionDialog">
	</div>
	<%--Form used to implement download functionality for log data. --%>
	<form name="download_form" action="/chart/" id="download_form" method="post">
		<input type="hidden" name="action" value="downloadLogEntries"/>
		<input type="hidden" name="downloadType" value="entries"/>
		<input type="hidden" name="json" value="" id="download_json"/>
	</form>

<data:cloud>
	<jsp:include page="/common/chatApplication.jsp"></jsp:include>
</data:cloud>
</body>
</html>
