<%@page import="com.rigabyte.data.util.Configuration"%>
<%@page import="java.util.ArrayList"%>
<%@page import="com.rigabyte.http.user.node.json.DataSourceInfoJson"%>
<%@page import="com.rigabyte.http.handler.SearchRequestHandler"%>
<%@page import="com.rigabyte.http.SearchUserState"%>
<%@page import="com.rigabyte.http.user.node.client.UserNodeServiceClient"%>
<%@page import="com.rigabyte.data.util.IndexUtil"%>
<%@page import="com.rigabyte.http.user.node.json.UserJson"%>
<%@page import="com.rigabyte.http.user.AccessRistrictionUtil"%>
<%@page import="com.rigabyte.http.user.node.json.SearchIndexJson"%>
<%@page import="com.rigabyte.data.index.client.SearchIndexManagerClient"%>
<%@page import="com.rigabyte.data.user.client.UserManagerClient"%>
<%@page import="com.rigabyte.http.user.node.json.OrganizationJson"%>
<%@page import="com.rigabyte.data.searchoptions.http.XAxisDataType"%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@page import="java.util.List"%>
<%@page import="java.util.Date"%>
<%


Configuration configuration=Configuration.getInstance();
SearchUserState state=IndexUtil.getSearchUserState(request);

UserJson user=UserManagerClient.getCurrentUser(request,true);
//Replace this to get information about the last 10 or 5 indexes.
OrganizationJson currentOrganization=UserManagerClient.getCurrentOrganization(request,false);

String searchHistoryJson=UserNodeServiceClient.getSearchHistoryJsonString(currentOrganization.getId(),user);
pageContext.setAttribute("searchHistoryJson",searchHistoryJson);


List<SearchIndexJson> searchIndexes=AccessRistrictionUtil.getSearchIndexesForUser(user,currentOrganization);
String lastSelectedIndexId=state.getLastSearchedIndex();
pageContext.setAttribute("searchIndexes",searchIndexes);
pageContext.setAttribute("lastSelectedIndexId",lastSelectedIndexId);

String startDate=(String)request.getAttribute("optionsStartDate");
SearchIndexManagerClient indexManagerClient=SearchIndexManagerClient.getInstance();
SearchRequestHandler handler=(SearchRequestHandler)SearchRequestHandler.getInstance();
if(startDate==null)
{
	handler.initializeSearchOptionDates(request,searchIndexes);
}


//If the page is requested for the first time, do a initial search with empty string and date from the newest index. Also check to make sure there is no result data already present.
String keyword=request.getParameter("keyword");
		
String requestCountStr=request.getParameter("requestCount");
int requestCount=0;
if(requestCountStr!=null)
{
	 requestCount=IndexUtil.getRequestCount(request);
}

		
if(keyword==null && searchIndexes!=null && !searchIndexes.isEmpty() && !state.isResultResultDataPresent(requestCount))
{
	OrganizationJson indexOrganizationJson=indexManagerClient.getOrganizationJsonForIndex(request, searchIndexes.get(0).getId(),true);
	
	String startDateInMillis=IndexUtil.getFormattedSearchOptionsDateInMillis((String)request.getAttribute("optionsStartDate"));
	String endDateInMillis=IndexUtil.getFormattedSearchOptionsDateInMillis((String)request.getAttribute("optionsEndDate"));
	
	 if(handler.isUseDefaultDate(startDateInMillis,endDateInMillis))
	 {
		 		
				String[] lastShardStartDateAndEndDate = handler.getDefaultStartAndEndDateToUse(state, searchIndexes.get(0).getId(),indexOrganizationJson);
				startDateInMillis=lastShardStartDateAndEndDate[0];
				endDateInMillis=lastShardStartDateAndEndDate[1];
	 }
	 
	
	long startDateLong=0;
	long endDateLong=0;
	try
	{
		startDateLong=Long.parseLong(startDateInMillis);
		endDateLong=Long.parseLong(endDateInMillis);
	}
	catch(Exception e)
	{
		startDateLong=-1;
		endDateLong=-1;
	}
	
	//This is used to adjust the end date to make end date inclusive.
	long resolution=configuration.getResolutionInMilliseconds();

	
	String formattedStartDate=IndexUtil.getFormattedSearchOptionsDateFromMillis(startDateInMillis);
	String formattedEndDate=IndexUtil.getFormattedSearchOptionsDateFromMillis(endDateInMillis);
	handler.setRequestAttributes(request, formattedStartDate, formattedEndDate, startDateInMillis, endDateInMillis);
	long adjustedEndLong=endDateLong;
	XAxisDataType dataType=IndexUtil.getXAxisDataTypeForIndex(searchIndexes.get(0),request,startDateLong,adjustedEndLong);
	if(dataType.equals(XAxisDataType.DATE))
	{
		adjustedEndLong=endDateLong+10000; //Add 10 seconds.
	}
	
	//Below search is performed only if the index is the sample index an no previous searches are present.(this check is done above.)
	handler.doInitialSearchForSampleIndex(state, "" , searchIndexes.get(0), request.getSession().getId(), startDateLong, adjustedEndLong,null,request);
}

//Following code is used to populate the data source select box.
String dataSourceId=request.getParameter("dataSourceInfoId");
String searchIndexId=lastSelectedIndexId;
List<DataSourceInfoJson> dataSourceInfos=new ArrayList<DataSourceInfoJson>();
pageContext.setAttribute("dataSourceInfos",dataSourceInfos);


//Set the dataSourceInfos.
if(searchIndexes!=null && !searchIndexes.isEmpty())
{
	if(searchIndexId==null || searchIndexId.trim().length()==0)
	{
		//If search indexId is null, use the first search index in the list.
		searchIndexId=searchIndexes.get(0).getId();
	}
	SearchIndexJson lastSelectedIndex=indexManagerClient.getSearchIndex(searchIndexId,request,true);
	if(lastSelectedIndex!=null)
	{
		dataSourceInfos=lastSelectedIndex.getDataSourceInfoList();	

		if(!dataSourceInfos.isEmpty())
		{
			pageContext.setAttribute("dataSourceInfos",dataSourceInfos);
			pageContext.setAttribute("dataSourceInfoId",dataSourceId);
		}
	}
}

%>

	<%--Set the tailRequested javascript variable and then reset its value. --%>
	<script type="text/javascript">
		var tailRequested="<%=state.isTailRequested()%>";
		var searchHistoryJson=${searchHistoryJson};
	</script>
	<%
		state.setTailRequested(false);
	%>
	
	
	<form name="search_options_form" action="/data/" id="search_options_form" method="get">
		<%-- optoinsStartDate, optionsEndDate set in the CompareSearchRequestHandler. --%>
		<label class="search_options_label" for="srch_startDate_opt">Data:</label>
		<select name="indexOpt" id="srch_index_opt">
			<c:forEach items="${searchIndexes}" var="searchIndex">
			 	<c:choose>
			 		<c:when test="${lastSelectedIndexId!=null && lastSelectedIndexId == searchIndex.id}">
			 			<option value="<c:out value="${searchIndex.id}"/>" selected="selected"><c:out value="${searchIndex.name}"/></option>
			 		</c:when>
			 		<c:otherwise>
			 			<option value="<c:out value="${searchIndex.id}"/>"><c:out value="${searchIndex.name}"/></option>
			 		</c:otherwise>
			 	</c:choose>
			 </c:forEach>
		</select>
		<label class="search_options_label"  id="startNumLabel" for="srch_startDate_opt"></label><input type="text" name="startDateOpt" id="srch_startDate_opt" value="<%=request.getAttribute("optionsStartDate")%>"></input>
		<label class="search_options_label" id="endNumLabel"  for="srch_endDate_opt"></label><input type="text" name="endDateOpt"  id="srch_endDate_opt" value="<%=request.getAttribute("optionsEndDate")%>"></input>
		<input type="hidden" name="startDateOpt" id="srch_startDateMillis_opt" value="<%=request.getAttribute("optionsStartDateInMillis")%>"></input>
		<input type="hidden" name="startDateOpt" id="srch_endDateMillis_opt" value="<%=request.getAttribute("optionsEndDateInMillis")%>"></input>
		<input type="hidden" name="xAxisDataTypeOpt" id="xAxisDataTypeOpt"/>
		<span id="searchOptMenuButton"></span>
		<c:if test="${dataSourceInfos!=null}">
			<label class="search_options_label" for="srch_startDate_opt"  id="data_source_info_label">Source:</label>
			<select name="dataSourceInfos" id="data_source_infos" multiple="multiple" style="width:190px;">
				<c:forEach items="${dataSourceInfos}" var="dataSourceInfo">
				 	<c:choose>
				 		<c:when test="${dataSourceInfoId!=null && dataSourceInfoId == dataSourceInfo.id}">
				 			<option value="<c:out value="${dataSourceInfo.id}"/>" selected="selected"><c:out value="${dataSourceInfo.name}"/></option>
				 		</c:when>
				 		<c:otherwise>
				 			<option value="<c:out value="${dataSourceInfo.id}"/>"><c:out value="${dataSourceInfo.name}"/></option>
				 		</c:otherwise>
				 	</c:choose>
				 </c:forEach>
			</select>
		</c:if>
		<span id="searchCheetSheet" title="Search cheat sheet."></span>
	</form>
		